/**
 * @author  Hyperandroid  ||  http://hyperandroid.com/
 *
 * Library namespace.
 * CAAT stands for: Canvas Advanced Animation Tookit.
 */

/**
 * @license
 * 
 * The MIT License
 * Copyright (c) 2010-2011 Ibon Tolosana, Hyperandroid || http://labs.hyperandroid.com/

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:

 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

var CAAT=CAAT||{};Function.prototype.bind=function(){var b=this;var a=Array.prototype.slice.call(arguments);var c=a.shift();return function(){return b.apply(c,a.concat(Array.prototype.slice.call(arguments)))}};(function(){CAAT.Behavior=function(){this.lifecycleListenerList=[];this.setDefaultInterpolator();return this};CAAT.Behavior.prototype={lifecycleListenerList:null,behaviorStartTime:-1,behaviorDuration:-1,cycleBehavior:false,expired:true,interpolator:null,actor:null,id:0,setId:function(a){this.id=a;return this},setDefaultInterpolator:function(){this.interpolator=new CAAT.Interpolator().createLinearInterpolator(false);return this},setPingPong:function(){this.interpolator=new CAAT.Interpolator().createLinearInterpolator(true);return this},setFrameTime:function(a,b){this.behaviorStartTime=a;this.behaviorDuration=b;this.expired=false;return this},setOutOfFrameTime:function(){this.expired=true;this.behaviorStartTime=Number.MAX_VALUE;this.behaviorDuration=0;return this},setInterpolator:function(a){this.interpolator=a;return this},apply:function(c,b){var a=c;if(this.isBehaviorInTime(c,b)){c=this.normalizeTime(c);this.fireBehaviorAppliedEvent(b,a,c,this.setForTime(c,b))}},setCycle:function(a){this.cycleBehavior=a;return this},addListener:function(a){this.lifecycleListenerList.push(a);return this},emptyListenerList:function(){this.lifecycleListenerList=[];return this},getStartTime:function(){return this.behaviorStartTime},getDuration:function(){return this.behaviorDuration},isBehaviorInTime:function(b,a){if(this.expired||this.behaviorStartTime<0){return false}if(this.cycleBehavior){if(b>=this.behaviorStartTime){b=(b-this.behaviorStartTime)%this.behaviorDuration+this.behaviorStartTime}}if(b>this.behaviorStartTime+this.behaviorDuration){if(!this.expired){this.setExpired(a,b)}return false}return this.behaviorStartTime<=b&&b<this.behaviorStartTime+this.behaviorDuration},fireBehaviorExpiredEvent:function(b,c){for(var a=0;a<this.lifecycleListenerList.length;a++){this.lifecycleListenerList[a].behaviorExpired(this,c,b)}},fireBehaviorAppliedEvent:function(c,e,a,d){for(var b=0;b<this.lifecycleListenerList.length;b++){if(this.lifecycleListenerList[b].behaviorApplied){this.lifecycleListenerList[b].behaviorApplied(this,e,a,c,d)}}},normalizeTime:function(a){a=a-this.behaviorStartTime;if(this.cycleBehavior){a%=this.behaviorDuration}return this.interpolator.getPosition(a/this.behaviorDuration).y},setExpired:function(a,b){this.expired=true;this.setForTime(this.interpolator.getPosition(1).y,a);this.fireBehaviorExpiredEvent(a,b)},setForTime:function(b,a){},initialize:function(b){if(b){for(var a in b){this[a]=b[a]}}return this}}})();(function(){CAAT.ContainerBehavior=function(){CAAT.ContainerBehavior.superclass.constructor.call(this);this.behaviors=[];return this};CAAT.ContainerBehavior.prototype={behaviors:null,addBehavior:function(a){this.behaviors.push(a);a.addListener(this);return this},apply:function(c,b){if(this.isBehaviorInTime(c,b)){c-=this.getStartTime();if(this.cycleBehavior){c%=this.getDuration()}for(var a=0;a<this.behaviors.length;a++){this.behaviors[a].apply(c,b)}}},setInterpolator:function(a){return this},behaviorExpired:function(b,c,a){if(this.cycleBehavior){b.expired=false}},setForTime:function(c,b){for(var a=0;a<this.behaviors.length;a++){this.behaviors[a].setForTime(c,b)}return null}};extend(CAAT.ContainerBehavior,CAAT.Behavior,null)})();(function(){CAAT.RotateBehavior=function(){CAAT.RotateBehavior.superclass.constructor.call(this);this.anchor=CAAT.Actor.prototype.ANCHOR_CENTER;return this};CAAT.RotateBehavior.prototype={startAngle:0,endAngle:0,anchorX:0.5,anchorY:0.5,setForTime:function(b,a){var c=this.startAngle+b*(this.endAngle-this.startAngle);a.setRotationAnchored(c,this.anchorX*a.width,this.anchorY*a.height);return c},setValues:function(d,c,b,a){this.startAngle=d;this.endAngle=c;if(b!==undefined&&a!==undefined){this.anchorX=b/100;this.anchorY=a/100}return this},setAngles:function(b,a){return this.setValues(b,a)},setAnchor:function(a,c,b){this.anchorX=c/a.width;this.anchorY=b/a.height;return this}};extend(CAAT.RotateBehavior,CAAT.Behavior,null)})();(function(){CAAT.GenericBehavior=function(){CAAT.GenericBehavior.superclass.constructor.call(this);return this};CAAT.GenericBehavior.prototype={start:0,end:0,target:null,property:null,callback:null,setForTime:function(c,a){var b=this.start+c*(this.end-this.start);if(this.callback){this.callback(b,this.target,a)}if(this.property){this.target[this.property]=b}},setValues:function(e,a,c,b,d){this.start=e;this.end=a;this.target=c;this.property=b;this.callback=d;return this}};extend(CAAT.GenericBehavior,CAAT.Behavior,null)})();(function(){CAAT.ScaleBehavior=function(){CAAT.ScaleBehavior.superclass.constructor.call(this);this.anchor=CAAT.Actor.prototype.ANCHOR_CENTER;return this};CAAT.ScaleBehavior.prototype={startScaleX:0,endScaleX:0,startScaleY:0,endScaleY:0,anchorX:0.5,anchorY:0.5,setForTime:function(d,c){var b=this.startScaleX+d*(this.endScaleX-this.startScaleX);var a=this.startScaleY+d*(this.endScaleY-this.startScaleY);if(0===b){b=0.01}if(0===a){a=0.01}c.setScaleAnchored(b,a,this.anchorX*c.width,this.anchorY*c.height);return{scaleX:b,scaleY:a}},setValues:function(d,f,b,e,c,a){this.startScaleX=d;this.endScaleX=f;this.startScaleY=b;this.endScaleY=e;if(c!==undefined&&a!==undefined&&c!==null&&a!==null){this.anchorX=c/100;this.anchorY=a/100}return this},setAnchor:function(b,a,c){this.anchorX=a/b.width;this.anchorY=c/b.height;return this}};extend(CAAT.ScaleBehavior,CAAT.Behavior,null)})();(function(){CAAT.AlphaBehavior=function(){CAAT.AlphaBehavior.superclass.constructor.call(this);return this};CAAT.AlphaBehavior.prototype={startAlpha:0,endAlpha:0,setForTime:function(c,a){var b=(this.startAlpha+c*(this.endAlpha-this.startAlpha));a.setAlpha(b);return b},setValues:function(b,a){this.startAlpha=b;this.endAlpha=a;return this}};extend(CAAT.AlphaBehavior,CAAT.Behavior,null)})();(function(){CAAT.PathBehavior=function(){CAAT.PathBehavior.superclass.constructor.call(this);return this};CAAT.PathBehavior.autorotate={LEFT_TO_RIGHT:0,RIGHT_TO_LEFT:1,FREE:2};CAAT.PathBehavior.prototype={path:null,autoRotate:false,prevX:-1,prevY:-1,autoRotateOp:CAAT.PathBehavior.autorotate.FREE,translateX:0,translateY:0,setAutoRotate:function(b,a){this.autoRotate=b;if(a!==undefined){this.autoRotateOp=a}return this},setPath:function(a){this.path=a;return this},setValues:function(a){return this.setPath(a)},setFrameTime:function(a,b){CAAT.PathBehavior.superclass.setFrameTime.call(this,a,b);this.prevX=-1;this.prevY=-1;return this},setTranslation:function(b,a){this.translateX=b;this.translateY=a;return this},setForTime:function(f,c){if(!this.path){return{x:c.x,y:c.y}}var a=this.path.getPosition(f);if(this.autoRotate){if(-1===this.prevX&&-1===this.prevY){this.prevX=a.x;this.prevY=a.y}var e=a.x-this.prevX;var d=a.y-this.prevY;if(e===0&&d===0){c.setLocation(a.x-this.translateX,a.y-this.translateY);return{x:c.x,y:c.y}}var g=Math.atan2(d,e);if(this.autoRotateOp===CAAT.PathBehavior.autorotate.LEFT_TO_RIGHT){if(this.prevX<=a.x){c.setImageTransformation(CAAT.SpriteImage.prototype.TR_NONE)}else{c.setImageTransformation(CAAT.SpriteImage.prototype.TR_FLIP_HORIZONTAL);g+=Math.PI}}else{if(this.autoRotateOp===CAAT.PathBehavior.autorotate.RIGHT_TO_LEFT){if(this.prevX<=a.x){c.setImageTransformation(CAAT.SpriteImage.prototype.TR_FLIP_HORIZONTAL)}else{c.setImageTransformation(CAAT.SpriteImage.prototype.TR_NONE);g-=Math.PI}}}c.setRotation(g);this.prevX=a.x;this.prevY=a.y;var b=Math.sqrt(e*e+d*d);e/=b;d/=b}c.setLocation(a.x-this.translateX,a.y-this.translateY);return{x:c.x,y:c.y}},positionOnTime:function(a){if(this.isBehaviorInTime(a,null)){a=this.normalizeTime(a);return this.path.getPosition(a)}return{x:-1,y:-1}}};extend(CAAT.PathBehavior,CAAT.Behavior,null)})();(function(){CAAT.BrowserDetect=function(){this.init();return this};CAAT.BrowserDetect.prototype={browser:"",version:0,OS:"",init:function(){this.browser=this.searchString(this.dataBrowser)||"An unknown browser";this.version=this.searchVersion(navigator.userAgent)||this.searchVersion(navigator.appVersion)||"an unknown version";this.OS=this.searchString(this.dataOS)||"an unknown OS"},searchString:function(d){for(var a=0;a<d.length;a++){var b=d[a].string;var c=d[a].prop;this.versionSearchString=d[a].versionSearch||d[a].identity;if(b){if(b.indexOf(d[a].subString)!==-1){return d[a].identity}}else{if(c){return d[a].identity}}}},searchVersion:function(b){var a=b.indexOf(this.versionSearchString);if(a===-1){return}return parseFloat(b.substring(a+this.versionSearchString.length+1))},dataBrowser:[{string:navigator.userAgent,subString:"Chrome",identity:"Chrome"},{string:navigator.userAgent,subString:"OmniWeb",versionSearch:"OmniWeb/",identity:"OmniWeb"},{string:navigator.vendor,subString:"Apple",identity:"Safari",versionSearch:"Version"},{prop:window.opera,identity:"Opera"},{string:navigator.vendor,subString:"iCab",identity:"iCab"},{string:navigator.vendor,subString:"KDE",identity:"Konqueror"},{string:navigator.userAgent,subString:"Firefox",identity:"Firefox"},{string:navigator.vendor,subString:"Camino",identity:"Camino"},{string:navigator.userAgent,subString:"Netscape",identity:"Netscape"},{string:navigator.userAgent,subString:"MSIE",identity:"Explorer",versionSearch:"MSIE"},{string:navigator.userAgent,subString:"Explorer",identity:"Explorer",versionSearch:"Explorer"},{string:navigator.userAgent,subString:"Gecko",identity:"Mozilla",versionSearch:"rv"},{string:navigator.userAgent,subString:"Mozilla",identity:"Netscape",versionSearch:"Mozilla"}],dataOS:[{string:navigator.platform,subString:"Win",identity:"Windows"},{string:navigator.platform,subString:"Mac",identity:"Mac"},{string:navigator.userAgent,subString:"iPhone",identity:"iPhone/iPod"},{string:navigator.platform,subString:"Linux",identity:"Linux"}]}})();function extend(b,e){var d=b.prototype;var a=function(){};a.prototype=e.prototype;b.prototype=new a();b.superclass=e.prototype;b.prototype.constructor=b;if(e.prototype.constructor===Object.prototype.constructor){e.prototype.constructor=e}for(var c in d){if(d.hasOwnProperty(c)){b.prototype[c]=d[c]}}}function proxy(c,g,a,b){if(typeof c==="function"){if(c.__isProxy){return c}return(function(h){var i=function(){if(g){g({fn:h,arguments:Array.prototype.slice.call(arguments)})}var k=null;try{k=h.apply(h,Array.prototype.slice.call(arguments));if(a){a({fn:h,arguments:Array.prototype.slice.call(arguments)})}}catch(j){if(b){k=b({fn:h,arguments:Array.prototype.slice.call(arguments),exception:j})}else{throw j}}return k};i.__isProxy=true;return i})(c)}if(!typeof c==="object"||c.constructor===Array||c.constructor===String||c.__isProxy){return c}var e=function(){};var d=new e();d.__object=c;d.__isProxy=true;for(var f in c){if(typeof c[f]==="function"){d[f]=(function(h,i,j){return function(){if(g){g({object:h.__object,method:j,arguments:Array.prototype.slice.call(arguments)})}var l=null;try{l=i.apply(h.__object,arguments);if(a){a({object:h.__object,method:j,arguments:Array.prototype.slice.call(arguments)})}}catch(k){if(b){l=b({object:h.__object,method:j,arguments:Array.prototype.slice.call(arguments),exception:k})}else{throw k}}return l}})(d,c[f],f)}}return d}(function(){CAAT.Matrix3=function(){this.matrix=[[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]];this.fmatrix=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1];return this};CAAT.Matrix3.prototype={matrix:null,fmatrix:null,transformCoord:function(b){var a=b.x;var d=b.y;var c=b.z;b.x=a*this.matrix[0][0]+d*this.matrix[0][1]+c*this.matrix[0][2]+this.matrix[0][3];b.y=a*this.matrix[1][0]+d*this.matrix[1][1]+c*this.matrix[1][2]+this.matrix[1][3];b.z=a*this.matrix[2][0]+d*this.matrix[2][1]+c*this.matrix[2][2]+this.matrix[2][3];return b},initialize:function(c,i,f,b,h,e,a,g,d){this.identity();this.matrix[0][0]=c;this.matrix[0][1]=i;this.matrix[0][2]=f;this.matrix[1][0]=b;this.matrix[1][1]=h;this.matrix[1][2]=e;this.matrix[2][0]=a;this.matrix[2][1]=g;this.matrix[2][2]=d;return this},initWithMatrix:function(a){this.matrix=a;return this},flatten:function(){var b=this.fmatrix;var a=this.matrix;b[0]=a[0][0];b[1]=a[1][0];b[2]=a[2][0];b[3]=a[3][0];b[4]=a[0][1];b[5]=a[1][1];b[6]=a[2][1];b[7]=a[2][1];b[8]=a[0][2];b[9]=a[1][2];b[10]=a[2][2];b[11]=a[3][2];b[12]=a[0][3];b[13]=a[1][3];b[14]=a[2][3];b[15]=a[3][3];return this.fmatrix},identity:function(){for(var b=0;b<4;b++){for(var a=0;a<4;a++){this.matrix[b][a]=(b===a)?1:0}}return this},getMatrix:function(){return this.matrix},rotateXY:function(a){return this.rotate(a,0,0)},rotateXZ:function(a){return this.rotate(0,a,0)},rotateYZ:function(a){return this.rotate(0,0,a)},setRotate:function(c,b,d){var a=this.rotate(c,b,d);this.copy(a);return this},rotate:function(f,e,g){var b=new CAAT.Matrix3();var d,h,a;if(f!==0){a=new CAAT.Matrix3();d=Math.sin(f);h=Math.cos(f);a.matrix[1][1]=h;a.matrix[1][2]=-d;a.matrix[2][1]=d;a.matrix[2][2]=h;b.multiply(a)}if(e!==0){a=new CAAT.Matrix3();d=Math.sin(e);h=Math.cos(e);a.matrix[0][0]=h;a.matrix[0][2]=-d;a.matrix[2][0]=d;a.matrix[2][2]=h;b.multiply(a)}if(g!==0){a=new CAAT.Matrix3();d=Math.sin(g);h=Math.cos(g);a.matrix[0][0]=h;a.matrix[0][1]=-d;a.matrix[1][0]=d;a.matrix[1][1]=h;b.multiply(a)}return b},getClone:function(){var a=new CAAT.Matrix3();a.copy(this);return a},multiply:function(H){var F=this.getClone();var L=F.matrix;var e=L[0][0];var c=L[0][1];var b=L[0][2];var a=L[0][3];var E=L[1][0];var D=L[1][1];var C=L[1][2];var B=L[1][3];var w=L[2][0];var v=L[2][1];var u=L[2][2];var t=L[2][3];var h=L[3][0];var g=L[3][1];var f=L[3][2];var d=L[3][3];var s=H.matrix;var o=s[0][0];var l=s[0][1];var j=s[0][2];var i=s[0][3];var K=s[1][0];var J=s[1][1];var I=s[1][2];var G=s[1][3];var A=s[2][0];var z=s[2][1];var y=s[2][2];var x=s[2][3];var r=s[3][0];var q=s[3][1];var p=s[3][2];var k=s[3][3];this.matrix[0][0]=e*o+c*K+b*A+a*r;this.matrix[0][1]=e*l+c*J+b*z+a*q;this.matrix[0][2]=e*j+c*I+b*y+a*p;this.matrix[0][3]=e*i+c*G+b*x+a*k;this.matrix[1][0]=E*o+D*K+C*A+B*r;this.matrix[1][1]=E*l+D*J+C*z+B*q;this.matrix[1][2]=E*j+D*I+C*y+B*p;this.matrix[1][3]=E*i+D*G+C*x+B*k;this.matrix[2][0]=w*o+v*K+u*A+t*r;this.matrix[2][1]=w*l+v*J+u*z+t*q;this.matrix[2][2]=w*j+v*I+u*y+t*p;this.matrix[2][3]=w*i+v*G+u*x+t*k;return this},premultiply:function(H){var F=this.getClone();var L=F.matrix;var e=L[0][0];var c=L[0][1];var b=L[0][2];var a=L[0][3];var E=L[1][0];var D=L[1][1];var C=L[1][2];var B=L[1][3];var w=L[2][0];var v=L[2][1];var u=L[2][2];var t=L[2][3];var h=L[3][0];var g=L[3][1];var f=L[3][2];var d=L[3][3];var s=H.matrix;var o=s[0][0];var l=s[0][1];var j=s[0][2];var i=s[0][3];var K=s[1][0];var J=s[1][1];var I=s[1][2];var G=s[1][3];var A=s[2][0];var z=s[2][1];var y=s[2][2];var x=s[2][3];var r=s[3][0];var q=s[3][1];var p=s[3][2];var k=s[3][3];this.matrix[0][0]=e*o+c*K+b*A;this.matrix[0][1]=e*l+c*J+b*z;this.matrix[0][2]=e*j+c*I+b*y;this.matrix[0][3]=e*i+c*G+b*x+a;this.matrix[1][0]=E*o+D*K+C*A;this.matrix[1][1]=E*l+D*J+C*z;this.matrix[1][2]=E*j+D*I+C*y;this.matrix[1][3]=E*i+D*G+C*x+B;this.matrix[2][0]=w*o+v*K+u*A;this.matrix[2][1]=w*l+v*J+u*z;this.matrix[2][2]=w*j+v*I+u*y;this.matrix[2][3]=w*i+v*G+u*x+t;return this},setTranslate:function(a,c,b){this.identity();this.matrix[0][3]=a;this.matrix[1][3]=c;this.matrix[2][3]=b;return this},translate:function(b,d,c){var a=new CAAT.Matrix3();a.setTranslate(b,d,c);return a},setScale:function(c,b,a){this.identity();this.matrix[0][0]=c;this.matrix[1][1]=b;this.matrix[2][2]=a;return this},scale:function(d,c,b){var a=new CAAT.Matrix3();a.setScale(d,c,b);return a},rotateModelView:function(i,g,d){var h=Math.sin(i);var f=Math.sin(g);var e=Math.sin(d);var c=Math.cos(i);var b=Math.cos(g);var a=Math.cos(d);this.matrix[0][0]=b*c;this.matrix[0][1]=-b*h;this.matrix[0][2]=f;this.matrix[0][3]=0;this.matrix[1][0]=e*f*c+h*a;this.matrix[1][1]=a*c-e*f*h;this.matrix[1][2]=-e*b;this.matrix[1][3]=0;this.matrix[2][0]=e*h-a*f*c;this.matrix[2][1]=a*f*h+e*c;this.matrix[2][2]=a*b;this.matrix[2][3]=0;this.matrix[3][0]=0;this.matrix[3][1]=0;this.matrix[3][2]=0;this.matrix[3][3]=1;return this},copy:function(a){for(var c=0;c<4;c++){for(var b=0;b<4;b++){this.matrix[c][b]=a.matrix[c][b]}}return this},calculateDeterminant:function(){var f=this.matrix;var m=f[0][0],l=f[0][1],j=f[0][2],h=f[0][3],d=f[1][0],c=f[1][1],b=f[1][2],a=f[1][3],q=f[2][0],p=f[2][1],o=f[2][2],n=f[2][3],k=f[3][0],i=f[3][1],g=f[3][2],e=f[3][3];return h*c*o*k+l*a*o*k+h*b*q*i+j*a*q*i+j*d*n*i+m*b*n*i+h*d*p*g+m*a*p*g+j*c*q*e+l*b*q*e+l*d*o*e+m*c*o*e+h*b*p*k-j*a*p*k-j*c*n*k-l*b*n*k-h*d*o*i-m*a*o*i-h*c*q*g-l*a*q*g-l*d*n*g-m*c*n*g-j*d*p*e-m*b*p*e},getInverse:function(){var j=this.matrix;var p=j[0][0],n=j[0][1],l=j[0][2],k=j[0][3],e=j[1][0],d=j[1][1],c=j[1][2],b=j[1][3],i=j[2][0],h=j[2][1],g=j[2][2],f=j[2][3],r=j[3][0],q=j[3][1],o=j[3][2],m=j[3][3];var a=new CAAT.Matrix3();a.matrix[0][0]=c*f*q+b*h*o+d*g*m-b*g*q-d*f*o-c*h*m;a.matrix[0][1]=k*g*q+n*f*o+l*h*m-n*g*m-l*f*q-k*h*o;a.matrix[0][2]=l*b*q+n*c*m+k*d*o-n*b*o-l*d*m-k*c*q;a.matrix[0][3]=k*c*h+n*b*g+l*d*f-l*b*h-k*d*g-n*c*f;a.matrix[1][0]=b*g*r+e*f*o+c*i*m-c*f*r-b*i*o-e*g*m;a.matrix[1][1]=l*f*r+k*i*o+p*g*m-k*g*r-p*f*o-l*i*m;a.matrix[1][2]=k*c*r+p*b*o+l*e*m-l*b*r-k*e*o-p*c*m;a.matrix[1][3]=l*b*i+k*e*g+p*c*f-k*c*i-p*b*g-l*e*f;a.matrix[2][0]=d*f*r+b*i*q+e*h*m-b*h*r-e*f*q-d*i*m;a.matrix[2][1]=k*h*r+p*f*q+n*i*m-p*h*m-n*f*r-k*i*q;a.matrix[2][2]=l*b*r+k*e*q+p*d*m-k*d*r-p*b*q-n*e*m;a.matrix[2][3]=k*d*i+p*b*h+n*e*f-p*d*f-n*b*i-k*e*h;a.matrix[3][0]=c*h*r+e*g*q+d*i*o-d*g*r-c*i*q-e*h*o;a.matrix[3][1]=n*g*r+l*i*q+p*h*o-l*h*r-p*g*q-n*i*o;a.matrix[3][2]=l*d*r+p*c*q+n*e*o-p*d*o-n*c*r-l*e*q;a.matrix[3][3]=n*c*i+l*e*h+p*d*g-l*d*i-p*c*h-n*e*g;return a.multiplyScalar(1/this.calculateDeterminant())},multiplyScalar:function(a){var c,b;for(c=0;c<4;c++){for(b=0;b<4;b++){this.matrix[c][b]*=a}}return this}}})();(function(){CAAT.Matrix=function(){this.matrix=[1,0,0,0,1,0,0,0,1];return this};CAAT.Matrix.prototype={matrix:null,transformCoord:function(b){var a=b.x;var c=b.y;b.x=a*this.matrix[0]+c*this.matrix[1]+this.matrix[2];b.y=a*this.matrix[3]+c*this.matrix[4]+this.matrix[5];return b},rotate:function(b){var a=new CAAT.Matrix();a.setRotation(b);return a},setRotation:function(a){this.identity();this.matrix[0]=Math.cos(a);this.matrix[1]=-Math.sin(a);this.matrix[3]=Math.sin(a);this.matrix[4]=Math.cos(a);return this},scale:function(c,b){var a=new CAAT.Matrix();a.matrix[0]=c;a.matrix[4]=b;return a},setScale:function(b,a){this.identity();this.matrix[0]=b;this.matrix[4]=a;return this},translate:function(b,c){var a=new CAAT.Matrix();a.matrix[2]=b;a.matrix[5]=c;return a},setTranslate:function(a,b){this.identity();this.matrix[2]=a;this.matrix[5]=b;return this},copy:function(b){b=b.matrix;var a=this.matrix;a[0]=b[0];a[1]=b[1];a[2]=b[2];a[3]=b[3];a[4]=b[4];a[5]=b[5];a[6]=b[6];a[7]=b[7];a[8]=b[8];return this},identity:function(){var a=this.matrix;a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return this},multiply:function(d){var j=this.matrix[0]*d.matrix[0]+this.matrix[1]*d.matrix[3]+this.matrix[2]*d.matrix[6];var i=this.matrix[0]*d.matrix[1]+this.matrix[1]*d.matrix[4]+this.matrix[2]*d.matrix[7];var h=this.matrix[0]*d.matrix[2]+this.matrix[1]*d.matrix[5]+this.matrix[2]*d.matrix[8];var g=this.matrix[3]*d.matrix[0]+this.matrix[4]*d.matrix[3]+this.matrix[5]*d.matrix[6];var f=this.matrix[3]*d.matrix[1]+this.matrix[4]*d.matrix[4]+this.matrix[5]*d.matrix[7];var e=this.matrix[3]*d.matrix[2]+this.matrix[4]*d.matrix[5]+this.matrix[5]*d.matrix[8];var c=this.matrix[6]*d.matrix[0]+this.matrix[7]*d.matrix[3]+this.matrix[8]*d.matrix[6];var b=this.matrix[6]*d.matrix[1]+this.matrix[7]*d.matrix[4]+this.matrix[8]*d.matrix[7];var a=this.matrix[6]*d.matrix[2]+this.matrix[7]*d.matrix[5]+this.matrix[8]*d.matrix[8];this.matrix[0]=j;this.matrix[1]=i;this.matrix[2]=h;this.matrix[3]=g;this.matrix[4]=f;this.matrix[5]=e;this.matrix[6]=c;this.matrix[7]=b;this.matrix[8]=a;return this},premultiply:function(d){var j=d.matrix[0]*this.matrix[0]+d.matrix[1]*this.matrix[3]+d.matrix[2]*this.matrix[6];var i=d.matrix[0]*this.matrix[1]+d.matrix[1]*this.matrix[4]+d.matrix[2]*this.matrix[7];var h=d.matrix[0]*this.matrix[2]+d.matrix[1]*this.matrix[5]+d.matrix[2]*this.matrix[8];var g=d.matrix[3]*this.matrix[0]+d.matrix[4]*this.matrix[3]+d.matrix[5]*this.matrix[6];var f=d.matrix[3]*this.matrix[1]+d.matrix[4]*this.matrix[4]+d.matrix[5]*this.matrix[7];var e=d.matrix[3]*this.matrix[2]+d.matrix[4]*this.matrix[5]+d.matrix[5]*this.matrix[8];var c=d.matrix[6]*this.matrix[0]+d.matrix[7]*this.matrix[3]+d.matrix[8]*this.matrix[6];var b=d.matrix[6]*this.matrix[1]+d.matrix[7]*this.matrix[4]+d.matrix[8]*this.matrix[7];var a=d.matrix[6]*this.matrix[2]+d.matrix[7]*this.matrix[5]+d.matrix[8]*this.matrix[8];this.matrix[0]=j;this.matrix[1]=i;this.matrix[2]=h;this.matrix[3]=g;this.matrix[4]=f;this.matrix[5]=e;this.matrix[6]=c;this.matrix[7]=b;this.matrix[8]=a;return this},getInverse:function(){var l=this.matrix[0];var j=this.matrix[1];var i=this.matrix[2];var g=this.matrix[3];var f=this.matrix[4];var e=this.matrix[5];var c=this.matrix[6];var b=this.matrix[7];var a=this.matrix[8];var k=new CAAT.Matrix();var h=l*(f*a-b*e)-g*(j*a-b*i)+c*(j*e-f*i);if(h===0){return null}var d=k.matrix;d[0]=f*a-e*b;d[1]=i*b-j*a;d[2]=j*e-i*f;d[3]=e*c-g*a;d[4]=l*a-i*c;d[5]=i*g-l*e;d[6]=g*b-f*c;d[7]=j*c-l*b;d[8]=l*f-j*g;k.multiplyScalar(1/h);return k},multiplyScalar:function(a){var c,b;for(b=0;b<9;b++){this.matrix[b]*=a}return this},transformRenderingContext:function(b){var a=this.matrix;b.setTransform(a[0],a[3],a[1],a[4],a[2],a[5]);return this}}})();(function(){CAAT.MatrixStack=function(){this.stack=[];this.saved=[];return this};CAAT.MatrixStack.prototype={stack:null,saved:null,pushMatrix:function(a){this.stack.push(a);return this},popMatrix:function(){return this.stack.pop()},save:function(){this.saved.push(this.stack.length);return this},restore:function(){var a=this.saved.pop();while(this.stack.length!==a){this.popMatrix()}return this},getMatrix:function(){var a=new CAAT.Matrix();for(var b=0;b<this.stack.length;b++){var c=this.stack[b];a.multiply(c)}return a}}})();(function(){CAAT.Color=function(){return this};CAAT.Color.prototype={hsvToRgb:function(j,u,n){var a,k,m;var e;var l,d,c,o;j=Math.max(0,Math.min(360,j));u=Math.max(0,Math.min(100,u));n=Math.max(0,Math.min(100,n));u/=100;n/=100;if(u===0){a=k=m=n;return[Math.round(a*255),Math.round(k*255),Math.round(m*255)]}j/=60;e=Math.floor(j);l=j-e;d=n*(1-u);c=n*(1-u*l);o=n*(1-u*(1-l));switch(e){case 0:a=n;k=o;m=d;break;case 1:a=c;k=n;m=d;break;case 2:a=d;k=n;m=o;break;case 3:a=d;k=c;m=n;break;case 4:a=o;k=d;m=n;break;default:a=n;k=d;m=c}return new CAAT.Color.RGB(Math.round(a*255),Math.round(k*255),Math.round(m*255))},RampEnumeration:{RAMP_RGBA:0,RAMP_RGB:1,RAMP_CHANNEL_RGB:2,RAMP_CHANNEL_RGBA:3,RAMP_CHANNEL_RGB_ARRAY:4,RAMP_CHANNEL_RGBA_ARRAY:5},interpolate:function(h,d,m,f,c,l,i,e){if(e<=0){return{r:h,g:d,b:m}}else{if(e>=i){return{r:f,g:c,b:l}}}var a=(h+(f-h)/i*e)>>0;var j=(d+(c-d)/i*e)>>0;var k=(m+(l-m)/i*e)>>0;if(a>255){a=255}else{if(a<0){a=0}}if(j>255){j=255}else{if(j<0){j=0}}if(k>255){k=255}else{if(k<0){k=0}}return{r:a,g:j,b:k}},makeRGBColorRamp:function(p,n,y){var l=[];var h=p.length-1;var o=n/h;for(var t=0;t<h;t++){var x=p[t];var C=(x>>24)&255;var v=(x&16711680)>>16;var d=(x&65280)>>8;var g=x&255;var r=p[t+1];var B=(r>>24)&255;var u=(r&16711680)>>16;var b=(r&65280)>>8;var f=r&255;var A=(B-C)/o;var q=(u-v)/o;var w=(b-d)/o;var z=(f-g)/o;for(var s=0;s<o;s++){var m=(C+A*s)>>0;var a=(v+q*s)>>0;var e=(d+w*s)>>0;var k=(g+z*s)>>0;switch(y){case this.RampEnumeration.RAMP_RGBA:l.push("argb("+m+","+a+","+e+","+k+")");break;case this.RampEnumeration.RAMP_RGB:l.push("rgb("+a+","+e+","+k+")");break;case this.RampEnumeration.RAMP_CHANNEL_RGB:l.push(4278190080|a<<16|e<<8|k);break;case this.RampEnumeration.RAMP_CHANNEL_RGBA:l.push(m<<24|a<<16|e<<8|k);break;case this.RampEnumeration.RAMP_CHANNEL_RGBA_ARRAY:l.push([a,e,k,m]);break;case this.RampEnumeration.RAMP_CHANNEL_RGB_ARRAY:l.push([a,e,k]);break}}}return l}}})();(function(){CAAT.Color.RGB=function(d,c,a){this.r=d||255;this.g=c||255;this.b=a||255;return this};CAAT.Color.RGB.prototype={r:255,g:255,b:255,toHex:function(){return("000000"+((this.r<<16)+(this.g<<8)+this.b).toString(16)).slice(-6)}}})();(function(){CAAT.Rectangle=function(){return this};CAAT.Rectangle.prototype={x:0,y:0,x1:0,y1:0,width:-1,height:-1,setEmpty:function(){this.width=-1;this.height=-1;return this},setLocation:function(a,b){this.x=a;this.y=b;this.x1=this.x+this.width;this.y1=this.y+this.height;return this},setDimension:function(a,b){this.width=a;this.height=b;this.x1=this.x+this.width;this.y1=this.y+this.height;return this},contains:function(b,a){return b>=0&&b<this.width&&a>=0&&a<this.height},isEmpty:function(){return this.width===-1&&this.height===-1},union:function(b,a){if(this.isEmpty()){this.x=b;this.x1=b;this.y=a;this.y1=a;this.width=0;this.height=0;return}this.x1=this.x+this.width;this.y1=this.y+this.height;if(a<this.y){this.y=a}if(b<this.x){this.x=b}if(a>this.y1){this.y1=a}if(b>this.x1){this.x1=b}this.width=this.x1-this.x;this.height=this.y1-this.y},unionRectangle:function(a){this.union(a.x,a.y);this.union(a.x1,a.y);this.union(a.x,a.y1);this.union(a.x1,a.y1);return this}}})();(function(){CAAT.Curve=function(){return this};CAAT.Curve.prototype={coordlist:null,k:0.05,length:-1,interpolator:false,HANDLE_SIZE:20,drawHandles:true,paint:function(a){if(false===this.drawHandles){return}var b=a.crc;b.save();b.beginPath();b.strokeStyle="#a0a0a0";b.moveTo(this.coordlist[0].x,this.coordlist[0].y);b.lineTo(this.coordlist[1].x,this.coordlist[1].y);b.stroke();if(this.cubic){b.moveTo(this.coordlist[2].x,this.coordlist[2].y);b.lineTo(this.coordlist[3].x,this.coordlist[3].y);b.stroke()}b.globalAlpha=0.5;for(var c=0;c<this.coordlist.length;c++){b.fillStyle="#7f7f00";b.beginPath();b.arc(this.coordlist[c].x,this.coordlist[c].y,this.HANDLE_SIZE/2,0,2*Math.PI,false);b.fill()}b.restore()},update:function(){this.calcLength()},solve:function(a,b){},getContour:function(b){var d=[],c;for(c=0;c<=b;c++){var a=new CAAT.Point();this.solve(a,c/b);d.push(a)}return d},getBoundingBox:function(b){if(!b){b=new CAAT.Rectangle()}var c=new CAAT.Point();for(var a=this.k;a<=1+this.k;a+=this.k){this.solve(c,a);b.union(c.x,c.y)}return b},calcLength:function(){var b,a,f,e;b=this.coordlist[0].x;f=this.coordlist[0].y;var d=0;var g=new CAAT.Point();for(var c=this.k;c<=1+this.k;c+=this.k){this.solve(g,c);d+=Math.sqrt((g.x-b)*(g.x-b)+(g.y-f)*(g.y-f));b=g.x;f=g.y}this.length=d;return d},getLength:function(){return this.length},endCurvePosition:function(a){return this.coordlist[this.coordlist.length-1]},startCurvePosition:function(a){return this.coordlist[0]},setPoints:function(a){},setPoint:function(a,b){if(b>=0&&b<this.coordlist.length){this.coordlist[b]=a}},applyAsPath:function(a){}}})();(function(){CAAT.Bezier=function(){CAAT.Bezier.superclass.constructor.call(this);return this};CAAT.Bezier.prototype={cubic:false,applyAsPath:function(a){if(this.cubic){a.bezierCurveTo(this.coordlist[1].x,this.coordlist[1].y,this.coordlist[2].x,this.coordlist[2].y,this.coordlist[3].x,this.coordlist[3].y)}else{a.quadraticCurveTo(this.coordlist[1].x,this.coordlist[1].y,this.coordlist[2].x,this.coordlist[2].y)}return this},isQuadric:function(){return !this.cubic},isCubic:function(){return this.cubic},setCubic:function(a,h,c,b,e,d,g,f){this.coordlist=[];this.coordlist.push(new CAAT.Point().set(a,h));this.coordlist.push(new CAAT.Point().set(c,b));this.coordlist.push(new CAAT.Point().set(e,d));this.coordlist.push(new CAAT.Point().set(g,f));this.cubic=true;this.update();return this},setQuadric:function(a,f,c,b,e,d){this.coordlist=[];this.coordlist.push(new CAAT.Point().set(a,f));this.coordlist.push(new CAAT.Point().set(c,b));this.coordlist.push(new CAAT.Point().set(e,d));this.cubic=false;this.update();return this},setPoints:function(a){if(a.length===3){this.coordlist=a;this.cubic=false;this.update()}else{if(a.length===4){this.coordlist=a;this.cubic=true;this.update()}else{throw"points must be an array of 3 or 4 CAAT.Point instances."}}return this},paint:function(a){if(this.cubic){this.paintCubic(a)}else{this.paintCuadric(a)}CAAT.Bezier.superclass.paint.call(this,a)},paintCuadric:function(b){var d,f;d=this.coordlist[0].x;f=this.coordlist[0].y;var c=b.crc;c.save();c.beginPath();c.moveTo(d,f);var a=new CAAT.Point();for(var e=this.k;e<=1+this.k;e+=this.k){this.solve(a,e);c.lineTo(a.x,a.y)}c.stroke();c.restore()},paintCubic:function(b){var d,f;d=this.coordlist[0].x;f=this.coordlist[0].y;var c=b.crc;c.save();c.beginPath();c.moveTo(d,f);var a=new CAAT.Point();for(var e=this.k;e<=1+this.k;e+=this.k){this.solve(a,e);c.lineTo(a.x,a.y)}c.stroke();c.restore()},solve:function(a,b){if(this.cubic){return this.solveCubic(a,b)}else{return this.solveQuadric(a,b)}},solveCubic:function(a,c){var d=c*c;var b=c*d;a.x=(this.coordlist[0].x+c*(-this.coordlist[0].x*3+c*(3*this.coordlist[0].x-this.coordlist[0].x*c)))+c*(3*this.coordlist[1].x+c*(-6*this.coordlist[1].x+this.coordlist[1].x*3*c))+d*(this.coordlist[2].x*3-this.coordlist[2].x*3*c)+this.coordlist[3].x*b;a.y=(this.coordlist[0].y+c*(-this.coordlist[0].y*3+c*(3*this.coordlist[0].y-this.coordlist[0].y*c)))+c*(3*this.coordlist[1].y+c*(-6*this.coordlist[1].y+this.coordlist[1].y*3*c))+d*(this.coordlist[2].y*3-this.coordlist[2].y*3*c)+this.coordlist[3].y*b;return a},solveQuadric:function(a,b){a.x=(1-b)*(1-b)*this.coordlist[0].x+2*(1-b)*b*this.coordlist[1].x+b*b*this.coordlist[2].x;a.y=(1-b)*(1-b)*this.coordlist[0].y+2*(1-b)*b*this.coordlist[1].y+b*b*this.coordlist[2].y;return a}};extend(CAAT.Bezier,CAAT.Curve,null)})();(function(){CAAT.CatmullRom=function(){CAAT.CatmullRom.superclass.constructor.call(this);return this};CAAT.CatmullRom.prototype={setCurve:function(a,h,c,b,e,d,g,f){this.coordlist=[];this.coordlist.push(new CAAT.Point().set(a,h));this.coordlist.push(new CAAT.Point().set(c,b));this.coordlist.push(new CAAT.Point().set(e,d));this.coordlist.push(new CAAT.Point().set(g,f));this.cubic=true;this.update()},paint:function(b){var e,c,h,g;e=this.coordlist[0].x;h=this.coordlist[0].y;var d=b.crc;d.save();d.beginPath();d.moveTo(e,h);var a=new CAAT.Point();for(var f=this.k;f<=1+this.k;f+=this.k){this.solve(a,f);d.lineTo(a.x,a.y)}d.stroke();d.restore();CAAT.CatmullRom.superclass.paint.call(this,b)},solve:function(a,d){var e=d*d;var b=d*e;var f=this.coordlist;a.x=0.5*((2*f[1].x)+(-f[0].x+f[2].x)*d+(2*f[0].x-5*f[1].x+4*f[2].x-f[3].x)*e+(-f[0].x+3*f[1].x-3*f[2].x+f[3].x)*b);a.y=0.5*((2*f[1].y)+(-f[0].y+f[2].y)*d+(2*f[0].y-5*f[1].y+4*f[2].y-f[3].y)*e+(-f[0].y+3*f[1].y-3*f[2].y+f[3].y)*b);return a}};extend(CAAT.CatmullRom,CAAT.Curve,null)})();(function(){CAAT.Point=function(a,c,b){this.x=a||0;this.y=c||0;this.z=b||0;return this};CAAT.Point.prototype={x:0,y:0,z:0,set:function(a,c,b){this.x=a||0;this.y=c||0;this.z=b||0;return this},clone:function(){var a=new CAAT.Point(this.x,this.y,this.z);return a},translate:function(a,c,b){this.x+=a;this.y+=c;this.z+=b||0;return this},translatePoint:function(a){this.x+=a.x;this.y+=a.y;this.z+=a.z;return this},subtract:function(a){this.x-=a.x;this.y-=a.y;this.z-=a.z;return this},multiply:function(a){this.x*=a;this.y*=a;this.z*=a;return this},rotate:function(b){var a=this.x,c=this.y;this.x=a*Math.cos(b)-Math.sin(b)*c;this.y=a*Math.sin(b)+Math.cos(b)*c;return this},setAngle:function(b){var a=this.getLength();this.x=Math.cos(b)*a;this.y=Math.sin(b)*a;return this},setLength:function(b){var a=this.getLength();if(a){this.multiply(b/a)}else{this.x=this.y=b}return this},normalize:function(){var a=this.getLength();this.x/=a;this.y/=a;this.z/=a;return this},getAngle:function(){return Math.atan2(this.y,this.x)},limit:function(a){var b=this.getLengthSquared();if(b+0.01>a*a){var c=Math.sqrt(b);this.x=(this.x/c)*a;this.y=(this.y/c)*a;this.z=(this.z/c)*a}return this},getLength:function(){var a=Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z);if(a<0.005&&a>-0.005){return 0.000001}return a},getLengthSquared:function(){var a=this.x*this.x+this.y*this.y+this.z*this.z;if(a<0.005&&a>-0.005){return 0}return a},getDistance:function(b){var c=this.x-b.x;var a=this.y-b.y;var d=this.z-b.z;return Math.sqrt(c*c+a*a+d*d)},getDistanceSquared:function(b){var c=this.x-b.x;var a=this.y-b.y;var d=this.z-b.z;return c*c+a*a+d*d},toString:function(){return"(CAAT.Point) x:"+String(Math.round(Math.floor(this.x*10))/10)+" y:"+String(Math.round(Math.floor(this.y*10))/10)+" z:"+String(Math.round(Math.floor(this.z*10))/10)}}})();(function(){CAAT.Actor=function(){this.behaviorList=[];this.lifecycleListenerList=[];this.AABB=new CAAT.Rectangle();this.viewVertices=[new CAAT.Point(0,0,0),new CAAT.Point(0,0,0),new CAAT.Point(0,0,0),new CAAT.Point(0,0,0)];this.scaleAnchor=this.ANCHOR_CENTER;this.rotateAnchor=this.ANCHOR_CENTER;this.modelViewMatrix=new CAAT.Matrix();this.worldModelViewMatrix=new CAAT.Matrix();this.modelViewMatrixI=new CAAT.Matrix();this.worldModelViewMatrixI=new CAAT.Matrix();this.tmpMatrix=new CAAT.Matrix();this.resetTransform();this.setScale(1,1);this.setRotation(0);return this};CAAT.Actor.prototype={tmpMatrix:null,lifecycleListenerList:null,behaviorList:null,parent:null,x:0,y:0,width:0,height:0,start_time:0,duration:Number.MAX_VALUE,clip:false,clipPath:null,scaleX:0,scaleY:0,scaleTX:0,scaleTY:0,scaleAnchor:0,rotationAngle:0,rotationY:0,alpha:1,rotationX:0,isGlobalAlpha:false,frameAlpha:1,expired:false,discardable:false,pointed:false,mouseEnabled:true,visible:true,ANCHOR_CENTER:0,ANCHOR_TOP:1,ANCHOR_BOTTOM:2,ANCHOR_LEFT:3,ANCHOR_RIGHT:4,ANCHOR_TOP_LEFT:5,ANCHOR_TOP_RIGHT:6,ANCHOR_BOTTOM_LEFT:7,ANCHOR_BOTTOM_RIGHT:8,ANCHOR_CUSTOM:9,fillStyle:null,strokeStyle:null,time:0,AABB:null,viewVertices:null,inFrame:false,dirty:true,wdirty:true,oldX:-1,oldY:-1,modelViewMatrix:null,worldModelViewMatrix:null,modelViewMatrixI:null,worldModelViewMatrixI:null,glEnabled:false,backgroundImage:null,id:null,getId:function(){return this.id},setId:function(a){this.id=a;return this},setParent:function(a){this.parent=a},setBackgroundImage:function(b,a){if(b){if(!(b instanceof CAAT.SpriteImage)){b=new CAAT.SpriteImage().initialize(b,1,1)}b.setOwner(this);this.backgroundImage=b;if(a){this.width=b.singleWidth;this.height=b.singleHeight}this.glEnabled=true}return this},setSpriteIndex:function(a){if(this.backgroundImage){this.backgroundImage.setSpriteIndex(a)}return this},setBackgroundImageOffset:function(b,a){if(this.backgroundImage){this.backgroundImage.setOffset(b,a)}return this},setAnimationImageIndex:function(a){if(this.backgroundImage){this.backgroundImage.setAnimationImageIndex(a)}return this},setChangeFPS:function(a){if(this.backgroundImage){this.backgroundImage.setChangeFPS(a)}return this},setImageTransformation:function(a){if(this.backgroundImage){this.backgroundImage.setSpriteTransformation(a)}return this},centerOn:function(a,b){this.setLocation(a-this.width/2,b-this.height/2);return this},centerAt:function(a,b){return this.centerOn(a,b)},getTextureGLPage:function(){return this.backgroundImage.image.__texturePage},setVisible:function(a){this.visible=a;return this},setOutOfFrameTime:function(){this.setFrameTime(-1,0);return this},addListener:function(a){this.lifecycleListenerList.push(a);return this},removeListener:function(a){var b=this.lifecycleListenerList.length;while(b--){if(this.lifecycleListenerList[b]===a){this.lifecycleListenerList.splice(b,1);return}}},setGlobalAlpha:function(a){this.isGlobalAlpha=a;return this},fireEvent:function(c,b){for(var a=0;a<this.lifecycleListenerList.length;a++){this.lifecycleListenerList[a].actorLifeCycleEvent(this,c,b)}},setScreenBounds:function(){this.viewVertices[0].set(0,0);this.viewVertices[1].set(this.width,0);this.viewVertices[2].set(this.width,this.height);this.viewVertices[3].set(0,this.height);this.modelToView(this.viewVertices);var e=Number.MAX_VALUE,b=Number.MIN_VALUE;var d=Number.MAX_VALUE,a=Number.MIN_VALUE;for(var c=0;c<4;c++){if(this.viewVertices[c].x<e){e=this.viewVertices[c].x}if(this.viewVertices[c].x>b){b=this.viewVertices[c].x}if(this.viewVertices[c].y<d){d=this.viewVertices[c].y}if(this.viewVertices[c].y>a){a=this.viewVertices[c].y}}this.AABB.x=e;this.AABB.y=d;this.AABB.width=(b-e);this.AABB.height=(a-d);return this},setExpired:function(a){this.expired=true;this.fireEvent("expired",a);return this},enableEvents:function(a){this.mouseEnabled=a;return this},emptyBehaviorList:function(){this.behaviorList=[];return this},setFillStyle:function(a){this.fillStyle=a;return this},setStrokeStyle:function(a){this.strokeStyle=a;return this},setPaint:function(a){return this.setFillStyle(a)},setAlpha:function(a){this.alpha=a;return this},resetTransform:function(){this.rotationAngle=0;this.rotateAnchor=0;this.rotationX=0;this.rotationY=0;this.scaleX=1;this.scaleY=1;this.scaleTX=0;this.scaleTY=0;this.scaleAnchor=0;this.oldX=-1;this.oldY=-1;this.dirty=true;return this},setFrameTime:function(a,b){this.start_time=a;this.duration=b;this.expired=false;this.dirty=true;return this},paint:function(b,c){if(this.backgroundImage){this.backgroundImage.paint(b,c,0,0)}else{if(this.fillStyle){var a=b.crc;a.fillStyle=this.fillStyle;a.fillRect(0,0,this.width,this.height)}}},setScale:function(b,a){this.setScaleAnchored(b,a,this.width/2,this.height/2);this.dirty=true;return this},getAnchorPercent:function(a){var b=[50,50,50,0,50,100,0,50,100,50,0,0,100,0,0,100,100,100];return{x:b[a*2],y:b[a*2+1]}},getAnchor:function(c){var b=0,a=0;switch(c){case this.ANCHOR_CENTER:b=this.width/2;a=this.height/2;break;case this.ANCHOR_TOP:b=this.width/2;a=0;break;case this.ANCHOR_BOTTOM:b=this.width/2;a=this.height;break;case this.ANCHOR_LEFT:b=0;a=this.height/2;break;case this.ANCHOR_RIGHT:b=this.width;a=this.height/2;break;case this.ANCHOR_TOP_RIGHT:b=this.width;a=0;break;case this.ANCHOR_BOTTOM_LEFT:b=0;a=this.height;break;case this.ANCHOR_BOTTOM_RIGHT:b=this.width;a=this.height;break;case this.ANCHOR_TOP_LEFT:b=0;a=0;break}return{x:b,y:a}},setScaleAnchored:function(d,c,b,a){this.scaleTX=b;this.scaleTY=a;this.scaleX=d;this.scaleY=c;this.dirty=true;return this},setRotation:function(a){this.setRotationAnchored(a,this.width/2,this.height/2);return this},setRotationAnchored:function(c,b,a){this.rotationAngle=c;this.rotationX=b?b:0;this.rotationY=a?a:0;this.dirty=true;return this},setSize:function(a,b){this.width=a>>0;this.height=b>>0;this.dirty=true;return this},setBounds:function(a,d,b,c){this.x=a|0;this.y=d|0;this.width=b|0;this.height=c|0;this.dirty=true;return this},setLocation:function(a,b){a=a|0;b=b|0;this.x=a;this.y=b;this.oldX=a;this.oldY=b;this.dirty=true;return this},isInAnimationFrame:function(a){if(this.expired){return false}if(this.duration===Number.MAX_VALUE){return this.start_time<=a}if(a>=this.start_time+this.duration){if(!this.expired){this.setExpired(a)}return false}return this.start_time<=a&&a<this.start_time+this.duration},contains:function(a,b){return a>=0&&b>=0&&a<this.width&&b<this.height},create:function(){return this},addBehavior:function(a){this.behaviorList.push(a);return this},removeBehaviour:function(a){var b=this.behaviorList.length-1;while(b){if(this.behaviorList[b]===a){this.behaviorList.splice(b,1);return this}}return this},removeBehaviorById:function(b){for(var a=0;a<this.behaviorList.length;a++){if(this.behaviorList[a].id===b){this.behaviorList.splice(a,1)}}return this},setDiscardable:function(a){this.discardable=a;return this},destroy:function(a){if(this.parent){this.parent.removeChild(this)}this.fireEvent("destroyed",a)},modelToView:function(a){if(a instanceof Array){for(var b=0;b<a.length;b++){this.worldModelViewMatrix.transformCoord(a[b])}}else{this.worldModelViewMatrix.transformCoord(a)}return a},viewToModel:function(a){this.worldModelViewMatrixI=this.worldModelViewMatrix.getInverse();this.worldModelViewMatrixI.transformCoord(a);return a},findActorAtPosition:function(a,b){if(!this.mouseEnabled||!this.isInAnimationFrame(this.time)){return null}this.modelViewMatrixI=this.modelViewMatrix.getInverse();this.modelViewMatrixI.transformCoord(a);return this.contains(a.x,a.y)?this:null},enableDrag:function(){this.ax=0;this.ay=0;this.mx=0;this.my=0;this.asx=1;this.asy=1;this.ara=0;this.screenx=0;this.screeny=0;this.mouseEnter=function(a){this.ax=-1;this.ay=-1;this.pointed=true;CAAT.setCursor("move")};this.mouseExit=function(a){this.ax=-1;this.ay=-1;this.pointed=false;CAAT.setCursor("default")};this.mouseMove=function(a){this.mx=a.point.x;this.my=a.point.y};this.mouseUp=function(a){this.ax=-1;this.ay=-1};this.mouseDrag=function(f){if(this.ax===-1||this.ay===-1){this.ax=f.point.x;this.ay=f.point.y;this.asx=this.scaleX;this.asy=this.scaleY;this.ara=this.rotationAngle;this.screenx=f.screenPoint.x;this.screeny=f.screenPoint.y}if(f.isShiftDown()){var b=(f.screenPoint.x-this.screenx)/100;var a=(f.screenPoint.y-this.screeny)/100;if(!f.isAltDown()){var e=Math.max(b,a);b=e;a=e}this.setScale(b+this.asx,a+this.asy)}else{if(f.isControlDown()){var d=f.screenPoint.x-this.screenx;var c=f.screenPoint.y-this.screeny;this.setRotation(-Math.atan2(d,c)+this.ara)}else{this.x+=f.point.x-this.ax;this.y+=f.point.y-this.ay;this.ax=f.point.x;this.ay=f.point.y}}};return this},mouseClick:function(a){},mouseDblClick:function(a){},mouseEnter:function(a){this.pointed=true},mouseExit:function(a){this.pointed=false},mouseMove:function(a){},mouseDown:function(a){},mouseUp:function(a){},mouseDrag:function(a){},drawScreenBoundingBox:function(a,c){if(null!==this.AABB&&this.inFrame){var b=this.AABB;a.ctx.strokeRect(b.x,b.y,b.width,b.height)}},animate:function(a,c){if(!this.isInAnimationFrame(c)){this.inFrame=false;this.dirty=true;return false}if(this.x!==this.oldX||this.y!==this.oldY){this.dirty=true;this.oldX=this.x;this.oldY=this.y}for(var b=0;b<this.behaviorList.length;b++){this.behaviorList[b].apply(c,this)}if(this.clipPath){if(this.clipPath.applyBehaviors){this.clipPath.applyBehaviors(c)}}this.setModelViewMatrix(a);this.inFrame=true;return true},setModelViewMatrix:function(b){this.wdirty=false;if(this.dirty){this.modelViewMatrix.identity();var a=this.tmpMatrix.identity();var c=this.modelViewMatrix.matrix;c[2]+=this.x;c[5]+=this.y;if(this.rotationAngle){c[2]+=c[0]*this.rotationX+c[1]*this.rotationY;c[5]+=c[3]*this.rotationX+c[4]*this.rotationY;this.modelViewMatrix.multiply(a.setRotation(this.rotationAngle));c[2]+=-c[0]*this.rotationX-c[1]*this.rotationY;c[5]+=-c[3]*this.rotationX-c[4]*this.rotationY}if(this.scaleX!=1||this.scaleY!=1&&(this.scaleTX||this.scaleTY)){c[2]+=c[0]*this.scaleTX+c[1]*this.scaleTY;c[5]+=c[3]*this.scaleTX+c[4]*this.scaleTY;c[0]=c[0]*this.scaleX;c[1]=c[1]*this.scaleY;c[3]=c[3]*this.scaleX;c[4]=c[4]*this.scaleY;c[2]+=-c[0]*this.scaleTX-c[1]*this.scaleTY;c[5]+=-c[3]*this.scaleTX-c[4]*this.scaleTY}}if(this.parent){if(this.dirty||this.parent.wdirty){this.worldModelViewMatrix.copy(this.parent.worldModelViewMatrix);this.worldModelViewMatrix.multiply(this.modelViewMatrix);this.wdirty=true}}else{if(this.dirty){this.wdirty=true}this.worldModelViewMatrix.copy(this.modelViewMatrix)}if(b.glEnabled&&(this.dirty||this.wdirty)){this.setScreenBounds()}this.dirty=false;return this},paintActor:function(b,c){if(!this.visible){return true}var a=b.ctx;this.frameAlpha=this.parent?this.parent.frameAlpha*this.alpha:1;a.globalAlpha=this.frameAlpha;this.worldModelViewMatrix.transformRenderingContext(a);if(this.clip){a.beginPath();if(!this.clipPath){a.rect(0,0,this.width,this.height)}else{this.clipPath.applyAsPath(a)}a.clip()}this.paint(b,c);return true},__paintActor:function(c,d){if(!this.visible){return true}var b=c.ctx;this.frameAlpha=this.alpha;var a=this.worldModelViewMatrix.matrix;b.setTransform(a[0],a[3],a[1],a[4],a[2],a[5],this.frameAlpha);this.paint(c,d);return true},paintActorGL:function(a,d){this.frameAlpha=this.parent.frameAlpha*this.alpha;if(!this.glEnabled||!this.visible){return}if(this.glNeedsFlush(a)){a.glFlush();this.glSetShader(a);if(!this.__uv){this.__uv=new Float32Array(8)}if(!this.__vv){this.__vv=new Float32Array(12)}this.setGLCoords(this.__vv,0);this.setUV(this.__uv,0);a.glRender(this.__vv,12,this.__uv);return}var c=a.coords;var b=a.coordsIndex;this.setGLCoords(c,b);a.coordsIndex=b+12;this.setUV(a.uv,a.uvIndex);a.uvIndex+=8},setGLCoords:function(c,a){var b=this.viewVertices;c[a++]=b[0].x;c[a++]=b[0].y;c[a++]=0;c[a++]=b[1].x;c[a++]=b[1].y;c[a++]=0;c[a++]=b[2].x;c[a++]=b[2].y;c[a++]=0;c[a++]=b[3].x;c[a++]=b[3].y;c[a++]=0},setUV:function(a,b){this.backgroundImage.setUV(a,b)},glNeedsFlush:function(a){if(this.getTextureGLPage()!==a.currentTexturePage){return true}if(this.frameAlpha!==a.currentOpacity){return true}return false},glSetShader:function(a){if(this.frameAlpha!==a.currentOpacity){a.setGLCurrentOpacity(this.frameAlpha)}},endAnimate:function(a,b){return this},initialize:function(b){if(b){for(var a in b){this[a]=b[a]}}return this},setClip:function(a,b){this.clip=a;this.clipPath=b;return this},cacheAsBitmap:function(d){d=d||0;var c=document.createElement("canvas");c.width=this.width;c.height=this.height;var b=c.getContext("2d");var a={ctx:b,crc:b};this.paintActor(a,d);this.setBackgroundImage(c);return this},setAsButton:function(a,c,d,e,f,b){(function(j,s,m,u,t,l,q){var p=0;var r=0;var i=0;var h=0;var g=0;var o=null;var k=true;var n=this;j.enabled=true;j.setEnabled=function(v){this.enabled=v};j.setBackgroundImage(s,true);p=m||0;r=u||p;i=t||p;h=l||p;g=p;o=q;j.setSpriteIndex(p);j.mouseEnter=function(v){this.setSpriteIndex(r);CAAT.setCursor("pointer")};j.mouseExit=function(v){this.setSpriteIndex(p);CAAT.setCursor("default")};j.mouseDown=function(v){this.setSpriteIndex(i)};j.mouseUp=function(v){this.setSpriteIndex(p)};j.mouseClick=function(v){if(this.enabled&&null!==o){o(this)}};j.setButtonImageIndex=function(v,y,w,x){p=v;r=y;i=w;h=x;return this}})(this,a,c,d,e,f,b);return this}};if(CAAT.NO_PERF){CAAT.Actor.prototype.paintActor=CAAT.Actor.prototype.__paintActor}})();(function(){CAAT.ActorContainer=function(){CAAT.ActorContainer.superclass.constructor.call(this);this.childrenList=[];this.pendingChildrenList=[];return this};CAAT.ActorContainer.prototype={childrenList:null,activeChildren:null,pendingChildrenList:null,drawScreenBoundingBox:function(a,c){if(!this.inFrame){return}for(var b=0;b<this.childrenList.length;b++){this.childrenList[b].drawScreenBoundingBox(a,c)}CAAT.ActorContainer.superclass.drawScreenBoundingBox.call(this,a,c)},emptyChildren:function(){this.childrenList=[];return this},paintActor:function(b,d){if(!this.visible){return true}var a=b.ctx;a.save();CAAT.ActorContainer.superclass.paintActor.call(this,b,d);if(!this.isGlobalAlpha){this.frameAlpha=this.parent?this.parent.frameAlpha:1}for(var c=this.activeChildren;c;c=c.__next){if(c.visible){a.save();c.paintActor(b,d);a.restore()}}a.restore();return true},__paintActor:function(c,e){var b=c.ctx;this.frameAlpha=this.parent?this.parent.frameAlpha*this.alpha:1;var a=this.worldModelViewMatrix.matrix;b.setTransform(a[0],a[3],a[1],a[4],a[2],a[5],this.frameAlpha);this.paint(c,e);if(!this.isGlobalAlpha){this.frameAlpha=this.parent?this.parent.frameAlpha:1}for(var d=this.activeChildren;d;d=d.__next){d.paintActor(c,e)}return true},paintActorGL:function(a,d){var b,e;if(!this.visible){return true}CAAT.ActorContainer.superclass.paintActorGL.call(this,a,d);if(!this.isGlobalAlpha){this.frameAlpha=this.parent.frameAlpha}for(e=this.activeChildren;e;e=e.__next){e.paintActorGL(a,d)}},animate:function(b,d){this.activeChildren=null;var h=null;if(false===CAAT.ActorContainer.superclass.animate.call(this,b,d)){return false}var g,e;var a=[];for(g=0;g<this.pendingChildrenList.length;g++){var c=this.pendingChildrenList[g];this.addChild(c)}this.pendingChildrenList=[];var j=this.childrenList;this.activeChildren=null;for(g=0;g<j.length;g++){var f=j[g];f.time=d;if(f.animate(b,d)){if(!this.activeChildren){this.activeChildren=f;f.__next=null;h=f}else{f.__next=null;h.__next=f;h=f}}else{if(f.expired&&f.discardable){f.destroy(d)}}}return true},endAnimate:function(a,b){},addChildImmediately:function(a){return this.addChild(a)},addChild:function(a){if(a.parent!=null){throw ("adding to a container an element with parent.")}a.parent=this;this.childrenList.push(a);return this},addChildDelayed:function(a){this.pendingChildrenList.push(a);return this},addChildAt:function(b,a){if(a<=0){this.childrenList.unshift(b);return this}else{if(a>=this.childrenList.length){a=this.childrenList.length}}b.parent=this;this.childrenList.splice(a,0,b);return this},findChild:function(c){var b=0,a=this.childrenList.length;for(b=0;b<a;b++){if(this.childrenList[b]===c){return b}}return -1},removeChild:function(b){var a=this.findChild(b);if(-1!==a){this.childrenList[a].setParent(null);this.childrenList.splice(a,1)}return this},findActorAtPosition:function(a,c){if(null===CAAT.ActorContainer.superclass.findActorAtPosition.call(this,a,c)){return null}for(var e=this.childrenList.length-1;e>=0;e--){var g=this.childrenList[e];var f=new CAAT.Point(a.x,a.y,0);var b=g.AABB;var d=g.findActorAtPosition(f,c);if(null!==d){return d}}return this},destroy:function(){for(var a=this.childrenList.length-1;a>=0;a--){this.childrenList[a].destroy()}CAAT.ActorContainer.superclass.destroy.call(this);return this},getNumChildren:function(){return this.childrenList.length},getNumActiveChildren:function(){return this.activeChildren.length},getChildAt:function(a){return this.childrenList[a]},setZOrder:function(c,b){var d=this.findChild(c);if(-1!==d){if(b===d){return}if(b>=this.childrenList.length){this.childrenList.splice(d,1);this.childrenList.push(c)}else{var a=this.childrenList.splice(d,1);if(b<0){b=0}else{if(b>this.childrenList.length){b=this.childrenList.length}}this.childrenList.splice(b,1,a)}}}};if(CAAT.NO_PERF){CAAT.ActorContainer.prototype.paintActor=CAAT.ActorContainer.prototype.__paintActor}extend(CAAT.ActorContainer,CAAT.Actor,null)})();(function(){CAAT.SpriteActor=function(){CAAT.SpriteActor.superclass.constructor.call(this);this.glEnabled=true;this.setAnimationImageIndex([0]);return this};CAAT.SpriteActor.prototype={compoundbitmap:null,animationImageIndex:null,prevAnimationTime:-1,changeFPS:1000,transformation:0,spriteIndex:0,TR_NONE:0,TR_FLIP_HORIZONTAL:1,TR_FLIP_VERTICAL:2,TR_FLIP_ALL:3,setSpriteImage:function(a){this.compoundbitmap=a;this.width=a.singleWidth;this.height=a.singleHeight;return this},setChangeFPS:function(a){this.changeFPS=a;return this},setSpriteTransformation:function(a){this.transformation=a;switch(a){case this.TR_FLIP_HORIZONTAL:this.compoundbitmap.paint=this.compoundbitmap.paintInvertedH;break;case this.TR_FLIP_VERTICAL:this.compoundbitmap.paint=this.compoundbitmap.paintInvertedV;break;case this.TR_FLIP_ALL:this.compoundbitmap.paint=this.compoundbitmap.paintInvertedHV;break;default:this.compoundbitmap.paint=this.compoundbitmap.paintN}return this},setAnimationImageIndex:function(a){this.animationImageIndex=a;this.spriteIndex=a[0];return this},setSpriteIndex:function(a){this.spriteIndex=a;return this},paint:function(b,d){if(this.animationImageIndex.length>1){if(this.prevAnimationTime===-1){this.prevAnimationTime=d}else{var a=d;a-=this.prevAnimationTime;a/=this.changeFPS;a%=this.animationImageIndex.length;this.spriteIndex=this.animationImageIndex[Math.floor(a)]}}var c=b.ctx;if(this.spriteIndex!=-1){this.compoundbitmap.paint(c,this.spriteIndex,0,0)}},paintActorGL:function(a,b){if(-1===this.spriteIndex){return}CAAT.SpriteActor.superclass.paintActorGL.call(this,a,b)},setUV:function(b,a){this.compoundbitmap.setUV(this.spriteIndex,b,a)},glNeedsFlush:function(a){if(this.compoundbitmap.image.__texturePage!==a.currentTexturePage){return true}if(this.frameAlpha!==a.currentOpacity){return true}return false}};extend(CAAT.SpriteActor,CAAT.ActorContainer,null)})();(function(){CAAT.ImageActor=function(){CAAT.ImageActor.superclass.constructor.call(this);this.glEnabled=true;return this};CAAT.ImageActor.prototype={image:null,transformation:0,TR_NONE:0,TR_FLIP_HORIZONTAL:1,TR_FLIP_VERTICAL:2,TR_FLIP_ALL:3,TR_FIXED_TO_SIZE:4,offsetX:0,offsetY:0,setOffsetX:function(a){this.offsetX=a|0;return this},setOffsetY:function(a){this.offsetY=a|0;return this},setOffset:function(a,b){this.offsetX=a;this.offsetY=b;return this},setImage:function(a){this.image=a;if(a&&(this.width===0||this.height===0)){this.width=a.width;this.height=a.height}return this},setImageTransformation:function(a){this.transformation=a;switch(this.transformation){case this.TR_FLIP_HORIZONTAL:this.paint=this.paintInvertedH;break;case this.TR_FLIP_VERTICAL:this.paint=this.paintInvertedV;break;case this.TR_FLIP_ALL:this.paint=this.paintInvertedHV;break;case this.TR_FIXED_TO_SIZE:this.paint=this.paintFixed}return this},paintFixed:function(b,c){if(this.image){b.ctx.drawImage(this.image,this.offsetX,this.offsetY,this.width,this.height)}else{var a=b.ctx;a.fillStyle=this.fillStyle;a.fillRect(0,0,this.width,this.height)}},paint:function(b,c){var a=b.ctx;a.drawImage(this.image,this.offsetX,this.offsetY)},paintActorGL:function(a,b){if(null===this.image){return}CAAT.ImageActor.superclass.paintActorGL.call(this,a,b)},paintInvertedH:function(b,c){var a=b.crc;a.save();a.translate(this.width,0);a.scale(-1,1);a.drawImage(this.image,this.offsetX,this.offsetY);a.restore()},paintInvertedV:function(b,c){var a=b.crc;a.save();a.translate(0,this.height);a.scale(1,-1);a.drawImage(this.image,this.offsetX,this.offsetY);a.restore()},paintInvertedHV:function(b,c){var a=b.crc;a.save();a.translate(0,this.height);a.scale(1,-1);a.translate(this.width,0);a.scale(-1,1);a.drawImage(this.image,this.offsetX,this.offsetY);a.restore()},setUV:function(c,k){var d=k;var e=this.image;if(!e.__texturePage){return}var l=e.__u;var j=e.__v;var a=e.__u1;var i=e.__v1;if(this.offsetX||this.offsetY){var g=this.width;var b=this.height;var f=e.__texturePage;l=(e.__tx-this.offsetX)/f.width;j=(e.__ty-this.offsetY)/f.height;a=l+g/f.width;i=j+b/f.height}if(e.inverted){c[d++]=a;c[d++]=j;c[d++]=a;c[d++]=i;c[d++]=l;c[d++]=i;c[d++]=l;c[d++]=j}else{c[d++]=l;c[d++]=j;c[d++]=a;c[d++]=j;c[d++]=a;c[d++]=i;c[d++]=l;c[d++]=i}},glNeedsFlush:function(a){if(this.image.__texturePage!==a.currentTexturePage){return true}if(this.frameAlpha!==a.currentOpacity){return true}return false}};extend(CAAT.ImageActor,CAAT.ActorContainer,null)})();(function(){CAAT.TextActor=function(){CAAT.TextActor.superclass.constructor.call(this);this.font="10px sans-serif";this.textAlign="left";this.textBaseline="top";this.outlineColor="black";this.clip=false;return this};CAAT.TextActor.TRAVERSE_PATH_FORWARD=1;CAAT.TextActor.TRAVERSE_PATH_BACKWARD=-1;CAAT.TextActor.prototype={font:null,textAlign:null,textBaseline:null,fill:true,text:null,textWidth:0,textHeight:0,outline:false,outlineColor:null,path:null,pathInterpolator:null,pathDuration:10000,sign:1,setFill:function(a){this.fill=a;return this},setOutline:function(a){this.outline=a;return this},setPathTraverseDirection:function(a){this.sign=a;return this},setOutlineColor:function(a){this.outlineColor=a;return this},setText:function(a){this.text=a;this.setFont(this.font);return this},setTextAlign:function(a){this.textAlign=a;return this},setAlign:function(a){return this.setTextAlign(a)},setTextBaseline:function(a){this.textBaseline=a;return this},setBaseline:function(a){return this.setTextBaseline(a)},setFont:function(a){if(!a){return this}this.font=a;if(null===this.text||this.text===""){this.width=this.height=0}return this},calcTextSize:function(a){if(a.glEnabled){return this}a.ctx.save();a.ctx.font=this.font;this.textWidth=a.crc.measureText(this.text).width;if(this.width===0){this.width=this.textWidth}try{var d=this.font.indexOf("px");var b=this.font.substring(0,d);this.textHeight=parseInt(b,10);this.textHeight+=(this.textHeight/4)>>0}catch(c){this.textHeight=20}if(this.height===0){this.height=this.textHeight}a.crc.restore();return this},paint:function(b,d){if(this.backgroundImage){CAAT.TextActor.superclass.paint.call(this,b,d);return}if(null===this.text){return}if(this.textWidth===0||this.textHeight===0){this.calcTextSize(b)}var c=b.crc;if(null!==this.font){c.font=this.font}if(null!==this.textAlign){c.textAlign=this.textAlign}if(null!==this.textBaseline){c.textBaseline=this.textBaseline}if(null!==this.fillStyle){c.fillStyle=this.fillStyle}if(null===this.path){var a=0;if(this.textAlign==="center"){a=(this.width/2)|0}else{if(this.textAlign==="right"){a=this.width}}if(this.fill){c.fillText(this.text,a,0);if(this.outline){if(null!==this.outlineColor){c.strokeStyle=this.outlineColor}c.beginPath();c.strokeText(this.text,a,0)}}else{if(null!==this.outlineColor){c.strokeStyle=this.outlineColor}c.strokeText(this.text,a,0)}}else{this.drawOnPath(b,d)}},drawOnPath:function(a,c){var b=a.crc;var h=this.sign*this.pathInterpolator.getPosition((c%this.pathDuration)/this.pathDuration).y*this.path.getLength();var m=new CAAT.Point(0,0,0);var k=new CAAT.Point(0,0,0);for(var e=0;e<this.text.length;e++){var f=this.text[e].toString();var g=b.measureText(f).width;var l=this.path.getLength();var j=g/2+h;m=this.path.getPositionFromLength(j).clone();k=this.path.getPositionFromLength(j-0.1).clone();var d=Math.atan2(m.y-k.y,m.x-k.x);b.save();b.translate((0.5+m.x)|0,(0.5+m.y)|0);b.rotate(d);if(this.fill){b.fillText(f,0,0)}if(this.outline){b.strokeStyle=this.outlineColor;b.strokeText(f,0,0)}b.restore();h+=g}},setPath:function(b,c,a){this.path=b;this.pathInterpolator=c||new CAAT.Interpolator().createLinearInterpolator();this.pathDuration=a||10000;this.mouseEnabled=false;return this}};extend(CAAT.TextActor,CAAT.ActorContainer,null)})();(function(){CAAT.Button=function(){CAAT.Button.superclass.constructor.call(this);this.glEnabled=true;return this};CAAT.Button.prototype={iNormal:0,iOver:0,iPress:0,iDisabled:0,iCurrent:0,fnOnClick:null,enabled:true,setEnabled:function(a){this.enabled=a},initialize:function(a,c,d,e,f,b){this.setSpriteImage(a);this.iNormal=c||0;this.iOver=d||this.iNormal;this.iPress=e||this.iNormal;this.iDisabled=f||this.iNormal;this.iCurrent=this.iNormal;this.width=a.singleWidth;this.height=a.singleHeight;this.fnOnClick=b;this.spriteIndex=c;return this},mouseEnter:function(a){this.setSpriteIndex(this.iOver);CAAT.setCursor("pointer")},mouseExit:function(a){this.setSpriteIndex(this.iNormal);CAAT.setCursor("default")},mouseDown:function(a){this.setSpriteIndex(this.iPress)},mouseUp:function(a){this.setSpriteIndex(this.iNormal)},mouseClick:function(a){if(this.enabled&&null!==this.fnOnClick){this.fnOnClick(this)}},toString:function(){return"CAAT.Button "+this.iNormal}};extend(CAAT.Button,CAAT.SpriteActor,null)})();(function(){CAAT.ShapeActor=function(){CAAT.ShapeActor.superclass.constructor.call(this);this.compositeOp="source-over";this.setShape(this.SHAPE_CIRCLE);return this};CAAT.ShapeActor.prototype={shape:0,compositeOp:null,SHAPE_CIRCLE:0,SHAPE_RECTANGLE:1,setShape:function(a){this.shape=a;this.paint=this.shape===this.SHAPE_CIRCLE?this.paintCircle:this.paintRectangle;return this},setCompositeOp:function(a){this.compositeOp=a;return this},paint:function(a,b){},paintCircle:function(b,c){var a=b.crc;a.globalCompositeOperation=this.compositeOp;if(null!==this.fillStyle){a.fillStyle=this.fillStyle;a.beginPath();a.arc(this.width/2,this.height/2,Math.min(this.width,this.height)/2,0,2*Math.PI,false);a.fill()}if(null!==this.strokeStyle){a.strokeStyle=this.strokeStyle;a.beginPath();a.arc(this.width/2,this.height/2,Math.min(this.width,this.height)/2,0,2*Math.PI,false);a.stroke()}},paintRectangle:function(b,c){var a=b.crc;a.globalCompositeOperation=this.compositeOp;if(null!==this.fillStyle){a.fillStyle=this.fillStyle;a.beginPath();a.fillRect(0,0,this.width,this.height);a.fill()}if(null!==this.strokeStyle){a.strokeStyle=this.strokeStyle;a.beginPath();a.strokeRect(0,0,this.width,this.height);a.stroke()}}};extend(CAAT.ShapeActor,CAAT.ActorContainer,null)})();(function(){CAAT.StarActor=function(){CAAT.StarActor.superclass.constructor.call(this);this.compositeOp="source-over";return this};CAAT.StarActor.prototype={nPeaks:0,maxRadius:0,minRadius:0,initialAngle:0,compositeOp:null,setFilled:function(a){return this},setOutlined:function(a){return this},setCompositeOp:function(a){this.compositeOp=a;return this},setInitialAngle:function(a){this.initialAngle=a;return this},initialize:function(c,a,b){this.setSize(2*a,2*a);this.nPeaks=c;this.maxRadius=a;this.minRadius=b;return this},paint:function(b,a){var o=b.ctx;var k=this.width/2;var h=this.height/2;var e=this.maxRadius;var c=this.minRadius;var g=k+e*Math.cos(this.initialAngle);var d=h+e*Math.sin(this.initialAngle);o.globalCompositeOperation=this.compositeOp;o.beginPath();o.moveTo(g,d);for(var l=1;l<this.nPeaks*2;l++){var f=Math.PI/this.nPeaks*l+this.initialAngle;var j=(l%2===0)?e:c;var n=k+j*Math.cos(f);var m=h+j*Math.sin(f);o.lineTo(n,m)}o.lineTo(k+e*Math.cos(this.initialAngle),h+e*Math.sin(this.initialAngle));o.closePath();if(this.fillStyle){o.fillStyle=this.fillStyle;o.fill()}if(this.strokeStyle){o.strokeStyle=this.strokeStyle;o.stroke()}}};extend(CAAT.StarActor,CAAT.ActorContainer,null)})();(function(){CAAT.IMActor=function(){CAAT.IMActor.superclass.constructor.call(this);return this};CAAT.IMActor.prototype={imageProcessor:null,changeTime:100,lastApplicationTime:-1,setImageProcessor:function(a){this.imageProcessor=a;return this},setImageProcessingTime:function(a){this.changeTime=a;return this},paint:function(b,c){if(c-this.lastApplicationTime>this.changeTime){this.imageProcessor.apply(b,c);this.lastApplicationTime=c}var a=b.ctx;this.imageProcessor.paint(b,c)}};extend(CAAT.IMActor,CAAT.ActorContainer,null)})();(function(){CAAT.AudioManager=function(){this.browserInfo=new CAAT.BrowserDetect();return this};CAAT.AudioManager.prototype={browserInfo:null,musicEnabled:true,fxEnabled:true,audioCache:null,channels:null,workingChannels:null,loopingChannels:[],audioTypes:{mp3:"audio/mpeg;",ogg:'audio/ogg; codecs="vorbis"',wav:'audio/wav; codecs="1"',mp4:'audio/mp4; codecs="mp4a.40.2"'},initialize:function(b){this.audioCache=[];this.channels=[];this.workingChannels=[];for(var a=0;a<b;a++){var d=document.createElement("audio");if(null!==d){d.finished=-1;this.channels.push(d);var c=this;d.addEventListener("ended",function(f){var g=f.target;var e;for(e=0;e<c.workingChannels.length;e++){if(c.workingChannels[e]===g){c.workingChannels.splice(e,1);break}}if(g.caat_callback){g.caat_callback(g.caat_id)}c.channels.push(g)},false)}}return this},addAudioFromURL:function(f,a,d){var e=null;var c=document.createElement("audio");if(null!==c){if(!c.canPlayType){return false}e=a.substr(a.lastIndexOf(".")+1);var b=c.canPlayType(this.audioTypes[e]);if(b!==""&&b!=="no"){c.src=a;c.preload="auto";c.load();if(d){c.caat_callback=d;c.caat_id=f}this.audioCache.push({id:f,audio:c});return true}}return false},addAudioFromDomNode:function(d,a,b){var c=a.src.substr(a.src.lastIndexOf(".")+1);if(a.canPlayType(this.audioTypes[c])){if(b){a.caat_callback=b;a.caat_id=d}this.audioCache.push({id:d,audio:a});return true}return false},addAudioElement:function(d,a,b){if(typeof a==="string"){return this.addAudioFromURL(d,a,b)}else{try{if(a instanceof HTMLAudioElement){return this.addAudioFromDomNode(d,a,b)}}catch(c){}}return false},addAudio:function(d,b,c){if(b instanceof Array){for(var a=0;a<b.length;a++){if(this.addAudioElement(d,b[a],c)){break}}}else{this.addAudioElement(d,b,c)}return this},getAudio:function(b){for(var a=0;a<this.audioCache.length;a++){if(this.audioCache[a].id===b){return this.audioCache[a].audio}}return null},play:function(c){if(!this.fxEnabled){return this}var b=this.getAudio(c);if(null!==b&&this.channels.length>0){var a=this.channels.shift();a.src=b.src;a.load();a.play();this.workingChannels.push(a)}return this},loop:function(c){if(!this.musicEnabled){return this}var a=this.getAudio(c);if(null!==a){var b=document.createElement("audio");if(null!==b){b.src=a.src;b.preload="auto";if(this.browserInfo.browser==="Firefox"){b.addEventListener("ended",function(d){var e=d.target;e.currentTime=0},false)}else{b.loop=true}b.load();b.play();this.loopingChannels.push(b);return b}}return null},endSound:function(){var a;for(a=0;a<this.workingChannels.length;a++){this.workingChannels[a].pause();this.channels.push(this.workingChannels[a])}for(a=0;a<this.loopingChannels.length;a++){this.loopingChannels[a].pause()}return this},setSoundEffectsEnabled:function(a){this.fxEnabled=a;return this},isSoundEffectsEnabled:function(){return this.fxEnabled},setMusicEnabled:function(a){this.musicEnabled=a;for(var b=0;b<this.loopingChannels.length;b++){if(a){this.loopingChannels[b].play()}else{this.loopingChannels[b].pause()}}return this},isMusicEnabled:function(){return this.musicEnabled}}})();(function(){CAAT.Dock=function(){CAAT.Dock.superclass.constructor.call(this);return this};CAAT.Dock.prototype={scene:null,ttask:null,minSize:0,maxSize:0,range:2,layoutOp:0,OP_LAYOUT_BOTTOM:0,OP_LAYOUT_TOP:1,OP_LAYOUT_LEFT:2,OP_LAYOUT_RIGHT:3,initialize:function(a){this.scene=a;return this},setApplicationRange:function(a){this.range=a;return this},setLayoutOp:function(a){this.layoutOp=a;return this},setSizes:function(c,a){this.minSize=c;this.maxSize=a;for(var b=0;b<this.childrenList.length;b++){this.childrenList[b].width=c;this.childrenList[b].height=c}return this},layout:function(){var d,e;if(this.layoutOp===this.OP_LAYOUT_BOTTOM||this.layoutOp===this.OP_LAYOUT_TOP){var c=0,b=0;for(d=0;d<this.getNumChildren();d++){c+=this.getChildAt(d).width}b=(this.width-c)/2;for(d=0;d<this.getNumChildren();d++){e=this.getChildAt(d);e.x=b;b+=e.width;if(this.layoutOp===this.OP_LAYOUT_BOTTOM){e.y=this.maxSize-e.height}else{e.y=0}}}else{var f=0,a=0;for(d=0;d<this.getNumChildren();d++){f+=this.getChildAt(d).height}a=(this.height-f)/2;for(d=0;d<this.getNumChildren();d++){e=this.getChildAt(d);e.y=a;a+=e.height;if(this.layoutOp===this.OP_LAYOUT_LEFT){e.x=0}else{e.x=this.width-e.width}}}},mouseMove:function(a){this.actorNotPointed()},mouseExit:function(a){this.actorNotPointed()},actorNotPointed:function(){var a;var c=this;for(a=0;a<this.getNumChildren();a++){var b=this.getChildAt(a);b.emptyBehaviorList();b.addBehavior(new CAAT.GenericBehavior().setValues(b.width,this.minSize,b,"width").setFrameTime(this.scene.time,250)).addBehavior(new CAAT.GenericBehavior().setValues(b.height,this.minSize,b,"height").setFrameTime(this.scene.time,250));if(a===this.getNumChildren()-1){b.behaviorList[0].addListener({behaviorApplied:function(f,h,d,e,g){e.parent.layout()},behaviorExpired:function(e,f,d){for(a=0;a<c.getNumChildren();a++){b=c.getChildAt(a);b.width=c.minSize;b.height=c.minSize}d.parent.layout()}})}}},actorPointed:function(a,h,f){var c=this.findChild(f);var b=0;if(this.layoutOp===this.OP_LAYOUT_BOTTOM||this.layoutOp===this.OP_LAYOUT_TOP){b=a/f.width}else{b=h/f.height}var d;for(d=0;d<this.childrenList.length;d++){var e=this.childrenList[d];e.emptyBehaviorList();var g=0;if(d<c-this.range||d>c+this.range){g=this.minSize}else{if(d===c){g=this.maxSize}else{if(d<c){g=this.minSize+(this.maxSize-this.minSize)*(Math.cos((d-c-b+1)/this.range*Math.PI)+1)/2}else{g=this.minSize+(this.maxSize-this.minSize)*(Math.cos((d-c-b)/this.range*Math.PI)+1)/2}}}e.height=g;e.width=g}this.layout()},actorMouseExit:function(b){if(null!==this.ttask){this.ttask.cancel()}this.ttask=this.scene.createTimer(this.scene.time,100,function a(c,e,d){b.source.parent.actorNotPointed()},null,null)},actorMouseEnter:function(a){if(null!==this.ttask){this.ttask.cancel();this.ttask=null}},addChild:function(a){var b=this;a.__Dock_mouseEnter=a.mouseEnter;a.__Dock_mouseExit=a.mouseExit;a.__Dock_mouseMove=a.mouseMove;a.mouseEnter=function(c){b.actorMouseEnter(c);c.source.__Dock_mouseEnter(c)};a.mouseExit=function(c){b.actorMouseExit(c);c.source.__Dock_mouseExit(c)};a.mouseMove=function(c){b.actorPointed(c.point.x,c.point.y,c.source);c.source.__Dock_mouseMove(c)};a.width=this.minSize;a.height=this.minSize;return CAAT.Dock.superclass.addChild.call(this,a)}};extend(CAAT.Dock,CAAT.ActorContainer,null)})();(function(){CAAT.Director=function(){CAAT.Director.superclass.constructor.call(this);this.browserInfo=new CAAT.BrowserDetect();this.audioManager=new CAAT.AudioManager().initialize(8);this.scenes=[];this.mousePoint=new CAAT.Point(0,0,0);this.prevMousePoint=new CAAT.Point(0,0,0);this.screenMousePoint=new CAAT.Point(0,0,0);this.isMouseDown=false;this.lastSelectedActor=null;this.dragging=false;return this};CAAT.Director.prototype={debug:false,onRenderStart:null,onRenderEnd:null,mousePoint:null,prevMousePoint:null,screenMousePoint:null,isMouseDown:false,lastSelectedActor:null,dragging:false,scenes:null,currentScene:null,canvas:null,crc:null,ctx:null,time:0,timeline:0,imagesCache:null,audioManager:null,clear:true,transitionScene:null,browserInfo:null,gl:null,glEnabled:false,glTextureManager:null,glTtextureProgram:null,glColorProgram:null,pMatrix:null,coords:null,coordsIndex:0,uv:null,uvIndex:0,front_to_back:false,currentTexturePage:0,currentOpacity:1,intervalId:null,frameCounter:0,RESIZE_NONE:1,RESIZE_WIDTH:2,RESIZE_HEIGHT:4,RESIZE_BOTH:8,RESIZE_PROPORTIONAL:16,resize:1,getRenderType:function(){return this.glEnabled?"WEBGL":"CANVAS"},windowResized:function(a,b){switch(this.resize){case this.RESIZE_WIDTH:this.setBounds(0,0,a,this.height);break;case this.RESIZE_HEIGHT:this.setBounds(0,0,this.width,b);break;case this.RESIZE_BOTH:this.setBounds(0,0,a,b);break;case this.RESIZE_PROPORTIONAL:this.setScaleProportional(a,b);break}},setScaleProportional:function(a,c){var b=Math.min(a/this.referenceWidth,c/this.referenceHeight);this.setScaleAnchored(b,b,0,0);this.canvas.width=this.referenceWidth*b;this.canvas.height=this.referenceHeight*b;this.ctx=this.canvas.getContext(this.glEnabled?"experimental-webgl":"2d");this.crc=this.ctx;if(this.glEnabled){this.glReset()}},enableResizeEvents:function(a){if(a===this.RESIZE_BOTH||a===this.RESIZE_WIDTH||a===this.RESIZE_HEIGHT||a===this.RESIZE_PROPORTIONAL){this.referenceWidth=this.width;this.referenceHeight=this.height;this.resize=a;CAAT.registerResizeListener(this)}else{CAAT.unregisterResizeListener(this)}},setBounds:function(a,e,b,d){CAAT.Director.superclass.setBounds.call(this,a,e,b,d);this.canvas.width=b;this.canvas.height=d;this.ctx=this.canvas.getContext(this.glEnabled?"experimental-webgl":"2d");this.crc=this.ctx;for(var c=0;c<this.scenes.length;c++){this.scenes[c].setBounds(0,0,b,d)}if(this.glEnabled){this.glReset()}return this},initialize:function(d,a,c){c=c||document.createElement("canvas");this.canvas=c;this.setBounds(0,0,d,a);this.create();this.enableEvents();this.timeline=new Date().getTime();this.transitionScene=new CAAT.Scene().create().setBounds(0,0,d,a);var e=document.createElement("canvas");e.width=d;e.height=a;var b=new CAAT.Actor().create().setBackgroundImage(e);this.transitionScene.ctx=e.getContext("2d");this.transitionScene.addChildImmediately(b);this.transitionScene.setEaseListener(this);return this},glReset:function(){this.pMatrix=makeOrtho(0,this.canvas.width,this.canvas.height,0,-1,1);this.gl.viewport(0,0,this.canvas.width,this.canvas.height);this.glColorProgram.setMatrixUniform(this.pMatrix);this.glTextureProgram.setMatrixUniform(this.pMatrix);this.gl.viewportWidth=this.canvas.width;this.gl.viewportHeight=this.canvas.height},initializeGL:function(f,b,c){c=c||document.createElement("canvas");c.width=f;c.height=b;var d;try{this.gl=c.getContext("experimental-webgl");this.gl.viewportWidth=f;this.gl.viewportHeight=b}catch(g){}if(this.gl){this.canvas=c;this.create();this.setBounds(0,0,f,b);this.crc=this.ctx;this.enableEvents();this.timeline=new Date().getTime();this.glColorProgram=new CAAT.ColorProgram(this.gl).create().initialize();this.glTextureProgram=new CAAT.TextureProgram(this.gl).create().initialize();this.glTextureProgram.useProgram();this.glReset();var a=2048;this.coords=new Float32Array(a*12);this.uv=new Float32Array(a*8);this.gl.clearColor(0,0,0,255);if(this.front_to_back){this.gl.clearDepth(1);this.gl.enable(this.gl.DEPTH_TEST);this.gl.depthFunc(this.gl.LESS)}else{this.gl.disable(this.gl.DEPTH_TEST)}this.gl.enable(this.gl.BLEND);this.gl.blendFunc(this.gl.SRC_ALPHA,this.gl.ONE_MINUS_SRC_ALPHA);this.glEnabled=true}else{return this.initialize(f,b,c)}return this},createScene:function(){var a=new CAAT.Scene().create();this.addScene(a);return a},setImagesCache:function(e,a,d){var b;if(null!==this.glTextureManager){this.glTextureManager.deletePages();this.glTextureManager=null}if(this.imagesCache){var c=[];for(b=0;b<this.imagesCache.length;b++){c.push(this.imagesCache[b].id)}for(b=0;b<c.length;b++){delete this.imagesCache[c[b]]}}this.imagesCache=e;if(e){for(b=0;b<e.length;b++){this.imagesCache[e[b].id]=e[b].image}}this.tpW=a||2048;this.tpH=d||2048;this.updateGLPages()},updateGLPages:function(){if(this.glEnabled){this.glTextureManager=new CAAT.GLTexturePageManager();this.glTextureManager.createPages(this.gl,this.tpW,this.tpH,this.imagesCache);this.currentTexturePage=this.glTextureManager.pages[0];this.glTextureProgram.setTexture(this.currentTexturePage.texture)}},addImage:function(d,c,b){if(this.getImage(d)){for(var a=0;a<this.imagesCache.length;a++){if(this.imagesCache[a].id===d){this.imagesCache[a].image=c;break}}this.imagesCache[d]=c}else{this.imagesCache.push({id:d,image:c});this.imagesCache[d]=c}if(!!!b){this.updateGLPages()}},deleteImage:function(c,b){for(var a=0;a<this.imagesCache.length;a++){if(this.imagesCache[a].id===c){delete this.imagesCache[c];this.imagesCache.splice(a,1);break}}if(!!!b){this.updateGLPages()}},setGLCurrentOpacity:function(a){this.currentOpacity=a;this.glTextureProgram.setAlpha(a)},glRender:function(e,d,b){e=e||this.coords;b=b||this.uv;d=d||this.coordsIndex;var f=this.gl;var c=d/12*2;var a=d/3;this.glTextureProgram.updateVertexBuffer(e);this.glTextureProgram.updateUVBuffer(b);f.drawElements(f.TRIANGLES,3*c,f.UNSIGNED_SHORT,0)},glFlush:function(){if(this.coordsIndex!==0){this.glRender(this.coords,this.coordsIndex,this.uv)}this.coordsIndex=0;this.uvIndex=0},render:function(e){this.time+=e;this.animate(this,e);var d=this.childrenList.length;var a,b;if(this.glEnabled){this.gl.clear(this.gl.COLOR_BUFFER_BIT|this.gl.DEPTH_BUFFER_BIT);this.coordsIndex=0;this.uvIndex=0;for(a=0;a<d;a++){var f=this.childrenList[a];if(f.isInAnimationFrame(this.time)){b=f.time-f.start_time;if(f.onRenderStart){f.onRenderStart(b)}f.paintActorGL(this,b);if(f.onRenderEnd){f.onRenderEnd(b)}f.time+=e}}this.glFlush()}else{this.ctx.globalAlpha=1;this.ctx.globalCompositeOperation="source-over";if(this.clear){this.ctx.clearRect(0,0,this.width,this.height)}for(a=0;a<d;a++){var f=this.childrenList[a];if(f.isInAnimationFrame(this.time)){b=f.time-f.start_time;this.ctx.save();if(f.onRenderStart){f.onRenderStart(b)}f.paintActor(this,b);if(f.onRenderEnd){f.onRenderEnd(b)}this.ctx.restore();if(this.debug){this.ctx.strokeStyle="red";f.drawScreenBoundingBox(this,b)}f.time+=e}}}this.frameCounter++},animate:function(a,d){this.setModelViewMatrix(this);for(var b=0;b<this.childrenList.length;b++){var c=this.childrenList[b].time-this.childrenList[b].start_time;this.childrenList[b].animate(this,c)}return this},renderToContext:function(a,d){if(d.isInAnimationFrame(this.time)){a.globalAlpha=1;a.globalCompositeOperation="source-over";a.clearRect(0,0,this.width,this.height);a.setTransform(1,0,0,0,1,0);var e=this.ctx;var c=this.crc;this.ctx=this.crc=a;a.save();var b=this.worldModelViewMatrix;this.worldModelViewMatrix=new CAAT.Matrix();this.wdirty=true;d.animate(this,d.time);if(d.onRenderStart){d.onRenderStart(d.time)}d.paintActor(this,d.time);if(d.onRenderEnd){d.onRenderEnd(d.time)}this.worldModelViewMatrix=b;a.restore();this.ctx=e;this.crc=c}},addScene:function(a){a.setBounds(0,0,this.width,this.height);this.scenes.push(a);a.setEaseListener(this);if(null===this.currentScene){this.setScene(0)}},getNumScenes:function(){return this.scenes.length},easeInOut:function(b,i,d,c,f,l,e,g,a,k){if(b===this.getCurrentSceneIndex()){return}var j=this.scenes[b];var h=this.scenes[c];if(!this.glEnabled&&!navigator.browser==="iOS"){this.worldModelViewMatrix.transformRenderingContext(this.transitionScene.ctx);this.renderToContext(this.transitionScene.ctx,h);h=this.transitionScene}j.setExpired(false);h.setExpired(false);j.mouseEnabled=false;h.mouseEnabled=false;j.resetTransform();h.resetTransform();j.setLocation(0,0);h.setLocation(0,0);j.alpha=1;h.alpha=1;if(i===CAAT.Scene.prototype.EASE_ROTATION){j.easeRotationIn(e,g,d,a)}else{if(i===CAAT.Scene.prototype.EASE_SCALE){j.easeScaleIn(0,e,g,d,a)}else{j.easeTranslationIn(e,g,d,a)}}if(f===CAAT.Scene.prototype.EASE_ROTATION){h.easeRotationOut(e,g,l,k)}else{if(f===CAAT.Scene.prototype.EASE_SCALE){h.easeScaleOut(0,e,g,l,k)}else{h.easeTranslationOut(e,g,l,k)}}this.childrenList=[];this.addChild(h);this.addChild(j)},easeInOutRandom:function(j,g,d,e){var b=Math.random();var c=Math.random();var h;var a;if(b<0.33){h=CAAT.Scene.prototype.EASE_ROTATION;a=new CAAT.Interpolator().createExponentialInOutInterpolator(4)}else{if(b<0.66){h=CAAT.Scene.prototype.EASE_SCALE;a=new CAAT.Interpolator().createElasticOutInterpolator(1.1,0.4)}else{h=CAAT.Scene.prototype.EASE_TRANSLATE;a=new CAAT.Interpolator().createBounceOutInterpolator()}}var f;var i;if(c<0.33){f=CAAT.Scene.prototype.EASE_ROTATION;i=new CAAT.Interpolator().createExponentialInOutInterpolator(4)}else{if(c<0.66){f=CAAT.Scene.prototype.EASE_SCALE;i=new CAAT.Interpolator().createExponentialOutInterpolator(4)}else{f=CAAT.Scene.prototype.EASE_TRANSLATE;i=new CAAT.Interpolator().createBounceOutInterpolator()}}this.easeInOut(j,h,(Math.random()*8.99)>>0,g,f,(Math.random()*8.99)>>0,d,e,a,i)},easeIn:function(c,d,f,e,b,g){var a=this.scenes[c];if(d===CAAT.Scene.prototype.EASE_ROTATION){a.easeRotationIn(f,e,b,g)}else{if(d===CAAT.Scene.prototype.EASE_SCALE){a.easeScaleIn(0,f,e,b,g)}else{a.easeTranslationIn(f,e,b,g)}}this.childrenList=[];this.addChild(a);a.resetTransform();a.setLocation(0,0);a.alpha=1;a.mouseEnabled=false;a.setExpired(false)},setScene:function(b){var a=this.scenes[b];this.childrenList=[];this.addChild(a);this.currentScene=a;a.setExpired(false);a.mouseEnabled=true;a.resetTransform();a.setLocation(0,0);a.alpha=1;a.activated()},switchToScene:function(d,c,b,e){var a=this.getSceneIndex(this.currentScene);if(!e){this.setScene(d)}else{this.easeInOutRandom(d,a,c,b)}},switchToPrevScene:function(c,b,d){var a=this.getSceneIndex(this.currentScene);if(this.getNumScenes()<=1||a===0){return}if(!d){this.setScene(a-1)}else{this.easeInOutRandom(a-1,a,c,b)}},switchToNextScene:function(c,b,d){var a=this.getSceneIndex(this.currentScene);if(this.getNumScenes()<=1||a===this.getNumScenes()-1){return}if(!d){this.setScene(a+1)}else{this.easeInOutRandom(a+1,a,c,b)}},mouseEnter:function(a){},mouseExit:function(a){},mouseMove:function(a){},mouseDown:function(a){},mouseUp:function(a){},mouseDrag:function(a){},easeEnd:function(b,a){if(!a){b.setExpired(true)}else{this.currentScene=b;this.currentScene.activated()}b.mouseEnabled=true;b.emptyBehaviorList()},getSceneIndex:function(b){for(var a=0;a<this.scenes.length;a++){if(this.scenes[a]===b){return a}}return -1},getScene:function(a){return this.scenes[a]},getCurrentSceneIndex:function(){return this.getSceneIndex(this.currentScene)},getBrowserName:function(){return this.browserInfo.browser},getBrowserVersion:function(){return this.browserInfo.version},getOSName:function(){return this.browserInfo.OS},getImage:function(b){var a=this.imagesCache[b];if(a){return a}for(var c=0;c<this.imagesCache.length;c++){if(this.imagesCache[c].id===b){return this.imagesCache[c].image}}return null},addAudio:function(b,a){this.audioManager.addAudio(b,a);return this},audioPlay:function(a){this.audioManager.play(a)},audioLoop:function(a){return this.audioManager.loop(a)},endSound:function(){return this.audioManager.endSound()},setSoundEffectsEnabled:function(a){return this.audioManager.setSoundEffectsEnabled(a)},setMusicEnabled:function(a){return this.audioManager.setMusicEnabled(a)},isMusicEnabled:function(){return this.audioManager.isMusicEnabled()},isSoundEffectsEnabled:function(){return this.audioManager.isSoundEffectsEnabled()},emptyScenes:function(){this.scenes=[]},addChild:function(a){a.parent=this;this.childrenList.push(a)},loop:function(b,c,a){if(a){this.onRenderStart=c;this.onRenderEnd=a}else{if(c){this.onRenderEnd=c}}CAAT.loop()},renderFrame:function(b,d){var a=new Date().getTime(),c=a-this.timeline;if(this.onRenderStart){this.onRenderStart(c)}this.render(c);this.timeline=a;if(this.onRenderEnd){this.onRenderEnd(c)}},endLoop:function(){},setClear:function(a){this.clear=a;return this},getAudioManager:function(){return this.audioManager},cumulateOffset:function(d,c,h){var f=h+"Left";var e=h+"Top";var a=0,g=0,b;while(d&&d.style){if(d.currentStyle){b=d.currentStyle.position}else{b=(d.ownerDocument.defaultView||d.ownerDocument.parentWindow).getComputedStyle(d,null);b=b?b.getPropertyValue("position"):null}if(!/^(fixed)$/.test(b)){a+=d[f];g+=d[e];d=d[c]}else{break}}return{x:a,y:g,style:b}},getOffset:function(c){var a=this.cumulateOffset(c,"offsetParent","offset");if(a.style==="fixed"){var b=this.cumulateOffset(c,c.parentNode?"parentNode":"parentElement","scroll");return{x:a.x+b.x,y:a.y+b.y}}return{x:a.x,y:a.y}},getCanvasCoord:function(b,c){var a=0;var f=0;if(!c){c=window.event}if(c.pageX||c.pageY){a=c.pageX;f=c.pageY}else{if(c.clientX||c.clientY){a=c.clientX+document.body.scrollLeft+document.documentElement.scrollLeft;f=c.clientY+document.body.scrollTop+document.documentElement.scrollTop}}var d=this.getOffset(c.target);a-=d.x;f-=d.y;b.set(a,f);this.screenMousePoint.set(a,f)},enableEvents:function(){CAAT.RegisterDirector(this);var b=this.canvas;var c=this;b.addEventListener("mouseup",function(d){d.preventDefault();c.isMouseDown=false;c.getCanvasCoord(c.mousePoint,d);var f;if(null!==c.lastSelectedActor){f=c.lastSelectedActor.viewToModel(new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0));c.lastSelectedActor.mouseUp(new CAAT.MouseEvent().init(f.x,f.y,d,c.lastSelectedActor,c.screenMousePoint))}if(!c.dragging){if(null!==c.lastSelectedActor){c.lastSelectedActor.mouseClick(new CAAT.MouseEvent().init(f.x,f.y,d,c.lastSelectedActor,c.screenMousePoint))}}else{c.dragging=false}},false);b.addEventListener("mousedown",function(g){g.preventDefault();c.getCanvasCoord(c.mousePoint,g);c.isMouseDown=true;c.lastSelectedActor=c.findActorAtPosition(c.mousePoint,new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0));var f=c.mousePoint.x;var d=c.mousePoint.y;if(null!==c.lastSelectedActor){c.lastSelectedActor.viewToModel(c.mousePoint);c.prevMousePoint.x=f;c.prevMousePoint.y=d;c.lastSelectedActor.mouseDown(new CAAT.MouseEvent().init(c.mousePoint.x,c.mousePoint.y,g,c.lastSelectedActor,c.screenMousePoint))}},false);b.addEventListener("mouseover",function(d){d.preventDefault();c.getCanvasCoord(c.mousePoint,d);c.lastSelectedActor=c.findActorAtPosition(c.mousePoint,new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0));if(null!==c.lastSelectedActor){var f=new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0);c.lastSelectedActor.viewToModel(f);c.lastSelectedActor.mouseEnter(new CAAT.MouseEvent().init(f.x,f.y,d,c.lastSelectedActor,c.screenMousePoint))}},false);b.addEventListener("mouseout",function(d){d.preventDefault();if(null!==c.lastSelectedActor){c.getCanvasCoord(c.mousePoint,d);var f=new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0);c.lastSelectedActor.viewToModel(f);c.lastSelectedActor.mouseExit(new CAAT.MouseEvent().init(f.x,f.y,d,c.lastSelectedActor,c.screenMousePoint));c.lastSelectedActor=null}c.isMouseDown=false},false);b.addEventListener("mousemove",function(f){f.preventDefault();c.getCanvasCoord(c.mousePoint,f);if(c.isMouseDown&&null!==c.lastSelectedActor){if(!c.dragging){if(Math.abs(c.prevMousePoint.x-c.mousePoint.x)<CAAT.DRAG_THRESHOLD_X&&Math.abs(c.prevMousePoint.y-c.mousePoint.y)<CAAT.DRAG_THRESHOLD_Y){return}}c.dragging=true;if(null!==c.lastSelectedActor.parent){c.lastSelectedActor.parent.viewToModel(c.mousePoint)}c.lastSelectedActor.mouseDrag(new CAAT.MouseEvent().init(c.mousePoint.x,c.mousePoint.y,f,c.lastSelectedActor,c.screenMousePoint));return}var g=c.findActorAtPosition(c.mousePoint,new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0));var h=g.viewToModel(new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0));if(g!==c.lastSelectedActor){if(null!==c.lastSelectedActor){var d=c.lastSelectedActor.viewToModel(new CAAT.Point(c.mousePoint.x,c.mousePoint.y,0));c.lastSelectedActor.mouseExit(new CAAT.MouseEvent().init(d.x,d.y,f,c.lastSelectedActor,c.screenMousePoint))}if(null!==g){g.mouseEnter(new CAAT.MouseEvent().init(h.x,h.y,f,g,c.screenMousePoint))}}c.lastSelectedActor=g;if(null!==g){c.lastSelectedActor.mouseMove(new CAAT.MouseEvent().init(h.x,h.y,f,c.lastSelectedActor,c.screenMousePoint))}},false);b.addEventListener("dblclick",function(d){d.preventDefault();c.getCanvasCoord(c.mousePoint,d);if(null!==c.lastSelectedActor){c.lastSelectedActor.viewToModel(c.mousePoint.x,c.mousePoint.y);c.lastSelectedActor.mouseDblClick(new CAAT.MouseEvent().init(c.mousePoint.x,c.mousePoint.y,d,c.lastSelectedActor,c.screenMousePoint))}},false);function a(f){var g=f.changedTouches,h=g[0],d="";switch(f.type){case"touchstart":d="mousedown";break;case"touchmove":d="mousemove";break;case"touchend":d="mouseup";break;default:return}var e=document.createEvent("MouseEvent");e.initMouseEvent(d,true,true,c.canvas,1,h.screenX,h.screenY,h.clientX,h.clientY,false,false,false,false,0,null);c.canvas.dispatchEvent(e);f.preventDefault()}b.addEventListener("touchstart",a,true);b.addEventListener("touchmove",a,true);b.addEventListener("touchend",a,true);b.addEventListener("touchcancel",a,true)}};extend(CAAT.Director,CAAT.ActorContainer,null)})();(function(){CAAT.MouseEvent=function(){this.point=new CAAT.Point(0,0,0);this.screenPoint=new CAAT.Point(0,0,0);return this};CAAT.MouseEvent.prototype={screenPoint:null,point:null,time:0,source:null,shift:false,control:false,alt:false,meta:false,sourceEvent:null,init:function(a,e,c,d,b){this.point.set(a,e);this.source=d;this.screenPoint=b;this.alt=c.altKey;this.control=c.ctrlKey;this.shift=c.shiftKey;this.meta=c.metaKey;this.sourceEvent=c;this.x=a;this.y=e;return this},isAltDown:function(){return this.alt},isControlDown:function(){return this.control},isShiftDown:function(){return this.shift},isMetaDown:function(){return this.meta},getSourceEvent:function(){return this.sourceEvent}}})();CAAT.PMR=64;CAAT.DEBUG=false;CAAT.log=function(){if(window.console){window.console.log(Array.prototype.slice.call(arguments))}};CAAT.GlobalEventsEnabled=false;CAAT.prevOnDeviceMotion=null;CAAT.onDeviceMotion=null;CAAT.accelerationIncludingGravity={x:0,y:0,z:0};CAAT.rotationRate={alpha:0,beta:0,gamma:0};CAAT.DRAG_THRESHOLD_X=5;CAAT.DRAG_THRESHOLD_Y=5;CAAT.renderEnabled=false;CAAT.FPS=60;CAAT.windowResizeListeners=[];CAAT.registerResizeListener=function(a){CAAT.windowResizeListeners.push(a)};CAAT.unregisterResizeListener=function(a){for(var b=0;b<CAAT.windowResizeListeners.length;b++){if(a===CAAT.windowResizeListeners[b]){CAAT.windowResizeListeners.splice(b,1);return}}};CAAT.keyListeners=[];CAAT.registerKeyListener=function(a){CAAT.keyListeners.push(a)};CAAT.SHIFT_KEY=16;CAAT.CONTROL_KEY=17;CAAT.ALT_KEY=18;CAAT.ENTER_KEY=13;CAAT.KEY_MODIFIERS={alt:false,control:false,shift:false};CAAT.GlobalEnableEvents=function __GlobalEnableEvents(){if(CAAT.GlobalEventsEnabled){return}this.GlobalEventsEnabled=true;window.addEventListener("keydown",function(a){var c=(a.which)?a.which:a.keyCode;if(c===CAAT.SHIFT_KEY){CAAT.KEY_MODIFIERS.shift=true}else{if(c===CAAT.CONTROL_KEY){CAAT.KEY_MODIFIERS.control=true}else{if(c===CAAT.ALT_KEY){CAAT.KEY_MODIFIERS.alt=true}else{for(var b=0;b<CAAT.keyListeners.length;b++){CAAT.keyListeners[b](c,"down",{alt:CAAT.KEY_MODIFIERS.alt,control:CAAT.KEY_MODIFIERS.control,shift:CAAT.KEY_MODIFIERS.shift})}}}}},false);window.addEventListener("keyup",function(a){var c=(a.which)?a.which:a.keyCode;if(c===CAAT.SHIFT_KEY){CAAT.KEY_MODIFIERS.shift=false}else{if(c===CAAT.CONTROL_KEY){CAAT.KEY_MODIFIERS.control=false}else{if(c===CAAT.ALT_KEY){CAAT.KEY_MODIFIERS.alt=false}else{for(var b=0;b<CAAT.keyListeners.length;b++){CAAT.keyListeners[b](c,"up",{alt:CAAT.KEY_MODIFIERS.alt,control:CAAT.KEY_MODIFIERS.control,shift:CAAT.KEY_MODIFIERS.shift})}}}}},false);window.addEventListener("resize",function(a){},false)};window.requestAnimFrame=(function(){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function a(c,b){window.setTimeout(c,1000/CAAT.FPS)}})();CAAT.loop=function(a){if(CAAT.renderEnabled){return}CAAT.FPS=a||60;CAAT.renderEnabled=true;if(CAAT.NO_PERF){setInterval(function(){for(var c=0,b=CAAT.director.length;c<b;c++){CAAT.director[c].renderFrame()}},1000/CAAT.FPS)}else{CAAT.renderFrame()}};var gCAATAllowRequestAnimFrame=true;CAAT.renderFrame=function(){for(var b=0,a=CAAT.director.length;b<a;b++){CAAT.director[b].renderFrame()}if(gCAATAllowRequestAnimFrame==true){window.requestAnimFrame(CAAT.renderFrame,0)}};CAAT.setCursor=function(a){if(navigator.browser!=="iOS"){document.body.style.cursor=a}};CAAT.RegisterDirector=function __CAATGlobal_RegisterDirector(a){if(!CAAT.director){CAAT.director=[]}CAAT.director.push(a);CAAT.GlobalEnableEvents()};(function(){function a(b){CAAT.rotationRate={alpha:0,beta:b[0],gamma:b[1]}}if(window.DeviceOrientationEvent){window.addEventListener("deviceorientation",function(b){a([b.beta,b.gamma])},true)}else{if(window.DeviceMotionEvent){window.addEventListener("devicemotion",function(b){a([b.acceleration.x*2,b.acceleration.y*2])},true)}else{window.addEventListener("MozOrientation",function(b){a([-b.y*45,b.x*45])},true)}}})();(function(){CAAT.CompoundImage=function(){this.paint=this.paintN;return this};CAAT.CompoundImage.prototype={TR_NONE:0,TR_FLIP_HORIZONTAL:1,TR_FLIP_VERTICAL:2,TR_FLIP_ALL:3,image:null,rows:0,cols:0,width:0,height:0,singleWidth:0,singleHeight:0,xyCache:null,initialize:function(o,e,j){this.image=o;this.rows=e;this.cols=j;this.width=o.width;this.height=o.height;this.singleWidth=Math.floor(this.width/j);this.singleHeight=Math.floor(this.height/e);this.xyCache=[];var q,f,x;if(o.__texturePage){o.__du=this.singleWidth/o.__texturePage.width;o.__dv=this.singleHeight/o.__texturePage.height;var g=this.singleWidth;var y=this.singleHeight;var A=this.cols;if(o.inverted){var m=g;g=y;y=m;A=this.rows}var d=this.image.__tx;var p=this.image.__ty;var a=this.image.__texturePage;for(q=0;q<e*j;q++){var z=((q%A)>>0);var n=((q/A)>>0);var l=d+z*g;var k=p+n*y;var s=l+g;var b=k+y;this.xyCache.push([l/a.width,k/a.height,s/a.width,b/a.height,l,k,s,b])}}else{for(q=0;q<e*j;q++){f=((q%this.cols)|0)*this.singleWidth;x=((q/this.cols)|0)*this.singleHeight;this.xyCache.push([f,x])}}return this},paintInvertedH:function(c,b,a,d){c.save();c.translate(((0.5+a)|0)+this.singleWidth,(0.5+d)|0);c.scale(-1,1);c.drawImage(this.image,this.xyCache[b][0],this.xyCache[b][1],this.singleWidth,this.singleHeight,0,0,this.singleWidth,this.singleHeight);c.restore();return this},paintInvertedV:function(c,b,a,d){c.save();c.translate((a+0.5)|0,(0.5+d+this.singleHeight)|0);c.scale(1,-1);c.drawImage(this.image,this.xyCache[b][0],this.xyCache[b][1],this.singleWidth,this.singleHeight,0,0,this.singleWidth,this.singleHeight);c.restore();return this},paintInvertedHV:function(c,b,a,d){c.save();c.translate((a+0.5)|0,(0.5+d+this.singleHeight)|0);c.scale(1,-1);c.translate(this.singleWidth,0);c.scale(-1,1);c.drawImage(this.image,this.xyCache[b][0],this.xyCache[b][1],this.singleWidth,this.singleHeight,0,0,this.singleWidth,this.singleHeight);c.restore();return this},paintN:function(c,b,a,d){c.drawImage(this.image,this.xyCache[b][0]>>0,this.xyCache[b][1]>>0,this.singleWidth,this.singleHeight,a>>0,d>>0,this.singleWidth,this.singleHeight);return this},paint:function(c,b,a,d){return this.paintN(c,b,a,d)},paintScaled:function(d,b,a,f,c,e){d.drawImage(this.image,this.xyCache[b][0],this.xyCache[b][1],this.singleWidth,this.singleHeight,(a+0.5)|0,(f+0.5)|0,c,e);return this},getNumImages:function(){return this.rows*this.cols},setUV:function(a,c,e){var b=this.image;if(!b.__texturePage){return}var d=e;if(b.inverted){c[d++]=this.xyCache[a][2];c[d++]=this.xyCache[a][1];c[d++]=this.xyCache[a][2];c[d++]=this.xyCache[a][3];c[d++]=this.xyCache[a][0];c[d++]=this.xyCache[a][3];c[d++]=this.xyCache[a][0];c[d++]=this.xyCache[a][1]}else{c[d++]=this.xyCache[a][0];c[d++]=this.xyCache[a][1];c[d++]=this.xyCache[a][2];c[d++]=this.xyCache[a][1];c[d++]=this.xyCache[a][2];c[d++]=this.xyCache[a][3];c[d++]=this.xyCache[a][0];c[d++]=this.xyCache[a][3]}}}})();(function(){CAAT.SpriteImage=function(){this.paint=this.paintN;this.setAnimationImageIndex([0]);return this};CAAT.SpriteImage.prototype={animationImageIndex:null,prevAnimationTime:-1,changeFPS:1000,transformation:0,spriteIndex:0,TR_NONE:0,TR_FLIP_HORIZONTAL:1,TR_FLIP_VERTICAL:2,TR_FLIP_ALL:3,TR_FIXED_TO_SIZE:4,image:null,rows:1,columns:1,width:0,height:0,singleWidth:0,singleHeight:0,scaleX:1,scaleY:1,offsetX:0,offsetY:0,xyCache:null,ownerActor:null,setOwner:function(a){this.ownerActor=a;return this},getRows:function(){return this.rows},getColumns:function(){return this.columns},getRef:function(){var a=new CAAT.SpriteImage();a.image=this.image;a.rows=this.rows;a.columns=this.columns;a.width=this.width;a.height=this.height;a.singleWidth=this.singleWidth;a.singleHeight=this.singleHeight;a.xyCache=this.xyCache;a.offsetX=this.offsetX;a.offsetY=this.offsetY;a.scaleX=this.scaleX;a.scaleY=this.scaleY;return a},setOffsetX:function(a){this.offsetX=a|0;return this},setOffsetY:function(a){this.offsetY=a|0;return this},setOffset:function(a,b){this.offsetX=a;this.offsetY=b;return this},initialize:function(o,f,a){this.image=o;this.rows=f;this.columns=a;this.width=o.width;this.height=o.height;this.singleWidth=Math.floor(this.width/a);this.singleHeight=Math.floor(this.height/f);this.xyCache=[];var q,g,x;if(o.__texturePage){o.__du=this.singleWidth/o.__texturePage.width;o.__dv=this.singleHeight/o.__texturePage.height;var j=this.singleWidth;var y=this.singleHeight;var A=this.columns;if(o.inverted){var m=j;j=y;y=m;A=this.rows}var e=this.image.__tx;var p=this.image.__ty;var b=this.image.__texturePage;for(q=0;q<f*a;q++){var z=((q%A)>>0);var n=((q/A)>>0);var l=e+z*j;var k=p+n*y;var s=l+j;var d=k+y;this.xyCache.push([l/b.width,k/b.height,s/b.width,d/b.height,l,k,s,d])}}else{for(q=0;q<f*a;q++){g=((q%this.columns)|0)*this.singleWidth;x=((q/this.columns)|0)*this.singleHeight;this.xyCache.push([g,x])}}return this},paintInvertedH:function(c,d,a,e){this.setSpriteIndexAtTime(d);var b=c.ctx;b.save();b.translate(((0.5+a)|0)+this.singleWidth,(0.5+e)|0);b.scale(-1,1);b.drawImage(this.image,this.xyCache[this.spriteIndex][0],this.xyCache[this.spriteIndex][1],this.singleWidth,this.singleHeight,this.offsetX,this.offsetY,this.singleWidth,this.singleHeight);b.restore();return this},paintInvertedV:function(c,d,a,e){this.setSpriteIndexAtTime(d);var b=c.ctx;b.save();b.translate((a+0.5)|0,(0.5+e+this.singleHeight)|0);b.scale(1,-1);b.drawImage(this.image,this.xyCache[this.spriteIndex][0],this.xyCache[this.spriteIndex][1],this.singleWidth,this.singleHeight,this.offsetX,this.offsetY,this.singleWidth,this.singleHeight);b.restore();return this},paintInvertedHV:function(c,d,a,e){this.setSpriteIndexAtTime(d);var b=c.ctx;b.save();b.translate((a+0.5)|0,(0.5+e+this.singleHeight)|0);b.scale(1,-1);b.translate(this.singleWidth,0);b.scale(-1,1);b.drawImage(this.image,this.xyCache[this.spriteIndex][0],this.xyCache[this.spriteIndex][1],this.singleWidth,this.singleHeight,this.offsetX,this.offsetY,this.singleWidth,this.singleHeight);b.restore();return this},paintN:function(b,c,a,d){this.setSpriteIndexAtTime(c);b.ctx.drawImage(this.image,this.xyCache[this.spriteIndex][0]>>0,this.xyCache[this.spriteIndex][1]>>0,this.singleWidth,this.singleHeight,this.offsetX+a,this.offsetY+d,this.singleWidth,this.singleHeight);return this},paintScaled:function(b,c,a,d){this.setSpriteIndexAtTime(c);b.ctx.drawImage(this.image,this.xyCache[this.spriteIndex][0],this.xyCache[this.spriteIndex][1],this.singleWidth,this.singleHeight,(a+0.5)|0,(d+0.5)|0,this.ownerActor.width,this.ownerActor.height);return this},getCurrentSpriteImageCSSPosition:function(){return"-"+(this.xyCache[this.spriteIndex][0]-this.offsetX)+"px -"+(this.xyCache[this.spriteIndex][1]-this.offsetY)+"px"},getNumImages:function(){return this.rows*this.columns},setUV:function(d,p){var g=this.image;if(!g.__texturePage){return}var e=p;var f=this.spriteIndex;var q=this.xyCache[f][0];var o=this.xyCache[f][1];var a=this.xyCache[f][2];var m=this.xyCache[f][3];if(this.offsetX||this.offsetY){var l=this.ownerActor.width;var c=this.ownerActor.height;var i=g.__texturePage;var n=-this.offsetX/i.width;var k=-this.offsetY/i.height;var j=(l-this.offsetX)/i.width;var b=(c-this.offsetY)/i.height;q=n+g.__u;o=k+g.__v;a=j+g.__u;m=b+g.__v}if(g.inverted){d[e++]=a;d[e++]=o;d[e++]=a;d[e++]=m;d[e++]=q;d[e++]=m;d[e++]=q;d[e++]=o}else{d[e++]=q;d[e++]=o;d[e++]=a;d[e++]=o;d[e++]=a;d[e++]=m;d[e++]=q;d[e++]=m}},setChangeFPS:function(a){this.changeFPS=a;return this},setSpriteTransformation:function(a){this.transformation=a;switch(a){case this.TR_FLIP_HORIZONTAL:this.paint=this.paintInvertedH;break;case this.TR_FLIP_VERTICAL:this.paint=this.paintInvertedV;break;case this.TR_FLIP_ALL:this.paint=this.paintInvertedHV;break;case this.TR_FIXED_TO_SIZE:this.paint=this.paintScaled;break;default:this.paint=this.paintN}return this},setAnimationImageIndex:function(a){this.animationImageIndex=a;this.spriteIndex=a[0];return this},setSpriteIndex:function(a){this.spriteIndex=a;return this},setSpriteIndexAtTime:function(b){if(this.animationImageIndex.length>1){if(this.prevAnimationTime===-1){this.prevAnimationTime=b;this.spriteIndex=0}else{var a=b;a-=this.prevAnimationTime;a/=this.changeFPS;a%=this.animationImageIndex.length;this.spriteIndex=this.animationImageIndex[Math.floor(a)]}}}}})();(function(){CAAT.ImagePreloader=function(){this.images=[];return this};CAAT.ImagePreloader.prototype={images:null,notificationCallback:null,imageCounter:0,loadImages:function(e,c){if(!e){if(c){c(0,[])}}var d=this,b;this.notificationCallback=c;this.images=[];for(b=0;b<e.length;b++){this.images.push({id:e[b].id,image:new Image()})}for(b=0;b<e.length;b++){this.images[b].image.onload=function a(){d.imageCounter++;d.notificationCallback(d.imageCounter,d.images)};this.images[b].image.src=e[b].url}if(e.length===0){c(0,[])}}}})();(function(){CAAT.TimerTask=function(){return this};CAAT.TimerTask.prototype={startTime:0,duration:0,callback_timeout:null,callback_tick:null,callback_cancel:null,scene:null,taskId:0,remove:false,create:function(b,d,c,a,e){this.startTime=b;this.duration=d;this.callback_timeout=c;this.callback_tick=a;this.callback_cancel=e;return this},checkTask:function(b){var a=b;a-=this.startTime;if(a>=this.duration){this.remove=true;if(this.callback_timeout){this.callback_timeout(b,a,this)}}else{if(this.callback_tick){this.callback_tick(b,a,this)}}return this},reset:function(a){this.remove=false;this.startTime=a;this.scene.ensureTimerTask(this);return this},cancel:function(){this.remove=true;if(null!=this.callback_cancel){this.callback_cancel(this.scene.time,this.scene.time-this.startTime,this)}return this}}})();(function(){CAAT.Scene=function(){CAAT.Scene.superclass.constructor.call(this);this.timerList=[];this.fillStyle=null;return this};CAAT.Scene.prototype={easeContainerBehaviour:null,easeContainerBehaviourListener:null,easeIn:false,EASE_ROTATION:1,EASE_SCALE:2,EASE_TRANSLATE:3,timerList:null,timerSequence:0,checkTimers:function(b){var a=this.timerList.length-1;while(a>=0){if(!this.timerList[a].remove){this.timerList[a].checkTask(b)}a--}},ensureTimerTask:function(a){if(!this.hasTimer(a)){this.timerList.push(a)}return this},hasTimer:function(b){var a=this.timerList.length-1;while(a>=0){if(this.timerList[a]===b){return true}a--}return false},createTimer:function(c,e,d,a,f){var b=new CAAT.TimerTask().create(c,e,d,a,f);b.taskId=this.timerSequence++;b.sceneTime=this.time;b.scene=this;this.timerList.push(b);return b},removeExpiredTimers:function(){var a;for(a=0;a<this.timerList.length;a++){if(this.timerList[a].remove){this.timerList.splice(a,1)}}},animate:function(a,b){this.checkTimers(b);CAAT.Scene.superclass.animate.call(this,a,b);this.removeExpiredTimers()},createAlphaBehaviour:function(c,b){var a=new CAAT.AlphaBehavior();a.setFrameTime(0,c);a.startAlpha=b?0:1;a.endAlpha=b?1:0;this.easeContainerBehaviour.addBehavior(a)},easeTranslationIn:function(c,b,a,d){this.easeTranslation(c,b,a,true,d)},easeTranslationOut:function(c,b,a,d){this.easeTranslation(c,b,a,false,d)},easeTranslation:function(e,d,a,c,f){this.easeContainerBehaviour=new CAAT.ContainerBehavior();this.easeIn=c;var b=new CAAT.PathBehavior();if(f){b.setInterpolator(f)}b.setFrameTime(0,e);if(a<1){a=1}else{if(a>4){a=4}}switch(a){case CAAT.Actor.prototype.ANCHOR_TOP:if(c){b.setPath(new CAAT.Path().setLinear(0,-this.height,0,0))}else{b.setPath(new CAAT.Path().setLinear(0,0,0,-this.height))}break;case CAAT.Actor.prototype.ANCHOR_BOTTOM:if(c){b.setPath(new CAAT.Path().setLinear(0,this.height,0,0))}else{b.setPath(new CAAT.Path().setLinear(0,0,0,this.height))}break;case CAAT.Actor.prototype.ANCHOR_LEFT:if(c){b.setPath(new CAAT.Path().setLinear(-this.width,0,0,0))}else{b.setPath(new CAAT.Path().setLinear(0,0,-this.width,0))}break;case CAAT.Actor.prototype.ANCHOR_RIGHT:if(c){b.setPath(new CAAT.Path().setLinear(this.width,0,0,0))}else{b.setPath(new CAAT.Path().setLinear(0,0,this.width,0))}break}if(d){this.createAlphaBehaviour(e,c)}this.easeContainerBehaviour.addBehavior(b);this.easeContainerBehaviour.setFrameTime(this.time,e);this.easeContainerBehaviour.addListener(this);this.emptyBehaviorList();CAAT.Scene.superclass.addBehavior.call(this,this.easeContainerBehaviour)},easeScaleIn:function(d,c,b,a,e){this.easeScale(d,c,b,a,true,e);this.easeIn=true},easeScaleOut:function(d,c,b,a,e){this.easeScale(d,c,b,a,false,e);this.easeIn=false},easeScale:function(l,b,c,f,e,g){this.easeContainerBehaviour=new CAAT.ContainerBehavior();var k=0;var j=0;var a=0;var i=0;switch(f){case CAAT.Actor.prototype.ANCHOR_TOP_LEFT:case CAAT.Actor.prototype.ANCHOR_TOP_RIGHT:case CAAT.Actor.prototype.ANCHOR_BOTTOM_LEFT:case CAAT.Actor.prototype.ANCHOR_BOTTOM_RIGHT:case CAAT.Actor.prototype.ANCHOR_CENTER:a=1;i=1;break;case CAAT.Actor.prototype.ANCHOR_TOP:case CAAT.Actor.prototype.ANCHOR_BOTTOM:k=1;a=1;j=0;i=1;break;case CAAT.Actor.prototype.ANCHOR_LEFT:case CAAT.Actor.prototype.ANCHOR_RIGHT:j=1;i=1;k=0;a=1;break;default:alert("scale anchor ?? "+f)}if(!e){var d;d=k;k=a;a=d;d=j;j=i;i=d}if(c){this.createAlphaBehaviour(b,e)}var m=this.getAnchorPercent(f);var h=new CAAT.ScaleBehavior().setFrameTime(l,b).setValues(k,a,j,i,m.x,m.y);if(g){h.setInterpolator(g)}this.easeContainerBehaviour.addBehavior(h);this.easeContainerBehaviour.setFrameTime(this.time,b);this.easeContainerBehaviour.addListener(this);this.emptyBehaviorList();CAAT.Scene.superclass.addBehavior.call(this,this.easeContainerBehaviour)},addBehavior:function(a){return this},easeRotationIn:function(c,b,a,d){this.easeRotation(c,b,a,true,d);this.easeIn=true},easeRotationOut:function(c,b,a,d){this.easeRotation(c,b,a,false,d);this.easeIn=false},easeRotation:function(c,d,h,f,i){this.easeContainerBehaviour=new CAAT.ContainerBehavior();var b=0;var e=0;if(h==CAAT.Actor.prototype.ANCHOR_CENTER){h=CAAT.Actor.prototype.ANCHOR_TOP}switch(h){case CAAT.Actor.prototype.ANCHOR_TOP:case CAAT.Actor.prototype.ANCHOR_BOTTOM:case CAAT.Actor.prototype.ANCHOR_LEFT:case CAAT.Actor.prototype.ANCHOR_RIGHT:b=Math.PI*(Math.random()<0.5?1:-1);break;case CAAT.Actor.prototype.ANCHOR_TOP_LEFT:case CAAT.Actor.prototype.ANCHOR_TOP_RIGHT:case CAAT.Actor.prototype.ANCHOR_BOTTOM_LEFT:case CAAT.Actor.prototype.ANCHOR_BOTTOM_RIGHT:b=Math.PI/2*(Math.random()<0.5?1:-1);break;default:alert("rot anchor ?? "+h)}if(false===f){var g=b;b=e;e=g}if(d){this.createAlphaBehaviour(c,f)}var j=this.getAnchorPercent(h);var a=new CAAT.RotateBehavior().setFrameTime(0,c).setValues(b,e,j.x,j.y);if(i){a.setInterpolator(i)}this.easeContainerBehaviour.addBehavior(a);this.easeContainerBehaviour.setFrameTime(this.time,c);this.easeContainerBehaviour.addListener(this);this.emptyBehaviorList();CAAT.Scene.superclass.addBehavior.call(this,this.easeContainerBehaviour)},setEaseListener:function(a){this.easeContainerBehaviourListener=a},behaviorExpired:function(a){this.easeContainerBehaviourListener.easeEnd(this,this.easeIn)},activated:function(){},setExpired:function(a){this.expired=a},paint:function(b,c){if(this.fillStyle){var a=b.crc;a.fillStyle=this.fillStyle;a.fillRect(0,0,this.width,this.height)}}};extend(CAAT.Scene,CAAT.ActorContainer,null)})();CAAT.modules=CAAT.modules||{};CAAT.modules.CircleManager=CAAT.modules.CircleManager||{};(function(){CAAT.modules.CircleManager.PackedCircle=function(){this.boundsRule=CAAT.modules.CircleManager.PackedCircle.BOUNDS_RULE_IGNORE;this.position=new CAAT.Point(0,0,0);this.offset=new CAAT.Point(0,0,0);this.targetPosition=new CAAT.Point(0,0,0);return this};CAAT.modules.CircleManager.PackedCircle.prototype={id:0,delegate:null,position:new CAAT.Point(0,0,0),offset:new CAAT.Point(0,0,0),targetPosition:null,targetChaseSpeed:0.02,isFixed:false,boundsRule:0,collisionMask:0,collisionGroup:0,BOUNDS_RULE_WRAP:1,BOUNDS_RULE_CONSTRAINT:2,BOUNDS_RULE_DESTROY:4,BOUNDS_RULE_IGNORE:8,containsPoint:function(b){var a=this.position.getDistanceSquared(b);return a<this.radiusSquared},getDistanceSquaredFromPosition:function(a){var b=this.position.getDistanceSquared(a);return b<this.radiusSquared},intersects:function(a){var b=this.position.getDistanceSquared(a.position);return(b<this.radiusSquared||b<a.radiusSquared)},setPosition:function(a){this.position=a;return this},setDelegate:function(a){this.delegate=a;return this},setOffset:function(a){this.offset=a;return this},setTargetPosition:function(a){this.targetPosition=a;return this},setTargetChaseSpeed:function(a){this.targetChaseSpeed=a;return this},setIsFixed:function(a){this.isFixed=a;return this},setCollisionMask:function(a){this.collisionMask=a;return this},setCollisionGroup:function(a){this.collisionGroup=a;return this},setRadius:function(a){this.radius=a;this.radiusSquared=this.radius*this.radius;return this},initialize:function(b){if(b){for(var a in b){this[a]=b[a]}}return this},dealloc:function(){this.position=null;this.offset=null;this.delegate=null;this.targetPosition=null}}})();(function(){CAAT.modules.CircleManager.PackedCircleManager=function(){return this};CAAT.modules.CircleManager.PackedCircleManager.prototype={allCircles:[],numberOfCollisionPasses:1,numberOfTargetingPasses:0,bounds:new CAAT.Rectangle(),addCircle:function(a){a.id=this.allCircles.length;this.allCircles.push(a);return this},removeCircle:function(c){var b=0,d=false,a=this.allCircles.length;if(a===0){throw"Error: (PackedCircleManager) attempting to remove circle, and allCircles.length === 0!!"}while(a--){if(this.allCircles[a]===c){d=true;b=a;break}}if(!d){throw"Could not locate circle in allCircles array!"}this.allCircles[b].dealloc();this.allCircles[b]=null;return this},forceCirclesToMatchDelegatePositions:function(){var a=this.allCircles.length;for(var c=0;c<a;c++){var b=this.allCircles[c];if(!b||!b.delegate){continue}b.position.set(b.delegate.x+b.offset.x,b.delegate.y+b.offset.y)}},pushAllCirclesTowardTarget:function(f){var d=new CAAT.Point(0,0,0),b=this.allCircles,a=b.length;for(var h=0;h<this.numberOfTargetingPasses;h++){for(var e=0;e<a;e++){var g=b[e];if(g.isFixed){continue}d.x=g.position.x-(g.targetPosition.x+g.offset.x);d.y=g.position.y-(g.targetPosition.y+g.offset.y);d.multiply(g.targetChaseSpeed);g.position.x-=d.x;g.position.y-=d.y}}},handleCollisions:function(){this.removeExpiredElements();var l=new CAAT.Point(0,0,0),k=this.allCircles,g=k.length;for(var c=0;c<this.numberOfCollisionPasses;c++){for(var f=0;f<g;f++){var q=k[f];for(var e=f+1;e<g;e++){var o=k[e];if(!this.circlesCanCollide(q,o)){continue}var p=o.position.x-q.position.x,m=o.position.y-q.position.y;var b=(q.radius+o.radius)*1.08,h=q.position.getDistanceSquared(o.position);if(h<(b*b)-0.02){l.x=p;l.y=m;l.normalize();var a=(b-Math.sqrt(h))*0.5;l.multiply(a);if(!o.isFixed){if(q.isFixed){l.multiply(2.2)}o.position.translatePoint(l)}if(!q.isFixed){if(o.isFixed){l.multiply(2.2)}q.position.subtract(l)}}}}}},handleBoundaryForCircle:function(j,i){var b=j.position.x;var a=j.position.y;var g=j.radius;var k=g*2;var f=1<<0;var c=1<<2;var h=1<<3;var e=1<<4;var d=1<<5;i=c|h;if(i&f&&b-k>this.bounds.right){j.position.x=this.bounds.left+g}else{if(i&f&&b+k<this.bounds.left){j.position.x=this.bounds.right-g}}if(i&c&&a-k>this.bounds.bottom){j.position.y=this.bounds.top-g}else{if(i&c&&a+k<this.bounds.top){j.position.y=this.bounds.bottom+g}}if(i&h&&b+g>=this.bounds.right){j.position.x=j.position.x=this.bounds.right-g}else{if(i&h&&b-g<this.bounds.left){j.position.x=this.bounds.left+g}}if(i&e&&a+g>this.bounds.bottom){j.position.y=this.bounds.bottom-g}else{if(i&e&&a-g<this.bounds.top){j.position.y=this.bounds.top+g}}},getCircleAt:function(e,b,c){var g=this.allCircles;var f=g.length;var j=new CAAT.Point(e,b,0);var h=null;var l=Number.MAX_VALUE;for(var d=0;d<f;d++){var k=g[d];if(!k){continue}var a=k.position.getDistanceSquared(j);if(a<l&&a<k.radiusSquared+c){l=a;h=k}}return h},circlesCanCollide:function(b,a){if(!b||!a||b===a){return false}return true},setBounds:function(a,d,b,c){this.bounds.x=a;this.bounds.y=d;this.bounds.width=b;this.bounds.height=c},setNumberOfCollisionPasses:function(a){this.numberOfCollisionPasses=a;return this},setNumberOfTargetingPasses:function(a){this.numberOfTargetingPasses=a;return this},sortOnDistanceToTarget:function(c,b){var e=c.getDistanceSquaredFromPosition(c.targetPosition);var d=b.getDistanceSquaredFromPosition(c.targetPosition);var a=0;if(e>d){a=-1}else{if(e<d){a=1}}return a},removeExpiredElements:function(){for(var a=this.allCircles.length;a>=0;a--){if(this.allCircles[a]===null){this.allCircles.splice(a,1)}}},initialize:function(b){if(b){for(var a in b){this[a]=b[a]}}return this}}})();(function(){CAAT.modules.LocalStorage=function(){return this};CAAT.modules.LocalStorage.prototype={save:function(a,b){try{localStorage.setItem(a,JSON.stringify(b))}catch(c){}return this},load:function(a){try{return JSON.parse(localStorage.getItem(a))}catch(b){return null}},remove:function(a){try{localStorage.removeItem(a)}catch(b){}return this}}})();(function(){CAAT.modules.ImageUtil=function(){return this};CAAT.modules.ImageUtil.prototype={createAlphaSpriteSheet:function(b,d,a,e,g){if(b<d){var h=b;b=d;d=h}var c=document.createElement("canvas");c.width=e.width;c.height=e.height*a;var j=c.getContext("2d");j.fillStyle=g?g:"rgba(255,255,255,0)";j.fillRect(0,0,e.width,e.height*a);var f;for(f=0;f<a;f++){j.globalAlpha=1-(b-d)/a*(f+1);j.drawImage(e,0,f*e.height)}return c},rotate:function(d,e){e=e||0;if(!e){return d}var c=document.createElement("canvas");c.width=d.height;c.height=d.width;var b=c.getContext("2d");b.globalAlpha=1;b.fillStyle="rgba(0,0,0,0)";b.clearRect(0,0,c.width,c.height);var a=new CAAT.Matrix();a.multiply(new CAAT.Matrix().setTranslate(c.width/2,c.width/2));a.multiply(new CAAT.Matrix().setRotation(e*Math.PI/180));a.multiply(new CAAT.Matrix().setTranslate(-c.width/2,-c.width/2));a.transformRenderingContext(b);b.drawImage(d,0,0);return c},optimize:function(d,k){k>>=0;var c=document.createElement("canvas");c.width=d.width;c.height=d.height;var r=c.getContext("2d");r.fillStyle="rgba(0,0,0,0)";r.fillRect(0,0,d.width,d.height);r.drawImage(d,0,0);var a=r.getImageData(0,0,d.width,d.height);var g=a.data;var h,f;var o=c.height,l=0;var q=c.width,m=0;var e=false;for(h=0;h<c.height;h++){for(f=0;f<c.width;f++){if(g[h*c.width*4+3+f*4]>k){e=true;break}}if(e){break}}o=h;e=false;for(h=c.height-1;h>=o;h--){for(f=3;f<c.width*4;f+=4){if(g[h*c.width*4+3+f*4]>k){e=true;break}}if(e){break}}l=h;e=false;for(f=0;f<c.width;f++){for(h=0;h<c.height;h++){if(g[h*c.width*4+3+f*4]>k){e=true;break}}if(e){break}}q=f;e=false;for(f=c.width-1;f>=q;f--){for(h=0;h<c.height;h++){if(g[h*c.width*4+3+f*4]>k){e=true;break}}if(e){break}}m=f;if(0===q&&0===o&&c.width-1===m&&c.height-1===l){return c}var b=m-q+1;var p=l-o+1;var n=r.getImageData(q,o,b,p);c.width=b;c.height=p;r=c.getContext("2d");r.putImageData(n,0,0);return c},createThumb:function(d,i,f,a){i=i||24;f=f||24;var b=document.createElement("canvas");b.width=i;b.height=f;var j=b.getContext("2d");if(a){var g=Math.max(d.width,d.height);var e=d.width/g*i;var c=d.height/g*f;j.drawImage(d,(i-e)/2,(f-c)/2,e,c)}else{j.drawImage(d,0,0,i,f)}return b}}})();(function(){CAAT.modules.LayoutUtils={};CAAT.modules.LayoutUtils.row=function(j,h,e){var d=h;var n=e;var a=j.width;var o=0,m=0,f=0,c=0;var b=Number.MIN_VALUE,g=Number.MAX_VALUE;for(f=d.length-1;f;f-=1){if(g<d[f].width){g=d[f].width}if(b<d[f].height){b=d[f].height}}if(n.padding_left){o=n.padding_left;a-=o}if(n.padding_right){a-=n.padding_right}if(n.top){var k=parseInt(n.top,10);if(!isNaN(k)){m=k}else{switch(n.top){case"center":m=(j.height-b)/2;break;case"top":m=0;break;case"bottom":m=j.height-b;break;defatul:m=0}}}var p=a/d.length;for(f=0,c=d.length;f<c;f++){d[f].setLocation(o+f*p+(p-d[f].width)/2,m)}}})();(function(){CAAT.Interpolator=function(){this.interpolated=new CAAT.Point(0,0,0);return this};CAAT.Interpolator.prototype={interpolated:null,paintScale:90,createLinearInterpolator:function(c,b){this.getPosition=function a(e){var d=e;if(c){if(e<0.5){e*=2}else{e=1-(e-0.5)*2}}if(b!==null&&b){e=1-e}return this.interpolated.set(d,e)};return this},createBackOutInterpolator:function(b){this.getPosition=function a(e){var c=e;if(b){if(e<0.5){e*=2}else{e=1-(e-0.5)*2}}e=e-1;var d=1.70158;return this.interpolated.set(c,e*e*((d+1)*e+d)+1)};return this},createExponentialInInterpolator:function(b,c){this.getPosition=function a(e){var d=e;if(c){if(e<0.5){e*=2}else{e=1-(e-0.5)*2}}return this.interpolated.set(d,Math.pow(e,b))};return this},createExponentialOutInterpolator:function(b,c){this.getPosition=function a(e){var d=e;if(c){if(e<0.5){e*=2}else{e=1-(e-0.5)*2}}return this.interpolated.set(d,1-Math.pow(1-e,b))};return this},createExponentialInOutInterpolator:function(b,c){this.getPosition=function a(e){var d=e;if(c){if(e<0.5){e*=2}else{e=1-(e-0.5)*2}}if(e*2<1){return this.interpolated.set(d,Math.pow(e*2,b)/2)}return this.interpolated.set(d,1-Math.abs(Math.pow(e*2-2,b))/2)};return this},createQuadricBezierInterpolator:function(e,c,b,d){this.getPosition=function a(g){var f=g;if(d){if(g<0.5){g*=2}else{g=1-(g-0.5)*2}}g=(1-g)*(1-g)*e.y+2*(1-g)*g*c.y+g*g*b.y;return this.interpolated.set(f,g)};return this},createCubicBezierInterpolator:function(f,d,c,b,e){this.getPosition=function a(j){var g=j;if(e){if(j<0.5){j*=2}else{j=1-(j-0.5)*2}}var i=j*j;var h=j*i;j=(f.y+j*(-f.y*3+j*(3*f.y-f.y*j)))+j*(3*d.y+j*(-6*d.y+d.y*3*j))+i*(c.y*3-c.y*3*j)+b.y*h;return this.interpolated.set(g,j)};return this},createElasticOutInterpolator:function(a,c,d){this.getPosition=function b(f){if(d){if(f<0.5){f*=2}else{f=1-(f-0.5)*2}}if(f===0){return{x:0,y:0}}if(f===1){return{x:1,y:1}}var e=c/(2*Math.PI)*Math.asin(1/a);return this.interpolated.set(f,(a*Math.pow(2,-10*f)*Math.sin((f-e)*(2*Math.PI)/c)+1))};return this},createElasticInInterpolator:function(a,c,d){this.getPosition=function b(f){if(d){if(f<0.5){f*=2}else{f=1-(f-0.5)*2}}if(f===0){return{x:0,y:0}}if(f===1){return{x:1,y:1}}var e=c/(2*Math.PI)*Math.asin(1/a);return this.interpolated.set(f,-(a*Math.pow(2,10*(f-=1))*Math.sin((f-e)*(2*Math.PI)/c)))};return this},createElasticInOutInterpolator:function(a,c,d){this.getPosition=function b(f){if(d){if(f<0.5){f*=2}else{f=1-(f-0.5)*2}}var e=c/(2*Math.PI)*Math.asin(1/a);f*=2;if(f<=1){return this.interpolated.set(f,-0.5*(a*Math.pow(2,10*(f-=1))*Math.sin((f-e)*(2*Math.PI)/c)))}return this.interpolated.set(f,1+0.5*(a*Math.pow(2,-10*(f-=1))*Math.sin((f-e)*(2*Math.PI)/c)))};return this},bounce:function(a){if((a/=1)<(1/2.75)){return{x:a,y:7.5625*a*a}}else{if(a<(2/2.75)){return{x:a,y:7.5625*(a-=(1.5/2.75))*a+0.75}}else{if(a<(2.5/2.75)){return{x:a,y:7.5625*(a-=(2.25/2.75))*a+0.9375}}else{return{x:a,y:7.5625*(a-=(2.625/2.75))*a+0.984375}}}}},createBounceOutInterpolator:function(b){this.getPosition=function a(c){if(b){if(c<0.5){c*=2}else{c=1-(c-0.5)*2}}return this.bounce(c)};return this},createBounceInInterpolator:function(b){this.getPosition=function a(d){if(b){if(d<0.5){d*=2}else{d=1-(d-0.5)*2}}var c=this.bounce(1-d);c.y=1-c.y;return c};return this},createBounceInOutInterpolator:function(b){this.getPosition=function a(d){if(b){if(d<0.5){d*=2}else{d=1-(d-0.5)*2}}var c;if(d<0.5){c=this.bounce(1-d*2);c.y=(1-c.y)*0.5;return c}c=this.bounce(d*2-1,b);c.y=c.y*0.5+0.5;return c};return this},paint:function(a,d){var b=a.crc;b.save();b.beginPath();b.moveTo(0,this.getPosition(0).y*this.paintScale);for(var c=0;c<=this.paintScale;c++){b.lineTo(c,this.getPosition(c/this.paintScale).y*this.paintScale)}b.strokeStyle="black";b.stroke();b.restore()},getContour:function(c){var b=[];for(var a=0;a<=c;a++){b.push({x:a/c,y:this.getPosition(a/c).y})}return b},enumerateInterpolators:function(){return[new CAAT.Interpolator().createLinearInterpolator(false,false),"Linear pingpong=false, inverse=false",new CAAT.Interpolator().createLinearInterpolator(true,false),"Linear pingpong=true, inverse=false",new CAAT.Interpolator().createLinearInterpolator(false,true),"Linear pingpong=false, inverse=true",new CAAT.Interpolator().createLinearInterpolator(true,true),"Linear pingpong=true, inverse=true",new CAAT.Interpolator().createExponentialInInterpolator(2,false),"ExponentialIn pingpong=false, exponent=2",new CAAT.Interpolator().createExponentialOutInterpolator(2,false),"ExponentialOut pingpong=false, exponent=2",new CAAT.Interpolator().createExponentialInOutInterpolator(2,false),"ExponentialInOut pingpong=false, exponent=2",new CAAT.Interpolator().createExponentialInInterpolator(2,true),"ExponentialIn pingpong=true, exponent=2",new CAAT.Interpolator().createExponentialOutInterpolator(2,true),"ExponentialOut pingpong=true, exponent=2",new CAAT.Interpolator().createExponentialInOutInterpolator(2,true),"ExponentialInOut pingpong=true, exponent=2",new CAAT.Interpolator().createExponentialInInterpolator(4,false),"ExponentialIn pingpong=false, exponent=4",new CAAT.Interpolator().createExponentialOutInterpolator(4,false),"ExponentialOut pingpong=false, exponent=4",new CAAT.Interpolator().createExponentialInOutInterpolator(4,false),"ExponentialInOut pingpong=false, exponent=4",new CAAT.Interpolator().createExponentialInInterpolator(4,true),"ExponentialIn pingpong=true, exponent=4",new CAAT.Interpolator().createExponentialOutInterpolator(4,true),"ExponentialOut pingpong=true, exponent=4",new CAAT.Interpolator().createExponentialInOutInterpolator(4,true),"ExponentialInOut pingpong=true, exponent=4",new CAAT.Interpolator().createExponentialInInterpolator(6,false),"ExponentialIn pingpong=false, exponent=6",new CAAT.Interpolator().createExponentialOutInterpolator(6,false),"ExponentialOut pingpong=false, exponent=6",new CAAT.Interpolator().createExponentialInOutInterpolator(6,false),"ExponentialInOut pingpong=false, exponent=6",new CAAT.Interpolator().createExponentialInInterpolator(6,true),"ExponentialIn pingpong=true, exponent=6",new CAAT.Interpolator().createExponentialOutInterpolator(6,true),"ExponentialOut pingpong=true, exponent=6",new CAAT.Interpolator().createExponentialInOutInterpolator(6,true),"ExponentialInOut pingpong=true, exponent=6",new CAAT.Interpolator().createBounceInInterpolator(false),"BounceIn pingpong=false",new CAAT.Interpolator().createBounceOutInterpolator(false),"BounceOut pingpong=false",new CAAT.Interpolator().createBounceInOutInterpolator(false),"BounceInOut pingpong=false",new CAAT.Interpolator().createBounceInInterpolator(true),"BounceIn pingpong=true",new CAAT.Interpolator().createBounceOutInterpolator(true),"BounceOut pingpong=true",new CAAT.Interpolator().createBounceInOutInterpolator(true),"BounceInOut pingpong=true",new CAAT.Interpolator().createElasticInInterpolator(1.1,0.4,false),"ElasticIn pingpong=false, amp=1.1, d=.4",new CAAT.Interpolator().createElasticOutInterpolator(1.1,0.4,false),"ElasticOut pingpong=false, amp=1.1, d=.4",new CAAT.Interpolator().createElasticInOutInterpolator(1.1,0.4,false),"ElasticInOut pingpong=false, amp=1.1, d=.4",new CAAT.Interpolator().createElasticInInterpolator(1.1,0.4,true),"ElasticIn pingpong=true, amp=1.1, d=.4",new CAAT.Interpolator().createElasticOutInterpolator(1.1,0.4,true),"ElasticOut pingpong=true, amp=1.1, d=.4",new CAAT.Interpolator().createElasticInOutInterpolator(1.1,0.4,true),"ElasticInOut pingpong=true, amp=1.1, d=.4",new CAAT.Interpolator().createElasticInInterpolator(1,0.2,false),"ElasticIn pingpong=false, amp=1.0, d=.2",new CAAT.Interpolator().createElasticOutInterpolator(1,0.2,false),"ElasticOut pingpong=false, amp=1.0, d=.2",new CAAT.Interpolator().createElasticInOutInterpolator(1,0.2,false),"ElasticInOut pingpong=false, amp=1.0, d=.2",new CAAT.Interpolator().createElasticInInterpolator(1,0.2,true),"ElasticIn pingpong=true, amp=1.0, d=.2",new CAAT.Interpolator().createElasticOutInterpolator(1,0.2,true),"ElasticOut pingpong=true, amp=1.0, d=.2",new CAAT.Interpolator().createElasticInOutInterpolator(1,0.2,true),"ElasticInOut pingpong=true, amp=1.0, d=.2"]}}})();(function(){CAAT.InterpolatorActor=function(){CAAT.InterpolatorActor.superclass.constructor.call(this);return this};CAAT.InterpolatorActor.prototype={interpolator:null,contour:null,S:50,gap:5,setGap:function(a){this.gap=a;return this},setInterpolator:function(b,a){this.interpolator=b;this.contour=b.getContour(a||this.S);return this},paint:function(a,f){CAAT.InterpolatorActor.superclass.paint.call(this,a,f);if(this.backgroundImage){return this}if(this.interpolator){var c=a.crc;var b=(this.width-2*this.gap);var e=(this.height-2*this.gap);c.beginPath();c.moveTo(this.gap+b*this.contour[0].x,-this.gap+this.height-e*this.contour[0].y);for(var d=1;d<this.contour.length;d++){c.lineTo(this.gap+b*this.contour[d].x,-this.gap+this.height-e*this.contour[d].y)}c.strokeStyle=this.strokeStyle;c.stroke()}},getInterpolator:function(){return this.interpolator}};extend(CAAT.InterpolatorActor,CAAT.ActorContainer,null)})();(function(){CAAT.PathSegment=function(){this.bbox=new CAAT.Rectangle();return this};CAAT.PathSegment.prototype={color:"black",length:0,bbox:null,parent:null,setParent:function(a){this.parent=a;return this},setColor:function(a){if(a){this.color=a}return this},endCurvePosition:function(){},startCurvePosition:function(){},setPoints:function(a){},setPoint:function(a,b){},getPosition:function(a){},getLength:function(){return this.length},getBoundingBox:function(){return this.bbox},numControlPoints:function(){},getControlPoint:function(a){},endPath:function(){},getContour:function(a){},updatePath:function(a){},applyAsPath:function(a){},transform:function(a){}}})();(function(){CAAT.LinearPath=function(){CAAT.LinearPath.superclass.constructor.call(this);this.points=[];this.points.push(new CAAT.Point());this.points.push(new CAAT.Point());this.newPosition=new CAAT.Point(0,0,0);return this};CAAT.LinearPath.prototype={points:null,newPosition:null,applyAsPath:function(a){a.lineTo(this.points[0].x,this.points[1].y)},setPoint:function(a,b){if(b===0){this.points[0]=a}else{if(b===1){this.points[1]=a}}},updatePath:function(b){var a=this.points[1].x-this.points[0].x;var c=this.points[1].y-this.points[0].y;this.length=Math.sqrt(a*a+c*c);this.bbox.setEmpty();this.bbox.union(this.points[0].x,this.points[0].y);this.bbox.union(this.points[1].x,this.points[1].y);return this},setPoints:function(a){this.points[0]=a[0];this.points[1]=a[1];this.updatePath();return this},setInitialPosition:function(a,b){this.points[0].x=a;this.points[0].y=b;this.newPosition.set(a,b);return this},setFinalPosition:function(b,a){this.points[1].x=b;this.points[1].y=a;return this},endCurvePosition:function(){return this.points[1]},startCurvePosition:function(){return this.points[0]},getPosition:function(a){if(a>1||a<0){a%=1}if(a<0){a=1+a}this.newPosition.set((this.points[0].x+(this.points[1].x-this.points[0].x)*a),(this.points[0].y+(this.points[1].y-this.points[0].y)*a));return this.newPosition},initialPositionX:function(){return this.points[0].x},finalPositionX:function(){return this.points[1].x},paint:function(a,c){var b=a.crc;b.save();b.strokeStyle=this.color;b.beginPath();b.moveTo(this.points[0].x,this.points[0].y);b.lineTo(this.points[1].x,this.points[1].y);b.stroke();if(c){b.globalAlpha=0.5;b.fillStyle="#7f7f00";b.beginPath();b.arc(this.points[0].x,this.points[0].y,CAAT.Curve.prototype.HANDLE_SIZE/2,0,2*Math.PI,false);b.arc(this.points[1].x,this.points[1].y,CAAT.Curve.prototype.HANDLE_SIZE/2,0,2*Math.PI,false);b.fill()}b.restore()},numControlPoints:function(){return 2},getControlPoint:function(a){if(0===a){return this.points[0]}else{if(1===a){return this.points[1]}}},getContour:function(b){var a=[];a.push(this.getPosition(0).clone());a.push(this.getPosition(1).clone());return a}};extend(CAAT.LinearPath,CAAT.PathSegment)})();(function(){CAAT.CurvePath=function(){CAAT.CurvePath.superclass.constructor.call(this);this.newPosition=new CAAT.Point(0,0,0);return this};CAAT.CurvePath.prototype={curve:null,newPosition:null,applyAsPath:function(a){this.curve.applyAsPath(a);return this},setPoint:function(a,b){if(this.curve){this.curve.setPoint(a,b)}},setPoints:function(a){var b=new CAAT.Bezier();b.setPoints(a);this.curve=b;return this},setQuadric:function(a,g,c,b,e,d){var f=new CAAT.Bezier();f.setQuadric(a,g,c,b,e,d);this.curve=f;this.updatePath();return this},setCubic:function(g,e,b,a,i,h,f,d){var c=new CAAT.Bezier();c.setCubic(g,e,b,a,i,h,f,d);this.curve=c;this.updatePath();return this},updatePath:function(a){this.curve.update();this.length=this.curve.getLength();this.curve.getBoundingBox(this.bbox);return this},getPosition:function(a){if(a>1||a<0){a%=1}if(a<0){a=1+a}this.curve.solve(this.newPosition,a);return this.newPosition},getPositionFromLength:function(a){this.curve.solve(this.newPosition,a/this.length);return this.newPosition},initialPositionX:function(){return this.curve.coordlist[0].x},finalPositionX:function(){return this.curve.coordlist[this.curve.coordlist.length-1].x},paint:function(a,b){this.curve.drawHandles=b;a.ctx.strokeStyle=this.color;this.curve.paint(a)},numControlPoints:function(){return this.curve.coordlist.length},getControlPoint:function(a){return this.curve.coordlist[a]},endCurvePosition:function(){return this.curve.endCurvePosition()},startCurvePosition:function(){return this.curve.startCurvePosition()},getContour:function(c){var b=[];for(var a=0;a<=c;a++){b.push({x:a/c,y:this.getPosition(a/c).y})}return b}};extend(CAAT.CurvePath,CAAT.PathSegment,null)})();(function(){CAAT.ShapePath=function(){CAAT.ShapePath.superclass.constructor.call(this);this.points=[];this.points.push(new CAAT.Point());this.points.push(new CAAT.Point());this.points.push(new CAAT.Point());this.points.push(new CAAT.Point());this.points.push(new CAAT.Point());this.newPosition=new CAAT.Point();return this};CAAT.ShapePath.prototype={points:null,length:-1,cw:true,bbox:null,newPosition:null,applyAsPath:function(a){if(this.cw){a.lineTo(this.points[0].x,this.points[0].y);a.lineTo(this.points[1].x,this.points[1].y);a.lineTo(this.points[2].x,this.points[2].y);a.lineTo(this.points[3].x,this.points[3].y);a.lineTo(this.points[4].x,this.points[4].y)}else{a.lineTo(this.points[4].x,this.points[4].y);a.lineTo(this.points[3].x,this.points[3].y);a.lineTo(this.points[2].x,this.points[2].y);a.lineTo(this.points[1].x,this.points[1].y);a.lineTo(this.points[0].x,this.points[0].y)}return this},setPoint:function(a,b){if(b>=0&&b<this.points.length){this.points[b]=a}},setPoints:function(a){this.points=[];this.points.push(a[0]);this.points.push(new CAAT.Point().set(a[1].x,a[0].y));this.points.push(a[1]);this.points.push(new CAAT.Point().set(a[0].x,a[1].y));this.points.push(a[0].clone());this.updatePath();return this},setClockWise:function(a){this.cw=a!==undefined?a:true;return this},isClockWise:function(){return this.cw},setInitialPosition:function(a,d){for(var c=0,b=this.points.length;c<b;c++){this.points[c].x=a;this.points[c].y=d}return this},setFinalPosition:function(b,a){this.points[2].x=b;this.points[2].y=a;this.points[1].x=b;this.points[1].y=this.points[0].y;this.points[3].x=this.points[0].x;this.points[3].y=a;this.points[4].x=this.points[0].x;this.points[4].y=this.points[0].y;this.updatePath();return this},endCurvePosition:function(){return this.points[4]},startCurvePosition:function(){return this.points[0]},getPosition:function(b){if(b>1||b<0){b%=1}if(b<0){b=1+b}if(-1===this.length){this.newPosition.set(0,0)}else{var f=this.bbox.width/this.length;var c=this.bbox.height/this.length;var j=0;var a;var d;var e=0;if(this.cw){d=[0,1,2,3,4];a=[f,c,f,c]}else{d=[4,3,2,1,0];a=[c,f,c,f]}while(e<a.length){if(j+a[e]<b){j+=a[e];e++}else{break}}b-=j;var i=d[e];var g=d[e+1];this.newPosition.set((this.points[i].x+(this.points[g].x-this.points[i].x)*b/a[e]),(this.points[i].y+(this.points[g].y-this.points[i].y)*b/a[e]))}return this.newPosition},initialPositionX:function(){return this.points[0].x},finalPositionX:function(){return this.points[2].x},paint:function(a,d){var b=a.crc;b.save();b.strokeStyle=this.color;b.beginPath();b.strokeRect(this.bbox.x,this.bbox.y,this.bbox.width,this.bbox.height);if(d){b.globalAlpha=0.5;b.fillStyle="#7f7f00";for(var c=0;c<this.points.length;c++){b.beginPath();b.arc(this.points[c].x,this.points[c].y,CAAT.Curve.prototype.HANDLE_SIZE/2,0,2*Math.PI,false);b.fill()}}b.restore()},numControlPoints:function(){return this.points.length},getControlPoint:function(a){return this.points[a]},getContour:function(c){var b=[];for(var a=0;a<this.points.length;a++){b.push(this.points[a])}return b},updatePath:function(a){if(a){if(a===this.points[0]){this.points[1].y=a.y;this.points[3].x=a.x}else{if(a===this.points[1]){this.points[0].y=a.y;this.points[2].x=a.x}else{if(a===this.points[2]){this.points[3].y=a.y;this.points[1].x=a.x}else{if(a===this.points[3]){this.points[0].x=a.x;this.points[2].y=a.y}}}}this.points[4].x=this.points[0].x;this.points[4].y=this.points[0].y}this.bbox.setEmpty();for(var b=0;b<4;b++){this.bbox.union(this.points[b].x,this.points[b].y)}this.length=2*this.bbox.width+2*this.bbox.height;this.points[0].x=this.bbox.x;this.points[0].y=this.bbox.y;this.points[1].x=this.bbox.x+this.bbox.width;this.points[1].y=this.bbox.y;this.points[2].x=this.bbox.x+this.bbox.width;this.points[2].y=this.bbox.y+this.bbox.height;this.points[3].x=this.bbox.x;this.points[3].y=this.bbox.y+this.bbox.height;this.points[4].x=this.bbox.x;this.points[4].y=this.bbox.y;return this}};extend(CAAT.ShapePath,CAAT.PathSegment)})();(function(){CAAT.Path=function(){CAAT.Path.superclass.constructor.call(this);this.newPosition=new CAAT.Point(0,0,0);this.pathSegments=[];this.behaviorList=[];this.matrix=new CAAT.Matrix();this.tmpMatrix=new CAAT.Matrix();return this};CAAT.Path.prototype={pathSegments:null,pathSegmentDurationTime:null,pathSegmentStartTime:null,newPosition:null,pathLength:-1,beginPathX:-1,beginPathY:-1,trackPathX:-1,trackPathY:-1,ax:-1,ay:-1,point:[],interactive:true,behaviorList:null,rb_angle:0,rb_rotateAnchorX:0,rb_rotateAnchorY:0,sb_scaleX:1,sb_scaleY:1,sb_scaleAnchorX:0,sb_scaleAnchorY:0,tb_x:0,tb_y:0,matrix:null,tmpMatrix:null,pathPoints:null,width:0,height:0,applyAsPath:function(a){a.beginPath();a.globalCompositeOperation="source-out";a.moveTo(this.getFirstPathSegment().startCurvePosition().x,this.getFirstPathSegment().startCurvePosition().y);for(var b=0;b<this.pathSegments.length;b++){this.pathSegments[b].applyAsPath(a)}a.globalCompositeOperation="source-over";return this},setInteractive:function(a){this.interactive=a;return this},getFirstPathSegment:function(){return this.pathSegments.length?this.pathSegments[0]:null},getLastPathSegment:function(){return this.pathSegments.length?this.pathSegments[this.pathSegments.length-1]:null},endCurvePosition:function(){if(this.pathSegments.length){return this.pathSegments[this.pathSegments.length-1].endCurvePosition()}else{return new CAAT.Point().set(this.beginPathX,this.beginPathY)}},startCurvePosition:function(){return this.pathSegments[0].startCurvePosition()},getCurrentPathSegment:function(){return this.pathSegments[this.pathSegments.length-1]},setLinear:function(b,d,a,c){this.beginPath(b,d);this.addLineTo(a,c);this.endPath();return this},setQuadric:function(d,f,b,e,a,c){this.beginPath(d,f);this.addQuadricTo(b,e,a,c);this.endPath();return this},setCubic:function(f,h,d,g,b,e,a,c){this.beginPath(f,h);this.addCubicTo(d,g,b,e,a,c);this.endPath();return this},setRectangle:function(b,d,a,c){this.beginPath(b,d);this.addRectangleTo(a,c);this.endPath();return this},addSegment:function(a){a.setParent(this);this.pathSegments.push(a);return this},addRectangleTo:function(c,d,a,b){var e=new CAAT.ShapePath();e.setPoints([this.endCurvePosition(),new CAAT.Point().set(c,d)]);e.setClockWise(a);e.setColor(b);e.setParent(this);this.pathSegments.push(e);return this},addQuadricTo:function(d,f,b,e,a){var g=new CAAT.Bezier();g.setPoints([this.endCurvePosition(),new CAAT.Point().set(d,f),new CAAT.Point().set(b,e)]);this.trackPathX=b;this.trackPathY=e;var c=new CAAT.CurvePath().setColor(a).setParent(this);c.curve=g;this.pathSegments.push(c);return this},addCubicTo:function(h,c,g,b,f,a,e){var d=new CAAT.Bezier();d.setPoints([this.endCurvePosition(),new CAAT.Point().set(h,c),new CAAT.Point().set(g,b),new CAAT.Point().set(f,a)]);this.trackPathX=f;this.trackPathY=a;var i=new CAAT.CurvePath().setColor(e).setParent(this);i.curve=d;this.pathSegments.push(i);return this},addCatmullTo:function(h,c,g,b,f,a,e){var d=new CAAT.CatmullRom().setColor(e);d.setCurve(this.trackPathX,this.trackPathY,h,c,g,b,f,a);this.trackPathX=f;this.trackPathY=a;var i=new CAAT.CurvePath().setParent(this);i.curve=d;this.pathSegments.push(i);return this},addLineTo:function(c,d,a){var b=new CAAT.LinearPath().setColor(a);b.setPoints([this.endCurvePosition(),new CAAT.Point().set(c,d)]);b.setParent(this);this.trackPathX=c;this.trackPathY=d;this.pathSegments.push(b);return this},beginPath:function(a,b){this.trackPathX=a;this.trackPathY=b;this.beginPathX=a;this.beginPathY=b;return this},closePath:function(){this.getLastPathSegment().setPoint(this.getFirstPathSegment().startCurvePosition(),this.getLastPathSegment().numControlPoints()-1);this.trackPathX=this.beginPathX;this.trackPathY=this.beginPathY;this.endPath();return this},endPath:function(){this.pathSegmentStartTime=[];this.pathSegmentDurationTime=[];this.updatePath();return this},getPosition:function(c){if(c>1||c<0){c%=1}if(c<0){c=1+c}for(var a=0;a<this.pathSegments.length;a++){if(this.pathSegmentStartTime[a]<=c&&c<=this.pathSegmentStartTime[a]+this.pathSegmentDurationTime[a]){c=this.pathSegmentDurationTime[a]?(c-this.pathSegmentStartTime[a])/this.pathSegmentDurationTime[a]:0;var b=this.pathSegments[a].getPosition(c);this.newPosition.x=b.x;this.newPosition.y=b.y;break}}return this.newPosition},getPositionFromLength:function(c){c%=this.getLength();if(c<0){c+=this.getLength()}var b=0;for(var a=0;a<this.pathSegments.length;a++){if(b<=c&&c<=this.pathSegments[a].getLength()+b){c-=b;var d=this.pathSegments[a].getPositionFromLength(c);this.newPosition.x=d.x;this.newPosition.y=d.y;break}b+=this.pathSegments[a].getLength()}return this.newPosition},paint:function(a){for(var b=0;b<this.pathSegments.length;b++){this.pathSegments[b].paint(a,this.interactive)}},release:function(){this.ax=-1;this.ay=-1},getNumSegments:function(){return this.pathSegments.length},getSegment:function(a){return this.pathSegments[a]},numControlPoints:function(){return this.points.length},getControlPoint:function(a){return this.points[a]},updatePath:function(a){var c,b;this.length=0;this.bbox.setEmpty();this.points=[];for(c=0;c<this.pathSegments.length;c++){this.pathSegments[c].updatePath(a);this.length+=this.pathSegments[c].getLength();this.bbox.unionRectangle(this.pathSegments[c].bbox);for(b=0;b<this.pathSegments[c].numControlPoints();b++){this.points.push(this.pathSegments[c].getControlPoint(b))}}this.width=this.bbox.width;this.height=this.bbox.height;this.pathSegmentStartTime=[];this.pathSegmentDurationTime=[];var c;for(c=0;c<this.pathSegments.length;c++){this.pathSegmentStartTime.push(0);this.pathSegmentDurationTime.push(0)}for(c=0;c<this.pathSegments.length;c++){this.pathSegmentDurationTime[c]=this.getLength()?this.pathSegments[c].getLength()/this.getLength():0;if(c>0){this.pathSegmentStartTime[c]=this.pathSegmentStartTime[c-1]+this.pathSegmentDurationTime[c-1]}else{this.pathSegmentStartTime[0]=0}this.pathSegments[c].endPath()}return this},press:function(b,f){if(!this.interactive){return}var e=CAAT.Curve.prototype.HANDLE_SIZE/2;for(var d=0;d<this.pathSegments.length;d++){for(var c=0;c<this.pathSegments[d].numControlPoints();c++){var a=this.pathSegments[d].getControlPoint(c);if(b>=a.x-e&&f>=a.y-e&&b<a.x+e&&f<a.y+e){this.point=a;return}}}this.point=null},drag:function(a,b){if(!this.interactive){return}if(null===this.point){return}if(-1===this.ax||-1===this.ay){this.ax=a;this.ay=b}this.point.x+=a-this.ax;this.point.y+=b-this.ay;this.ax=a;this.ay=b;this.updatePath(this.point)},getContour:function(c){var b=[];for(var a=0;a<=c;a++){b.push(new CAAT.Point().set(a/c,this.getPosition(a/c).y,0))}return b},setPoints:function(b){if(this.points.length===b.length){for(var a=0;a<b.length;a++){this.points[a].x=b[a].x;this.points[a].y=b[a].y}}return this},setPoint:function(a,b){if(b>=0&&b<this.points.length){this.points[b].x=a.x;this.points[b].y=a.y}return this},emptyBehaviorList:function(){this.behaviorList=[];return this},extractPathPoints:function(){if(!this.pathPoints){var a;this.pathPoints=[];for(a=0;a<this.numControlPoints();a++){this.pathPoints.push(this.getControlPoint(a).clone())}}return this},addBehavior:function(a){this.behaviorList.push(a);this.extractPathPoints();return this},removeBehaviour:function(a){var b=this.behaviorList.length-1;while(b){if(this.behaviorList[b]===a){this.behaviorList.splice(b,1);return this}}return this},removeBehaviorById:function(b){for(var a=0;a<this.behaviorList.length;a++){if(this.behaviorList[a].id===b){this.behaviorList.splice(a,1)}}return this},applyBehaviors:function(b){if(this.behaviorList.length){for(var a=0;a<this.behaviorList.length;a++){this.behaviorList[a].apply(b,this)}this.setATMatrix();for(a=0;a<this.numControlPoints();a++){this.setPoint(this.matrix.transformCoord(this.pathPoints[a].clone()),a)}}return this},setATMatrix:function(){this.matrix.identity();var a=this.tmpMatrix.identity();var b=this.matrix.matrix;b[2]+=this.tb_x;b[5]+=this.tb_y;if(this.rb_angle){b[2]+=b[0]*this.rb_rotateAnchorX+b[1]*this.rb_rotateAnchorY;b[5]+=b[3]*this.rb_rotateAnchorX+b[4]*this.rb_rotateAnchorY;this.matrix.multiply(a.setRotation(this.rb_angle));b[2]+=-b[0]*this.rb_rotateAnchorX-b[1]*this.rb_rotateAnchorY;b[5]+=-b[3]*this.rb_rotateAnchorX-b[4]*this.rb_rotateAnchorY}if(this.sb_scaleX!=1||this.sb_scaleY!=1&&(this.sb_scaleAnchorX||this.sb_scaleAnchorY)){b[2]+=b[0]*this.sb_scaleAnchorX+b[1]*this.sb_scaleAnchorY;b[5]+=b[3]*this.sb_scaleAnchorX+b[4]*this.sb_scaleAnchorY;b[0]=b[0]*this.sb_scaleX;b[1]=b[1]*this.sb_scaleY;b[3]=b[3]*this.sb_scaleX;b[4]=b[4]*this.sb_scaleY;b[2]+=-b[0]*this.sb_scaleAnchorX-b[1]*this.sb_scaleAnchorY;b[5]+=-b[3]*this.sb_scaleAnchorX-b[4]*this.sb_scaleAnchorY}return this},setRotationAnchored:function(c,b,a){this.rb_angle=c;this.rb_rotateAnchorX=b+this.bbox.x;this.rb_rotateAnchorY=a+this.bbox.y;return this},setScaleAnchored:function(b,a,d,c){this.sb_scaleX=b;this.sb_scaleAnchorX=d+this.bbox.x;this.sb_scaleY=a;this.sb_scaleAnchorY=c+this.bbox.y;return this},setLocation:function(a,b){this.tb_x=a;this.tb_y=b;return this}};extend(CAAT.Path,CAAT.PathSegment,null)})();(function(){CAAT.PathActor=function(){CAAT.PathActor.superclass.constructor.call(this);return this};CAAT.PathActor.prototype={path:null,pathBoundingRectangle:null,bOutline:false,outlineColor:"black",getPath:function(){return this.path},setPath:function(a){this.path=a;this.pathBoundingRectangle=a.getBoundingBox();return this},paint:function(a,c){var b=a.crc;b.strokeStyle="black";this.path.paint(a);if(this.bOutline){b.strokeStyle=this.outlineColor;b.strokeRect(0,0,this.width,this.height)}},showBoundingBox:function(a,b){this.bOutline=a;if(a&&b){this.outlineColor=b}},setInteractive:function(a){if(this.path){this.path.setInteractive(a)}return this},mouseDrag:function(a){this.path.drag(a.point.x,a.point.y)},mouseDown:function(a){this.path.press(a.point.x,a.point.y)},mouseUp:function(a){this.path.release()}};extend(CAAT.PathActor,CAAT.ActorContainer,null)})();(function(){CAAT.ImageProcessor=function(){return this};CAAT.ImageProcessor.prototype={canvas:null,ctx:null,width:0,height:0,imageData:null,bufferImage:null,grabPixels:function(d){var b=document.createElement("canvas");if(b!==null){b.width=d.width;b.height=d.height;var a=b.getContext("2d");a.drawImage(d,0,0);try{var f=a.getImageData(0,0,b.width,b.height);return f}catch(c){CAAT.log("error pixelgrabbing.",d);return null}}return null},makeArray:function(d,e){var b=[];for(var c=0;c<d;c++){b.push(e)}return b},makeArray2D:function(d,e,f){var b=[];for(var c=0;c<d;c++){b.push(this.makeArray(e,f))}return b},initialize:function(b,a){this.width=b;this.height=a;this.canvas=document.createElement("canvas");if(this.canvas!==null){this.canvas.width=b;this.canvas.height=a;this.ctx=this.canvas.getContext("2d");this.imageData=this.ctx.getImageData(0,0,b,a);this.bufferImage=this.imageData.data}return this},clear:function(h,f,c,d){if(null===this.imageData){return this}var j=this.imageData.data;for(var e=0;e<this.width*this.height;e++){j[e*4+0]=h;j[e*4+1]=f;j[e*4+2]=c;j[e*4+3]=d}return this},getImageData:function(){return this.ctx.getImageData(0,0,this.width,this.height)},apply:function(a,b){if(null!==this.imageData){this.ctx.putImageData(this.imageData,0,0)}return this},getCanvas:function(){return this.canvas},createPattern:function(a){return this.ctx.createPattern(this.canvas,a?a:"repeat")},paint:function(b,c){if(null!==this.canvas){var a=b.ctx;a.drawImage(this.getCanvas(),0,0)}}}})();(function(){CAAT.IMPlasma=function(){CAAT.IMPlasma.superclass.constructor.call(this);return this};CAAT.IMPlasma.prototype={wavetable:null,m_colorMap:null,spd1:1,spd2:2,spd3:3,spd4:4,pos1:0,pos2:0,pos3:0,pos4:0,tpos1:0,tpos2:0,tpos3:0,tpos4:0,m_colorMapSize:256,i1:0,i2:0,i3:0,i4:0,b1:false,b2:false,b3:false,b4:false,color:[4294967295,4294902015,4294967040,4278255360,4294901760,4278190335,4278190080],initialize:function(d,b,c){CAAT.IMPlasma.superclass.initialize.call(this,d,b);this.wavetable=[];for(var a=0;a<256;a++){this.wavetable.push(Math.floor(32*(1+Math.cos(a*2*Math.PI/256))))}this.pos1=Math.floor(255*Math.random());this.pos2=Math.floor(255*Math.random());this.pos3=Math.floor(255*Math.random());this.pos4=Math.floor(255*Math.random());this.m_colorMap=CAAT.Color.prototype.makeRGBColorRamp(c!==null?c:this.color,256,CAAT.Color.prototype.RampEnumeration.RAMP_CHANNEL_RGBA_ARRAY);this.setB();return this},setB:function(){this.b1=Math.random()>0.5;this.b2=Math.random()>0.5;this.b3=Math.random()>0.5;this.b4=Math.random()>0.5;this.spd1=Math.floor((Math.random()*3+1)*(Math.random()<0.5?1:-1));this.spd2=Math.floor((Math.random()*3+1)*(Math.random()<0.5?1:-1));this.spd3=Math.floor((Math.random()*3+1)*(Math.random()<0.5?1:-1));this.spd4=Math.floor((Math.random()*3+1)*(Math.random()<0.5?1:-1));this.i1=Math.floor((Math.random()*2.4+1)*(Math.random()<0.5?1:-1));this.i2=Math.floor((Math.random()*2.4+1)*(Math.random()<0.5?1:-1));this.i3=Math.floor((Math.random()*2.4+1)*(Math.random()<0.5?1:-1));this.i4=Math.floor((Math.random()*2.4+1)*(Math.random()<0.5?1:-1))},apply:function(b,e){var j=0;this.tpos1=this.pos1;this.tpos2=this.pos2;for(var i=0;i<this.height;i++){this.tpos3=this.pos3;this.tpos4=this.pos4;for(var h=0;h<this.width;h++){var f=this.tpos1+this.tpos2+this.tpos3;var d=this.tpos2+this.tpos3-this.tpos1;var c=this.tpos3+this.tpos4-this.tpos2;var a=this.tpos4+this.tpos1-this.tpos2;if(this.b1){f=-f}if(this.b2){d=-d}if(this.b3){c=-c}if(this.b4){a=-a}var g=Math.floor(this.wavetable[f&255]+this.wavetable[d&255]+this.wavetable[c&255]+this.wavetable[a&255]);this.bufferImage[j++]=this.m_colorMap[g][0];this.bufferImage[j++]=this.m_colorMap[g][1];this.bufferImage[j++]=this.m_colorMap[g][2];this.bufferImage[j++]=this.m_colorMap[g][3];this.tpos3+=this.i1;this.tpos3&=255;this.tpos4+=this.i2;this.tpos4&=255}this.tpos1+=this.i3;this.tpos1&=255;this.tpos2+=this.i4;this.tpos2&=255}this.pos1+=this.spd1;this.pos2-=this.spd2;this.pos3+=this.spd3;this.pos4-=this.spd4;this.pos1&=255;this.pos3&=255;this.pos2&=255;this.pos4&=255;return CAAT.IMPlasma.superclass.apply.call(this,b,e)}};extend(CAAT.IMPlasma,CAAT.ImageProcessor,null)})();(function(){CAAT.IMBump=function(){CAAT.IMBump.superclass.constructor.call(this);return this};CAAT.IMBump.prototype={m_avgX:null,m_avgY:null,m_tt:null,phong:null,m_radius:75,m_lightcolor:null,bcolor:false,lightPosition:[],prepareBump:function(d,g){var f,e;this.m_radius=(g?g:75);var a=this.grabPixels(d);this.m_tt=this.makeArray(this.height,0);for(f=0;f<this.height;f++){this.m_tt[f]=this.width*f}this.m_avgX=this.makeArray2D(this.height,this.width,0);this.m_avgY=this.makeArray2D(this.height,this.width,0);var c=this.makeArray2D(this.height,this.width,0);if(null===a){return}var b=a.data;for(f=0;f<this.height;f++){for(e=0;e<this.width;e++){var k=(f*this.width+e)*4;c[f][e]=b[k]+b[k+1]+b[k+2]}}c=this.soften(c);for(var l=1;l<this.width-1;l++){for(var h=1;h<this.height-1;h++){this.m_avgX[h][l]=Math.floor(c[h][l+1]-c[h][l-1]);this.m_avgY[h][l]=Math.floor(c[h+1][l]-c[h-1][l])}}c=null},soften:function(d){var b;var a=this.makeArray2D(this.height,this.width,0);for(var c=0;c<this.width;c++){for(var e=0;e<this.height;e++){b=(d[e][c]);b+=(d[(e+1)%this.height][c]);b+=(d[(e+this.height-1)%this.height][c]);b+=(d[e][(c+1)%this.width]);b+=(d[e][(c+this.width-1)%this.width]);b+=(d[(e+1)%this.height][(c+1)%this.width]);b+=(d[(e+this.height-1)%this.height][(c+this.width-1)%this.width]);b+=(d[(e+this.height-1)%this.height][(c+1)%this.width]);b+=(d[(e+1)%this.height][(c+this.width-1)%this.width]);b/=9;a[e][c]=b/3}}return a},calculatePhong:function(){this.phong=this.makeArray2D(this.m_radius,this.m_radius,0);var c,b,d;for(c=0;c<this.m_radius;c++){for(b=0;b<this.m_radius;b++){var a=b/this.m_radius;var e=c/this.m_radius;d=(1-Math.sqrt(a*a+e*e))*0.8;if(d<0){d=0}this.phong[c][b]=Math.floor(d*255)}}},drawColored:function(p){var u,t,s;for(u=0;u<this.height;u++){for(t=0;t<this.width;t++){var l=0;var w=0;var o=0;for(s=0;s<this.m_lightcolor.length;s++){var d=this.lightPosition[s].x;var a=this.lightPosition[s].y;var n=Math.floor(Math.abs(this.m_avgX[u][t]-t+d));var m=Math.floor(Math.abs(this.m_avgY[u][t]-u+a));if(n>=this.m_radius){n=this.m_radius-1}if(m>=this.m_radius){m=this.m_radius-1}var y=this.phong[n][m];var q=0;var v=0;var z=0;if(y>=0){q=(this.m_lightcolor[s][0]*y/128);v=(this.m_lightcolor[s][1]*y/128);z=(this.m_lightcolor[s][2]*y/128)}else{y=128+y;var h=(this.m_lightcolor[s][0]);var x=(this.m_lightcolor[s][1]);var e=(this.m_lightcolor[s][2]);q=Math.floor(h+(255-h)*y/128);v=Math.floor(x+(255-x)*y/128);z=Math.floor(e+(255-e)*y/128)}l+=q;w+=v;o+=z}if(l>255){l=255}if(w>255){w=255}if(o>255){o=255}var f=(t+this.m_tt[u])*4;p[f]=l;p[f+1]=w;p[f+2]=o;p[f+3]=255}}},setLightColors:function(b){this.m_lightcolor=b;this.lightPosition=[];for(var c=0;c<this.m_lightcolor.length;c++){var a=this.width*Math.random();var d=this.height*Math.random();this.lightPosition.push(new CAAT.Point().set(a,d))}return this},initialize:function(b,a){CAAT.IMBump.superclass.initialize.call(this,b.width,b.height);this.setLightColors([[255,128,0],[0,0,255]]);this.prepareBump(b,a);this.calculatePhong();return this},setLightPosition:function(b,a,c){this.lightPosition[b].set(a,c);return this},apply:function(a,b){this.drawColored(this.bufferImage);return CAAT.IMBump.superclass.apply.call(this,a,b)}};extend(CAAT.IMBump,CAAT.ImageProcessor,null)})();(function(){CAAT.IMRotoZoom=function(){CAAT.IMRotoZoom.superclass.constructor.call(this);return this};CAAT.IMRotoZoom.prototype={m_alignv:1,m_alignh:1,distortion:2,mask:0,shift:0,sourceImageData:null,initialize:function(b,a,c){CAAT.IMRotoZoom.superclass.initialize.call(this,b,a);this.clear(255,128,0,255);this.sourceImageData=this.grabPixels(c);if(null!==this.sourceImageData){switch(this.sourceImageData.width){case 1024:this.mask=1023;this.shift=10;break;case 512:this.mask=511;this.shift=9;break;case 256:this.mask=255;this.shift=8;break;case 128:this.mask=127;this.shift=7;break;case 64:this.mask=63;this.shift=6;break;case 32:this.mask=31;this.shift=5;break;case 16:this.mask=15;this.shift=4;break;case 8:this.mask=7;this.shift=3;break}}this.setCenter();return this},rotoZoom:function(d,f){var l=new Date().getTime();var u=Math.PI*2*Math.cos(l*0.0001);var b=600+550*Math.sin(l*0.0002);var o=this.distortion;var v=0;var t=Math.floor(Math.cos(u)*b);var s=Math.floor(Math.sin(u)*b);var a=0,w=0;switch(this.m_alignh){case 0:a=0;break;case 1:a=(this.height>>1);break;case 2:a=this.height-1;break}switch(this.m_alignv){case 0:w=0;break;case 1:w=(this.width>>1);break;case 2:w=this.width-1;break}var r=(((this.width>>1)<<8)-t*w+s*a)&65535;var q=(((this.height>>1)<<8)-s*w-t*a)&65535;var g=this.sourceImageData.width;var k=this.sourceImageData.height;var n=this.sourceImageData.data;while(v<this.width*this.height*4){var e=r;var c=q;for(var p=0;p<this.width;p++){var h=((c>>this.shift)&this.mask)*g+((e>>this.shift)&this.mask);h<<=2;this.bufferImage[v++]=n[h++];this.bufferImage[v++]=n[h++];this.bufferImage[v++]=n[h++];this.bufferImage[v++]=n[h++];e+=t;c+=s}o+=this.distortion;r-=s;q+=t-o}},apply:function(a,b){if(null!==this.sourceImageData){this.rotoZoom(a,b)}return CAAT.IMRotoZoom.superclass.apply.call(this,a,b)},setCenter:function(){var a=Math.random();if(a<0.33){this.m_alignv=0}else{if(a<0.66){this.m_alignv=1}else{this.m_alignv=2}}a=Math.random();if(a<0.33){this.m_alignh=0}else{if(a<0.66){this.m_alignh=1}else{this.m_alignh=2}}}};extend(CAAT.IMRotoZoom,CAAT.ImageProcessor,null)})();(function(){CAAT.Program=function(a){this.gl=a;return this};CAAT.Program.prototype={shaderProgram:null,gl:null,setAlpha:function(a){},getShader:function(d,a,c){var b;if(a==="x-shader/x-fragment"){b=d.createShader(d.FRAGMENT_SHADER)}else{if(a==="x-shader/x-vertex"){b=d.createShader(d.VERTEX_SHADER)}else{return null}}d.shaderSource(b,c);d.compileShader(b);if(!d.getShaderParameter(b,d.COMPILE_STATUS)){alert(d.getShaderInfoLog(b));return null}return b},getDomShader:function(e,f){var b=document.getElementById(f);if(!b){return null}var d="";var a=b.firstChild;while(a){if(a.nodeType===3){d+=a.textContent}a=a.nextSibling}var c;if(b.type==="x-shader/x-fragment"){c=e.createShader(e.FRAGMENT_SHADER)}else{if(b.type==="x-shader/x-vertex"){c=e.createShader(e.VERTEX_SHADER)}else{return null}}e.shaderSource(c,d);e.compileShader(c);if(!e.getShaderParameter(c,e.COMPILE_STATUS)){alert(e.getShaderInfoLog(c));return null}return c},initialize:function(){return this},getFragmentShader:function(){return null},getVertexShader:function(){return null},create:function(){var a=this.gl;this.shaderProgram=a.createProgram();a.attachShader(this.shaderProgram,this.getVertexShader());a.attachShader(this.shaderProgram,this.getFragmentShader());a.linkProgram(this.shaderProgram);a.useProgram(this.shaderProgram);return this},setMatrixUniform:function(a){this.gl.uniformMatrix4fv(this.shaderProgram.pMatrixUniform,false,new Float32Array(a.flatten()))},useProgram:function(){this.gl.useProgram(this.shaderProgram);return this}}})();(function(){CAAT.ColorProgram=function(a){CAAT.ColorProgram.superclass.constructor.call(this,a);return this};CAAT.ColorProgram.prototype={colorBuffer:null,vertexPositionBuffer:null,vertexPositionArray:null,getFragmentShader:function(){return this.getShader(this.gl,"x-shader/x-fragment","#ifdef GL_ES \nprecision highp float; \n#endif \nvarying vec4 color; \nvoid main(void) { \n  gl_FragColor = color;\n}\n")},getVertexShader:function(){return this.getShader(this.gl,"x-shader/x-vertex","attribute vec3 aVertexPosition; \nattribute vec4 aColor; \nuniform mat4 uPMatrix; \nvarying vec4 color; \nvoid main(void) { \ngl_Position = uPMatrix * vec4(aVertexPosition, 1.0); \ncolor= aColor; \n}\n")},initialize:function(){this.shaderProgram.vertexPositionAttribute=this.gl.getAttribLocation(this.shaderProgram,"aVertexPosition");this.gl.enableVertexAttribArray(this.shaderProgram.vertexPositionAttribute);this.shaderProgram.vertexColorAttribute=this.gl.getAttribLocation(this.shaderProgram,"aColor");this.gl.enableVertexAttribArray(this.shaderProgram.vertexColorAttribute);this.shaderProgram.pMatrixUniform=this.gl.getUniformLocation(this.shaderProgram,"uPMatrix");this.useProgram();this.colorBuffer=this.gl.createBuffer();this.setColor([1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]);var a=4096,b;this.vertexPositionBuffer=this.gl.createBuffer();this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexPositionBuffer);this.vertexPositionArray=new Float32Array(a*12);this.gl.bufferData(this.gl.ARRAY_BUFFER,this.vertexPositionArray,this.gl.DYNAMIC_DRAW);this.gl.vertexAttribPointer(this.shaderProgram.vertexPositionAttribute,3,this.gl.FLOAT,false,0,0);return CAAT.ColorProgram.superclass.initialize.call(this)},setColor:function(a){this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.colorBuffer);this.gl.bufferData(this.gl.ARRAY_BUFFER,new Float32Array(a),this.gl.STATIC_DRAW);this.gl.vertexAttribPointer(this.shaderProgram.vertexColorAttribute,this.colorBuffer,this.gl.FLOAT,false,0,0)}};extend(CAAT.ColorProgram,CAAT.Program,null)})();(function(){CAAT.TextureProgram=function(a){CAAT.TextureProgram.superclass.constructor.call(this,a);return this};CAAT.TextureProgram.prototype={vertexPositionBuffer:null,vertexPositionArray:null,vertexUVBuffer:null,vertexUVArray:null,vertexIndexBuffer:null,linesBuffer:null,prevAlpha:-1,prevR:-1,prevG:-1,prevB:-1,prevA:-1,prevTexture:null,getFragmentShader:function(){return this.getShader(this.gl,"x-shader/x-fragment","#ifdef GL_ES \nprecision highp float; \n#endif \nvarying vec2 vTextureCoord; \nuniform sampler2D uSampler; \nuniform float alpha; \nuniform bool uUseColor;\nuniform vec4 uColor;\nvoid main(void) { \nif ( uUseColor ) {\n  gl_FragColor= vec4(uColor.rgb, uColor.a*alpha);\n} else { \n  vec4 textureColor= texture2D(uSampler, vec2(vTextureCoord)); \n  gl_FragColor = vec4(textureColor.rgb, textureColor.a * alpha); \n}\n}\n")},getVertexShader:function(){return this.getShader(this.gl,"x-shader/x-vertex","attribute vec3 aVertexPosition; \nattribute vec2 aTextureCoord; \nuniform mat4 uPMatrix; \nvarying vec2 vTextureCoord; \nvoid main(void) { \ngl_Position = uPMatrix * vec4(aVertexPosition, 1.0); \nvTextureCoord = aTextureCoord;\n}\n")},useProgram:function(){CAAT.TextureProgram.superclass.useProgram.call(this);this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexPositionBuffer);this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexUVBuffer);this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER,this.vertexIndexBuffer)},initialize:function(){var d;this.linesBuffer=this.gl.createBuffer();this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER,this.linesBuffer);var b=[];for(d=0;d<1024;d++){b[d]=d}this.linesBufferArray=new Uint16Array(b);this.gl.bufferData(this.gl.ELEMENT_ARRAY_BUFFER,this.linesBufferArray,this.gl.DYNAMIC_DRAW);this.shaderProgram.vertexPositionAttribute=this.gl.getAttribLocation(this.shaderProgram,"aVertexPosition");this.gl.enableVertexAttribArray(this.shaderProgram.vertexPositionAttribute);this.shaderProgram.textureCoordAttribute=this.gl.getAttribLocation(this.shaderProgram,"aTextureCoord");this.gl.enableVertexAttribArray(this.shaderProgram.textureCoordAttribute);this.shaderProgram.pMatrixUniform=this.gl.getUniformLocation(this.shaderProgram,"uPMatrix");this.shaderProgram.samplerUniform=this.gl.getUniformLocation(this.shaderProgram,"uSampler");this.shaderProgram.alphaUniform=this.gl.getUniformLocation(this.shaderProgram,"alpha");this.shaderProgram.useColor=this.gl.getUniformLocation(this.shaderProgram,"uUseColor");this.shaderProgram.color=this.gl.getUniformLocation(this.shaderProgram,"uColor");this.setAlpha(1);this.setUseColor(false);var a=4096;this.vertexPositionBuffer=this.gl.createBuffer();this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexPositionBuffer);this.vertexPositionArray=new Float32Array(a*12);this.gl.bufferData(this.gl.ARRAY_BUFFER,this.vertexPositionArray,this.gl.DYNAMIC_DRAW);this.gl.vertexAttribPointer(this.shaderProgram.vertexPositionAttribute,3,this.gl.FLOAT,false,0,0);this.vertexUVBuffer=this.gl.createBuffer();this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexUVBuffer);this.vertexUVArray=new Float32Array(a*8);this.gl.bufferData(this.gl.ARRAY_BUFFER,this.vertexUVArray,this.gl.DYNAMIC_DRAW);this.gl.vertexAttribPointer(this.shaderProgram.textureCoordAttribute,2,this.gl.FLOAT,false,0,0);this.vertexIndexBuffer=this.gl.createBuffer();this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER,this.vertexIndexBuffer);var c=[];for(d=0;d<a;d++){c.push(0+d*4);c.push(1+d*4);c.push(2+d*4);c.push(0+d*4);c.push(2+d*4);c.push(3+d*4)}this.gl.bufferData(this.gl.ELEMENT_ARRAY_BUFFER,new Uint16Array(c),this.gl.STATIC_DRAW);return CAAT.TextureProgram.superclass.initialize.call(this)},setUseColor:function(e,h,f,c,d){this.gl.uniform1i(this.shaderProgram.useColor,e?1:0);if(e){if(this.prevA!==d||this.prevR!==h||this.prevG!==f||this.prevB!==c){this.gl.uniform4f(this.shaderProgram.color,h,f,c,d);this.prevA=d;this.prevR=h;this.prevG=f;this.prevB=c}}},setTexture:function(a){if(this.prevTexture!==a){var b=this.gl;b.activeTexture(b.TEXTURE0);b.bindTexture(b.TEXTURE_2D,a);b.uniform1i(this.shaderProgram.samplerUniform,0);this.prevTexture=a}return this},updateVertexBuffer:function(a){this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexPositionBuffer);this.gl.bufferSubData(this.gl.ARRAY_BUFFER,0,a);return this},updateUVBuffer:function(a){this.gl.bindBuffer(this.gl.ARRAY_BUFFER,this.vertexUVBuffer);this.gl.bufferSubData(this.gl.ARRAY_BUFFER,0,a);return this},setAlpha:function(a){if(this.prevAlpha!==a){this.gl.uniform1f(this.shaderProgram.alphaUniform,a);this.prevAlpha=a}return this},drawLines:function(k,f,i,h,d,e,c){var j=this.gl;this.setAlpha(e);j.bindBuffer(j.ELEMENT_ARRAY_BUFFER,this.linesBuffer);j.lineWidth(c);this.updateVertexBuffer(k);this.setUseColor(true,i,h,d,1);j.drawElements(j.LINES,f,j.UNSIGNED_SHORT,0);this.setAlpha(1);this.setUseColor(false);j.bindBuffer(j.ELEMENT_ARRAY_BUFFER,this.vertexIndexBuffer)},drawPolylines:function(f,h,j,i,d,e,c){var k=this.gl;k.bindBuffer(k.ELEMENT_ARRAY_BUFFER,this.linesBuffer);k.lineWidth(c);this.setAlpha(e);this.updateVertexBuffer(f);this.setUseColor(true,j,i,d,1);k.drawElements(k.LINE_STRIP,h,k.UNSIGNED_SHORT,0);this.setAlpha(1);this.setUseColor(false);k.bindBuffer(k.ELEMENT_ARRAY_BUFFER,this.vertexIndexBuffer)}};extend(CAAT.TextureProgram,CAAT.Program,null)})();function makePerspective(d,a,i,g,f){var c=i*Math.tan(d*Math.PI/360);var h=-c;var b=h*a;var e=c*a;return makeFrustum(b,e,h,c,i,g,f)}function makeFrustum(h,l,b,k,m,j,i){var g=2*m/(l-h);var e=2*m/(k-b);var f=(l+h)/(l-h);var d=(k+b)/(k-b);var c=-(j+m)/(j-m);var a=-2*j*m/(j-m);return new CAAT.Matrix3().initWithMatrix([[g,0,f,-i/2],[0,-e,d,i/2],[0,0,c,a],[0,0,-1,0]])}function makeOrtho(b,h,a,g,i,f){var e=-(h+b)/(h-b);var d=-(g+a)/(g-a);var c=-(f+i)/(f-i);return new CAAT.Matrix3().initWithMatrix([[2/(h-b),0,0,e],[0,2/(g-a),0,d],[0,0,-2/(f-i),c],[0,0,0,1]])}(function(){CAAT.GLTextureElement=function(){return this};CAAT.GLTextureElement.prototype={inverted:false,image:null,u:0,v:0,glTexture:null}})();(function(){CAAT.GLTextureScan=function(a){this.freeChunks=[{position:0,size:a||1024}];return this};CAAT.GLTextureScan.prototype={freeChunks:null,findWhereFits:function(c){if(this.freeChunks.length===0){return[]}var a=[];var b;for(b=0;b<this.freeChunks.length;b++){var d=0;while(d+c<=this.freeChunks[b].size){a.push(d+this.freeChunks[b].position);d+=c}}return a},fits:function(a,c){var b=0;for(b=0;b<this.freeChunks.length;b++){var d=this.freeChunks[b];if(d.position<=a&&a+c<=d.position+d.size){return true}}return false},substract:function(a,f){var e=0;for(e=0;e<this.freeChunks.length;e++){var h=this.freeChunks[e];if(h.position<=a&&a+f<=h.position+h.size){var d=0;var b=0;var g=0;var c=0;d=h.position;b=a-h.position;g=a+f;c=h.position+h.size-g;this.freeChunks.splice(e,1);if(b>0){this.freeChunks.splice(e++,0,{position:d,size:b})}if(c>0){this.freeChunks.splice(e,0,{position:g,size:c})}return true}}return false},log:function(a){if(0===this.freeChunks.length){CAAT.log("index "+a+" empty")}else{var d="index "+a;for(var b=0;b<this.freeChunks.length;b++){var c=this.freeChunks[b];d+="["+c.position+","+c.size+"]"}CAAT.log(d)}}}})();(function(){CAAT.GLTextureScanMap=function(a,c){this.scanMapHeight=c;this.scanMapWidth=a;this.scanMap=[];for(var b=0;b<this.scanMapHeight;b++){this.scanMap.push(new CAAT.GLTextureScan(this.scanMapWidth))}return this};CAAT.GLTextureScanMap.prototype={scanMap:null,scanMapWidth:0,scanMapHeight:0,whereFitsChunk:function(a,k){if(a>this.width||k>this.height){return null}var d,c,b=0;while(b<=this.scanMapHeight-k){var e=null;var h=false;for(;b<=this.scanMapHeight-k;b++){e=this.scanMap[b].findWhereFits(a);if(null!==e&&e.length>0){h=true;break}}if(h){var f=Number.MAX_VALUE;for(c=0;c<e.length;c++){var g=true;for(d=b;d<b+k;d++){if(!this.scanMap[d].fits(e[c],a)){g=false;break}}if(g){return{x:e[c],y:b}}}b++}else{return null}}return null},substract:function(b,e,d,a){for(var c=0;c<a;c++){if(!this.scanMap[c+e].substract(b,d)){CAAT.log("Error: removing chunk ",d,a," at ",b,e)}}},log:function(){for(var a=0;a<this.scanMapHeight;a++){this.scanMap[a].log(a)}}}})();(function(){CAAT.GLTexturePage=function(a,b){this.width=a||1024;this.height=b||1024;this.images=[];return this};CAAT.GLTexturePage.prototype={width:1024,height:1024,gl:null,texture:null,allowImagesInvertion:false,padding:4,scan:null,images:null,criteria:"area",initialize:function(e){this.gl=e;this.texture=e.createTexture();e.bindTexture(e.TEXTURE_2D,this.texture);e.enable(e.BLEND);e.blendFunc(e.SRC_ALPHA,e.ONE_MINUS_SRC_ALPHA);var a=new Uint8Array(this.width*this.height*4);for(var d=0;d<4*this.width*this.height;){a[d++]=0;a[d++]=0;a[d++]=0;a[d++]=0}e.texImage2D(e.TEXTURE_2D,0,e.RGBA,this.width,this.height,0,e.RGBA,e.UNSIGNED_BYTE,a);e.enable(e.BLEND);for(var c=0;c<this.images.length;c++){var b=this.images[c];if(b.inverted){b=CAAT.modules.ImageUtil.prototype.rotate(b,-90)}e.texSubImage2D(e.TEXTURE_2D,0,this.images[c].__tx,this.images[c].__ty,e.RGBA,e.UNSIGNED_BYTE,b)}},create:function(d){var a=[];for(var c=0;c<d.length;c++){var b=d[c].image;a.push(b)}this.createFromImages(a)},clear:function(){this.createFromImages([])},update:function(d,c,b,a){this.allowImagesInvertion=d;this.padding=c;if(b<100){b=100}if(a<100){a=100}this.width=b;this.height=a;this.createFromImages(this.images)},createFromImages:function(a){var c;this.scan=new CAAT.GLTextureScanMap(this.width,this.height);this.images=[];if(this.allowImagesInvertion){for(c=0;c<a.length;c++){a[c].inverted=this.allowImagesInvertion&&a[c].height<a[c].width}}var d=this;a.sort(function(g,f){var h=g.width*g.height;var e=f.width*f.height;if(d.criteria==="width"){return g.width<f.width?1:g.width>f.width?-1:0}else{if(d.criteria==="height"){return g.height<f.height?1:g.height>f.height?-1:0}}return h<e?1:h>e?-1:0});for(c=0;c<a.length;c++){var b=a[c];this.packImage(b)}},addImage:function(b,c,a){this.allowImagesInvertion=c;this.padding=a;this.images.push(b);this.createFromImages(Array.prototype.slice.call(this.images))},endCreation:function(){var a=this.gl;a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MAG_FILTER,a.LINEAR);a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MIN_FILTER,a.LINEAR_MIPMAP_NEAREST);a.generateMipmap(a.TEXTURE_2D)},deletePage:function(){for(var a=0;a<this.images.length;a++){delete this.images[a].__texturePage;delete this.images[a].__u;delete this.images[a].__v}this.gl.deleteTexture(this.texture)},toCanvas:function(f,d){f=f||document.createElement("canvas");f.width=this.width;f.height=this.height;var e=f.getContext("2d");e.fillStyle="rgba(0,0,0,0)";e.fillRect(0,0,this.width,this.height);for(var c=0;c<this.images.length;c++){e.drawImage(!this.images[c].inverted?this.images[c]:CAAT.modules.ImageUtil.prototype.rotate(this.images[c],90),this.images[c].__tx,this.images[c].__ty);if(d){e.strokeStyle="red";e.strokeRect(this.images[c].__tx,this.images[c].__ty,this.images[c].__w,this.images[c].__h)}if(this.images[c].__gridC&&this.images[c].__gridR){for(var b=0;b<this.images[c].__gridR;b++){for(var a=0;a<this.images[c].__gridC;a++){e.strokeStyle="blue";e.strokeRect(this.images[c].__tx+a*this.images[c].__w/this.images[c].__gridC,this.images[c].__ty+b*this.images[c].__h/this.images[c].__gridR,this.images[c].__w/this.images[c].__gridC,this.images[c].__h/this.images[c].__gridR)}}}}if(d){e.strokeStyle="red";e.strokeRect(0,0,this.width,this.height)}return f},packImage:function(c){var g,b;if(c.inverted){g=c.height;b=c.width}else{g=c.width;b=c.height}var a=g;var f=b;var e;if(a&&this.padding){e=this.padding;if(a+e<=this.width){a+=e}}if(f&&this.padding){e=this.padding;if(f+e<=this.height){f+=e}}var d=this.scan.whereFitsChunk(a,f);if(null!==d){this.images.push(c);c.__tx=d.x;c.__ty=d.y;c.__u=d.x/this.width;c.__v=d.y/this.height;c.__u1=(d.x+g)/this.width;c.__v1=(d.y+b)/this.height;c.__texturePage=this;c.__w=g;c.__h=b;this.scan.substract(d.x,d.y,a,f)}else{CAAT.log("Imagen ",c.src," de tama�o ",c.width,c.height," no cabe.")}},changeHeuristic:function(a){this.criteria=a}}})();(function(){CAAT.GLTexturePageManager=function(){this.pages=[];return this};CAAT.GLTexturePageManager.prototype={pages:null,createPages:function(g,d,a,f){var b=false;while(!b){var e=new CAAT.GLTexturePage(d,a);e.create(f);e.initialize(g);e.endCreation();this.pages.push(e);b=true;for(var c=0;c<f.length;c++){if(!f[c].image.__texturePage){if(f[c].image.width<=d&&f[c].height<=a){b=false}break}}}},deletePages:function(){for(var a=0;a<this.pages.length;a++){this.pages[a].deletePage()}this.pages=null}}})();